on prepareSprite(me)
  functionDialogOff(me)
  exit
end

on startMeUp(me)
  put(member(myCastmember, myCast))
  sprite(the currentSpriteNum).name = member(myCastmember, myCast)
  activate(gDir, 0)
  dialogActive = 1
  put("starting up")
  currentCursor = "normal"
  currentSound = ""
  loopCount = 0
  rectList = [rect(161, 129, 247, 263), rect(279, 136, 340, 263), rect(371, 135, 443, 263), rect(465, 204, 521, 310)]
  exit
end

on closeMeDown(me)
  sprite(the currentSpriteNum).name = member("Dummy")
  activate(gDir, 1)
  dialogActive = 0
  exit
end

on exitFrame(me)
  if dialogActive then
    if currentCursor = "normal" then
      x = 1
      repeat while x <= count(rectList)
        if inside(point(the mouseH, the mouseV), getAt(rectList, x)) then
          sendSprite(115, #c_click)
          cursoRect = getAt(rectList, x)
          cursorNumber = x
          currentCursor = "click"
          addLoopObject(gDir, me)
          -- UNK_64 0
          if ERROR = 1 then
            soundToKick = "09d001v0"
          else
            -- UNK_64 0
            if ERROR = 2 then
              soundToKick = "09d002v0"
            else
              -- UNK_64 0
              if ERROR = 3 then
                soundToKick = "09d003v0"
              else
                -- UNK_64 0
                if ERROR = 4 then
                  soundToKick = "09d004v0"
                end if
              end if
            end if
          end if
          -- UNK_65 1
        end if
        x = 1 + x
      end repeat
      exit repeat
    end if
    if not inside(point(the mouseH, the mouseV), cursoRect) then
      sendSprite(115, #C_Standard)
      currentCursor = "normal"
      if soundToKick <> "" then
        stop(gSound, currentSound)
        deleteLoopObject(gDir, me)
        soundToKick = ""
      end if
    end if
  end if
  exit
end

on loop(me)
  loopCount = loopCount + 1
  if loopCount = 10 then
    currentSound = play(gSound, soundToKick, #EFFECT)
    deleteLoopObject(gDir, me)
    loopCount = 0
  end if
  exit
end

on mouseUp(me)
  if currentCursor = "click" then
    if soundToKick <> "" then
      stop(gSound, currentSound)
      deleteLoopObject(gDir, me)
      soundToKick = ""
    end if
    play(gSound, "SndMouseClick", #EFFECT)
    -- UNK_64 0
    if ERROR = "1" then
      thisMovie = chars(the movie, 1, 2)
      trash(gMulleGlobals.user.car)
      if thisMovie = "03" then
        n = getProp(gDir.spriteList, #CarStart)
        repeat while n <= getProp(gDir.spriteList, #CarStart) + 35
          if n <> getProp(gDir.spriteList, #CarStart) + 7 then
            sprite(n).name = "dummy"
          end if
          n = 1 + n
        end repeat
        updateStage()
      end if
      if gMulleGlobals.user.nrOfBuiltCars = 0 then
        list = [82, 133, 152]
      else
        if gMulleGlobals.user.nrOfBuiltCars = 1 then
          list = [82, 152]
        else
          if gMulleGlobals.user.nrOfBuiltCars = 2 then
            list = [82]
          else
            list = []
          end if
        end if
      end if
      n = 1
      repeat while n <= count(list)
        addPart(gMulleGlobals.user.car, getAt(list, n))
        n = 1 + n
      end repeat
      if thisMovie = "03" then
        n = getProp(gDir.spriteList, #JunkStart)
        repeat while n <= getProp(gDir.spriteList, #JunkStart) + 35
          sprite(n).name = "dummy"
          n = 1 + n
        end repeat
      end if
      n = 1
      repeat while n <= count(list)
        put("sendin id ", getAt(list, n))
        put("from login")
        removeJunkPart(gMulleGlobals.user, void(), getAt(list, n))
        n = 1 + n
      end repeat
      if thisMovie = "03" then
        sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk)
        sendSprite(getProp(gDir.spriteList, #CarStart), #drawCar)
        updateStage()
        if count(list) = 3 then
          sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #AfterTrash3)
        else
          if count(list) = 2 then
            sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #AfterTrash2)
          else
            if count(list) = 1 then
              sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #AfterTrash1)
            else
              if count(list) = 0 then
                sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #afterTrash0)
              end if
            end if
          end if
        end if
        put("cursorNumber ", cursorNumber)
        put("in dialog")
        functionDialogSwitch(me)
      else
        gMulleGlobals.WhereFrom = the movie.char[1..2]
        functionDialogSwitch(me)
        updateStage()
        go(1, "03")
      end if
    else
      -- UNK_64 0
      if ERROR = "2" then
        gMulleGlobals.WhereFrom = the movie.char[1..2]
        go("08")
      else
        -- UNK_64 0
        if ERROR = "3" then
          go("12")
        else
          -- UNK_64 0
          if ERROR = "4" then
            functionDialogSwitch(me)
          end if
        end if
      end if
    end if
    -- UNK_65 1
  end if
  exit
end

on functionDialogSwitch(me)
  if sprite(the currentSpriteNum).name = member(myCastmember, myCast) then
    put("startcall")
    cursorNumber = "0"
    closeMeDown(me)
  else
    startMeUp(me)
  end if
  exit
end

on functionDialogOff(me)
  sprite(the currentSpriteNum).visible = 0
  exit
end

on getPropertyDescriptionList()
  p_list = [#myCastmember:[#comment:"Which castmember:", #format:#string, #default:""], #myCast:[#comment:"of which cast:", #format:#string, #default:""]]
  return(p_list)
  exit
end