on new(me)
  objectType = #none
  ObjectId = 0
  InnerRadius = 0
  OuterRadius = 0
  customObject = ""
  DirResource = ""
  sounds = []
  FrameList = []
  setWhenDone = []
  checkFor = []
  ifFound = #none
  spriteInfo = []
  ancestor = 0
  Active = 1
  SPOver = 0
  SPUnder = 0
  myLoc = point(0, 0)
  optionalData = []
  canEnter = 1
  return(me)
  exit
end

on kill(me)
  return(0)
  exit
end

on init(me, theSprites, theLoc, theOptional, theCarLoc)
  SPOver = getAt(theSprites, 1)
  SPUnder = getAt(theSprites, 2)
  myLoc = theLoc
  optionalData = []
  tempDir = void()
  if listp(theOptional) then
    if count(theOptional) then
      optionalData = theOptional
      tempDir = getaProp(optionalData, #direction)
    end if
  end if
  if voidp(tempDir) then
    tempDir = 1
  end if
  if count(FrameList) then
    tempList = getaProp(FrameList, tempDir)
    if listp(tempList) then
      FrameList = tempList
    end if
  end if
  lookUp = 0
  if symbolp(ifFound) then
    if not ifFound = #none then
      lookUp = 1
    end if
  end if
  if lookUp then
    foundOne = 0
    n = 1
    repeat while n <= count(checkFor)
      tempProp = getPropAt(checkFor, n)
      tempVal = getAt(checkFor, n)
      if not listp(tempVal) then
        tempVal = [tempVal]
      end if
      tempVal = duplicate(tempVal)
      -- UNK_64 0
      if ERROR = #Cache then
        -- UNK_64 0
        -- UNK_64 0
        -- UNK_64 2
        repeat while ERROR <= ERROR
          -- UNK_64 2
          -- UNK_64 1
          index = getAt()
          if not getCacheProp(gMulleGlobals.user.car, index) = #NoProp then
            foundOne = 1
          else
          end if
        end repeat
        -- UNK_65 3
      else
        -- UNK_64 0
        if ERROR = #medals then
          -- UNK_64 0
          -- UNK_64 0
          -- UNK_64 2
          repeat while ERROR <= ERROR
            -- UNK_64 2
            -- UNK_64 1
            index = getAt()
            if getMedal(gMulleGlobals.user.car, index) then
              foundOne = 1
            else
            end if
          end repeat
          -- UNK_65 3
        else
          -- UNK_64 0
          if ERROR = #UserStuff then
            -- UNK_64 0
            -- UNK_64 0
            -- UNK_64 2
            repeat while ERROR <= ERROR
              -- UNK_64 2
              -- UNK_64 1
              index = getAt()
              if not getUserProp(gMulleGlobals.user, index) = #NoProp then
                foundOne = 1
              else
              end if
            end repeat
            -- UNK_65 3
          else
            -- UNK_64 0
            if ERROR = #missions then
              -- UNK_64 0
              -- UNK_64 0
              -- UNK_64 2
              repeat while ERROR <= ERROR
                -- UNK_64 2
                -- UNK_64 1
                index = getAt()
                if isMissionCompleted(gMulleGlobals.user, index) then
                  foundOne = 1
                else
                end if
              end repeat
              -- UNK_65 3
            else
              -- UNK_64 0
              if ERROR = #parts then
                foundOne = not getOnePart(me, #checkFor)
              end if
            end if
          end if
        end if
      end if
      -- UNK_65 1
      if foundOne then
      else
        n = 1 + n
      end if
    end repeat
    if foundOne then
      -- UNK_64 0
      if ERROR = #NoDisplay then
        return(0)
      else
        -- UNK_64 0
        if ERROR = #NoEnter then
          canEnter = 0
        end if
      end if
      -- UNK_65 1
    end if
  end if
  temp = getaProp(optionalData, #InnerRadius)
  if integerp(temp) then
    InnerRadius = temp
  end if
  temp = getaProp(optionalData, #OuterRadius)
  if integerp(temp) then
    OuterRadius = temp
  end if
  init(ancestor, theCarLoc)
  return(1)
  exit
end

on getOnePart(me, where)
  if where = #setWhenDone then
    tempVal = getaProp(setWhenDone, #parts)
  else
    tempVal = getaProp(checkFor, #parts)
  end if
  if not listp(tempVal) then
    tempVal = [tempVal]
  end if
  tempVal = duplicate(tempVal)
  if getPos(tempVal, #random) then
    tempRandomPart = 1
    deleteOne(tempVal, #random)
  else
    tempRandomPart = 0
  end if
  tempAvail = getCurrentlyAvailable(gMulleGlobals.externalParts, #Destinations)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if getPos(tempAvail, index) then
      return(index)
    end if
  end repeat
  -- UNK_65 3
  if tempRandomPart then
    tempAvail = getCurrentlyAvailable(gMulleGlobals.externalParts, #random)
    if count(tempAvail) then
      return(getAt(tempAvail, 1))
    end if
  end if
  return(0)
  exit
end

on getId(me)
  return(ObjectId)
  exit
end

on getCacheProp(me)
  return(getaProp(setWhenDone, #Cache))
  exit
end

on getOptionalData(me)
  return(optionalData)
  exit
end

on getGiftParts(me)
  return(getaProp(setWhenDone, #parts))
  exit
end

on getSetWhenDone(me, theWhat)
  if voidp(theWhat) then
    return(duplicate(setWhenDone))
  end if
  return(getaProp(setWhenDone, theWhat))
  exit
end

on getCheckFor(me, theWhat)
  if voidp(theWhat) then
    return(duplicate(checkFor))
  end if
  return(getaProp(checkFor, theWhat))
  exit
end

on getType(me)
  return(type)
  exit
end

on getLoc(me)
  return(myLoc)
  exit
end

on getSpritesInfo(me)
  return(spriteInfo)
  exit
end

on getInnerRadius(me)
  return(InnerRadius)
  exit
end

on getOuterRadius(me)
  return(OuterRadius)
  exit
end

on getDirResource(me)
  return(DirResource)
  exit
end

on getFrameList(me)
  return(FrameList)
  exit
end

on toList(me)
  return([ObjectId, type, InnerRadius, OuterRadius, customObject, DirResource, sounds, FrameList, setWhenDone, checkFor, ifFound])
  exit
end

on fromList(me, theid)
  memberName = "Object" & string(theid) & "DB"
  if sprite(0).number = -1 then
    return(0)
  end if
  objectList = value(member(memberName).text)
  ObjectId = getaProp(objectList, #ObjectId)
  type = getaProp(objectList, #type)
  InnerRadius = getaProp(objectList, #InnerRadius)
  OuterRadius = getaProp(objectList, #OuterRadius)
  customObject = getaProp(objectList, #customObject)
  DirResource = getaProp(objectList, #DirResource)
  sounds = getaProp(objectList, #sounds)
  FrameList = getaProp(objectList, #FrameList)
  setWhenDone = getaProp(objectList, #setWhenDone)
  checkFor = getaProp(objectList, #checkFor)
  ifFound = getaProp(objectList, #ifFound)
  spriteInfo = getaProp(objectList, #spriteInfo)
  if voidp(spriteInfo) then
    spriteInfo = [#Under:1]
  end if
  if not listp(checkFor) then
    checkFor = []
  end if
  if not listp(setWhenDone) then
    setWhenDone = []
  end if
  tempUseCustom = 0
  if stringp(customObject) then
    if length(customObject) then
      tempUseCustom = 1
      tempMemb = "Object" & customObject & "Script"
      if sprite(0).number > 0 then
        ancestor = new(script(tempMemb), me)
      else
        return(0)
      end if
    end if
  end if
  if tempUseCustom = 0 then
    ancestor = new(script("Destination"), me)
  end if
  return(1)
  exit
end