on getStartPile()
  return([2, 6, 12, 23, 29, 30, 47, 66, 90, 96, 112, 119, 121, 126, 131, 143, 153, 158, 178, 190, 203, 210, 211, 214, 215, 307])
  exit
end

on makerandomJunkParts()
  tempList = checkForNonMorphs()
  repeat while 1
    junkList = [#Pile1:[], #Pile2:[], #Pile3:[], #Pile4:[], #Pile5:[], #Pile6:[]]
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      partId = getAt()
      pile = symbol("Pile" & string(random(6)))
      tempLoc = setPartPosition(gMulleGlobals.junkPileHandlers, pile, partId)
      tempJunk = getProp(junkList, pile)
      addProp(tempJunk, partId, tempLoc)
    end repeat
    -- UNK_65 3
    max = 0
    min = count(tempList)
    n = 1
    repeat while n <= 6
      nr = count(getAt(junkList, n))
      if nr > max then
        max = nr
      end if
      if nr < min then
        min = nr
      end if
      n = 1 + n
    end repeat
    if max - min <= 10 then
    else
    end if
  end repeat
  put(max, min)
  put(junkList)
  exit
end

on leftOvers()
  startList = [1, 82, 133, 152]
  destParts = checkForDestParts()
  tempList = getStartPile()
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    part = getPart(gMulleGlobals.parts, index)
    tempMaster = getMaster(part)
    if tempMaster > 0 then
      index = tempMaster
    end if
    add(tempList, index)
  end repeat
  -- UNK_65 3
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    add(tempList, index)
  end repeat
  -- UNK_65 3
  total = checkForNonMorphs()
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    tempPos = getPos(total, partId)
    if tempPos then
      deleteAt(total, tempPos)
    else
      put("Wrong id:", partId)
    end if
  end repeat
  -- UNK_65 3
  tempList = getPlugReserved()
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    deleteOne(total, partId)
  end repeat
  -- UNK_65 3
  largePartsList = checkForNonMorphs([13, 14, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 35, 91, 119, 124, 126, 129, 134, 137, 146, 149, 154, 158, 168, 173, 174, 175, 177, 189, 191, 192, 193, 199, 208, 209, 210, 212, 215, 221, 227, 229, 233, 235, 251, 264, 278, 279, 281, 282, 283, 294, 295, 306])
  figgeList = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    tempPos = getPos(total, index)
    if tempPos then
      add(figgeList, index)
      deleteAt(total, tempPos)
    end if
  end repeat
  -- UNK_65 3
  put("For random:", total)
  put("For Figge:", figgeList)
  exit
end

on checkForDestParts()
  destParts = []
  tempList = value(member("ObjectsDB").text)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    temp = value(member("Object" & string(index) & "DB").text)
    xopo = getaProp(temp, #setWhenDone)
    if listp(xopo) then
      if count(xopo) then
        tempParts = getaProp(xopo, #parts)
        if listp(tempParts) then
          if getPos(tempParts, #random) then
            deleteOne(tempParts, #random)
          end if
          if count(tempParts) then
            -- UNK_64 0
            -- UNK_64 0
            -- UNK_64 2
            repeat while ERROR <= ERROR
              -- UNK_64 2
              -- UNK_64 1
              partId = getAt()
              part = getPart(gMulleGlobals.parts, partId)
              tempMaster = getMaster(part)
              if tempMaster > 0 then
                put("Warning: destpart is morph " & partId)
                partId = tempMaster
              end if
              add(destParts, partId)
            end repeat
            -- UNK_65 3
          end if
        end if
      end if
    end if
  end repeat
  -- UNK_65 3
  return(destParts)
  exit
end

on checkForNonMorphs(tempList)
  if listp(tempList) then
    n = 1
    repeat while n <= count(tempList)
      setAt(tempList, n, getPart(gMulleGlobals.parts, getAt(tempList, n)))
      n = 1 + n
    end repeat
    exit repeat
  end if
  tempList = gMulleGlobals.parts.partList
  resultList = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if objectp(index) then
      add(resultList, getId(index))
      tempMassa = getMaster(index)
      if integerp(tempMassa) then
        if tempMassa > 0 then
          deleteOne(resultList, getId(index))
        end if
      end if
    end if
  end repeat
  -- UNK_65 3
  return(resultList)
  exit
end

on checkForNonJunk()
  put(makerandomJunkParts(checkForNonMorphs()))
  exit
end

on fromIdToSound()
  parts = checkForNonMorphs()
  str = ""
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    sound = getDescription(part)
    str = str & string(partId) & ": " & sound.char[4..6] & "\r"
  end repeat
  -- UNK_65 3
  put(str)
  exit
end

on fromSoundToId()
  soundList = [65, 142, 120, 4, 82, 22, 135, 23, 97, 30, 24, 25, 92, 28, 108, 31, 121]
  soundList = [30]
  partList = checkForNonMorphs()
  convertList = []
  resultList = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    sound = value(getDescription(part).char[4..6])
    addProp(convertList, sound, partId)
  end repeat
  -- UNK_65 3
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    sound = getAt()
    temp = getaProp(convertList, sound)
    if temp then
      add(resultList, temp)
    else
      put("Missing! sound:", sound)
    end if
  end repeat
  -- UNK_65 3
  sort(resultList)
  put(resultList)
  sort(resultList)
  put("And sorted: " & resultList)
  exit
end

on checkForSoundDoubles()
  partList = checkForNonMorphs()
  convertList = []
  sort(convertList)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    sound = value(getDescription(part).char[4..6])
    found = getaProp(convertList, sound)
    if voidp(found) then
      addProp(convertList, sound, [partId])
    else
      add(found, partId)
      setProp(convertList, sound, found)
    end if
  end repeat
  -- UNK_65 3
  put("Sound: partIdList")
  n = 1
  repeat while n <= count(convertList)
    temp = getAt(convertList, n)
    if count(temp) > 1 then
      put(getPropAt(convertList, n) & ": " & string(temp))
    end if
    n = 1 + n
  end repeat
  exit
end

on DBsToFile()
  castToCheck = "CDData"
  file = new(xtra("FileIO"))
  if the machineType = 256 then
    delim = ":"
  else
    delim = "\\"
  end if
  path = displaySave(file, "Directory for output", "xxx")
  if length(path) = 0 then
    file = 0
    exit
  end if
  n = length(path)
  repeat while n >= 1
    if path.char[n] = delim then
      path = path.char[1..n]
    else
      n = 255 + n
    end if
  end repeat
  max = the number of castMembers
  n = 1
  repeat while n <= max
    if member(n, castToCheck).type = #field then
      tempName = member(n, castToCheck).name
      dbType = 0
      if tempName contains "part" and charToNum(tempName.char[5]) < 64 then
        dbType = #partId
        prefix = "20t"
      else
        if tempName.char[1..6] = "Object" and tempName.char[length(tempName)] = "B" then
          dbType = #ObjectId
          prefix = "31t"
        else
          if tempName.char[1..7] = "Mission" and tempName.char[length(tempName)] = "B" then
            dbType = #MissionId
            prefix = "50t"
          else
            if tempName.char[1..7] = "World" and tempName.char[length(tempName)] = "B" then
              dbType = #WorldId
              prefix = "32t"
            else
              if tempName.char[1..3] = "Map" and tempName.char[length(tempName)] = "B" then
                dbType = #MapId
                prefix = "30t"
              end if
            end if
          end if
        end if
      end if
      if symbolp(dbType) then
        tempList = value(member(n, castToCheck).text)
        id = getaProp(tempList, dbType)
        if dbType = #WorldId then
          name = prefix & string(id) & "v0.txt"
        else
          if id < 10 then
            zeros = "00"
          else
            if id < 100 then
              zeros = "0"
            else
              zeros = ""
            end if
          end if
          name = prefix & zeros & string(id) & "v0.txt"
        end if
        tempStr = ""
        m = 1
        repeat while m <= count(tempList)
          tempStr = tempStr & getPropAt(tempList, m) & ":" & getAt(tempList, m) & "\r" & numToChar(10)
          m = 1 + m
        end repeat
        createFile(file, path & name)
        openFile(file, path & name, 2)
        if status(file) = 0 then
          writeString(file, tempStr)
          closeFile(file)
        else
          alert("Problem writing file")
        end if
      end if
    end if
    n = 1 + n
  end repeat
  file = 0
  exit
end

on UserStuff()
  put(gMulleGlobals.user.ownStuff)
  exit
end

on getPlugReserved()
  tempList = [279, 280, 281, 282, 291, 31, 69, 5, 184, 289, 167, 300, 301, 302, 303, 304, 305]
  return(includeMorphs(tempList))
  exit
end

on includeMorphs(tempList)
  result = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    part = getPart(gMulleGlobals.parts, index)
    if objectp(part) then
      temp = getMorphList(part)
      add(result, index)
      if listp(temp) then
        -- UNK_64 0
        -- UNK_64 0
        -- UNK_64 2
        repeat while ERROR <= ERROR
          -- UNK_64 2
          -- UNK_64 1
          morph = getAt()
          put("New" && morph)
          add(result, morph)
        end repeat
        -- UNK_65 3
      end if
    else
      put("Not found" && index)
    end if
  end repeat
  -- UNK_65 3
  return(result)
  exit
end

on getStartParts()
  junk = value(member("InitialJunkDB").text)
  result = []
  sort(result)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    n = 1
    repeat while n <= count(index)
      add(result, getPropAt(index, n))
      n = 1 + n
    end repeat
  end repeat
  -- UNK_65 3
  put(result)
  exit
end

on checkAllPartsValid()
  all = value(member("ExternalPartsDB").text)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    aList = getAt()
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      partId = getAt()
      if not objectp(getPart(gMulleGlobals.parts, partId)) then
        put("Missing: ", partId)
      end if
    end repeat
    -- UNK_65 3
  end repeat
  -- UNK_65 3
  all = value(member("InitialJunkDB").text)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    aList = getAt()
    n = 1
    repeat while n <= count(aList)
      if not objectp(getPart(gMulleGlobals.parts, getPropAt(aList, n))) then
        put("Missing: ", partId)
      end if
      n = 1 + n
    end repeat
  end repeat
  -- UNK_65 3
  exit
end