on new(me)
  nrOfPiles = 6
  maxParts = [#Pile1:50, #Pile2:50, #Pile3:50, #Pile4:50, #Pile5:50, #Pile6:50, #shopFloor:15, #yard:20]
  rects = [#Pile1:[rect(193, 260, 637, 400), rect(291, 193, 637, 263), rect(361, 153, 636, 194)], #Pile2:[rect(210, 252, 654, 380), rect(256, 174, 651, 262), rect(365, 120, 667, 188)], #Pile3:[rect(150, 281, 639, 380), rect(127, 162, 643, 291), rect(183, 100, 639, 164)], #Pile4:[rect(0, 324, 425, 404), rect(3, 174, 425, 325), rect(3, 90, 425, 182)], #Pile5:[rect(6, 268, 450, 412), rect(5, 180, 411, 275), rect(0, 100, 303, 189)], #Pile6:[rect(0, 275, 400, 390), rect(1, 201, 368, 283), rect(4, 135, 270, 203)], #shopFloor:[rect(20, 400, 600, 460)], #yard:[rect(290, 400, 580, 445)], #PileDoors:[rect(8, 106, 56, 323), rect(44, 84, 115, 224), rect(111, 41, 151, 103), rect(463, 47, 503, 107), rect(512, 69, 592, 208), rect(572, 94, 637, 312)]]
  shopFloorRect = rect(10, 400, 600, 460)
  yardRect = rect(290, 400, 580, 445)
  figgeBeenHere = 0
  return(me)
  exit
end

on kill(me)
  return(0)
  exit
end

on setPileRects(me)
  exit
end

on getRandomPile(me)
  tempList = []
  n = 1
  repeat while n <= nrOfPiles
    add(tempList, n)
    n = 1 + n
  end repeat
  rndList = []
  n = 1
  repeat while n <= nrOfPiles
    tempRnd = random(count(tempList))
    add(rndList, getAt(tempList, tempRnd))
    deleteAt(tempList, tempRnd)
    n = 1 + n
  end repeat
  n = 1
  repeat while n <= nrOfPiles
    tempSymbol = symbol("Pile" & string(getAt(rndList, n)))
    if not checkFull(me, tempSymbol) then
      return(tempSymbol)
    else
      n = 1 + n
    end if
  end repeat
  return(0)
  exit
end

on checkFull(me, whichJunk)
  tempMax = getaProp(maxParts, whichJunk)
  if count(getJunk(gMulleGlobals.user, whichJunk)) < tempMax then
    r = 0
  else
    r = 1
  end if
  return(r)
  exit
end

on setPartPosition(me, whichJunk, partId)
  partHeight = getHeight(getPart(gMulleGlobals.parts, partId))
  partWidth = getWidth(getPart(gMulleGlobals.parts, partId))
  if symbolp(whichJunk) then
    tempRects = getaProp(rects, whichJunk)
  else
    if integerp(whichJunk) then
      tempRects = getaProp(rects, symbol("Pile" & string(whichJunk)))
    end if
  end if
  bottomline = 0
  n = 1
  repeat while n <= count(tempRects)
    if getAt(getAt(tempRects, n), 4) > bottomline then
      bottomline = getAt(getAt(tempRects, n), 4)
    end if
    n = 1 + n
  end repeat
  if whichJunk = #shopFloor or whichJunk = #yard then
    rndRect = getAt(tempRects, random(count(tempRects)))
    rndH = random(getAt(rndRect, 3) - getAt(rndRect, 1))
    rndV = random(getAt(rndRect, 4) - getAt(rndRect, 2))
    tempOffset = point(getAt(rndRect, 1), getAt(rndRect, 2))
    newPartLoc = point(rndH, rndV) + tempOffset
  else
    newPartLoc = point(0, 999)
    overDoor = 0
    repeat while overDoor = 0
      rndRect = getAt(tempRects, random(count(tempRects)))
      rndH = random(getAt(rndRect, 3) - getAt(rndRect, 1))
      rndV = random(getAt(rndRect, 4) - getAt(rndRect, 2))
      tempOffset = point(getAt(rndRect, 1), getAt(rndRect, 2))
      newPartLoc = point(rndH, rndV) + tempOffset
      if getAt(newPartLoc, 2) + partHeight >= bottomline then
        rndV = rndV - getAt(newPartLoc, 2) + partHeight - bottomline
        newPartLoc = point(rndH, rndV) + tempOffset
      end if
      rectToCome = rect(getAt(newPartLoc, 1) - partWidth, getAt(newPartLoc, 2) - partHeight, getAt(newPartLoc, 1) + partWidth, getAt(newPartLoc, 2) + partHeight)
      testRect = intersect(rectToCome, getAt(getaProp(rects, #PileDoors), integer(the last char in string(whichJunk))))
      if testRect = rect(0, 0, 0, 0) then
        overDoor = 1
        next repeat
      end if
      newPartLoc = point(0, 999)
    end repeat
  end if
  return(newPartLoc)
  exit
end

on checkPoint(me, thePoint, theid, thePile)
  partHeight = getHeight(getPart(gMulleGlobals.parts, theid))
  partWidth = getWidth(getPart(gMulleGlobals.parts, theid))
  tempRects = getaProp(rects, symbol("Pile" & string(thePile)))
  bottomline = 0
  n = 1
  repeat while n <= count(tempRects)
    if getAt(getAt(tempRects, n), 4) > bottomline then
      bottomline = getAt(getAt(tempRects, n), 4)
    end if
    n = 1 + n
  end repeat
  rectToCome = rect(getAt(thePoint, 1) - partWidth, getAt(thePoint, 2) - partHeight, getAt(thePoint, 1) + partWidth, getAt(thePoint, 2) + partHeight)
  put("botton ", bottomline)
  diff = 0
  if getAt(rectToCome, 4) > bottomline then
    diff = getAt(rectToCome, 4) - bottomline
    rectToCome = rect(getAt(rectToCome, 1), getAt(rectToCome, 2) - diff, getAt(rectToCome, 3), getAt(rectToCome, 4) - diff)
  end if
  testRect = intersect(rectToCome, getAt(getaProp(rects, #PileDoors), thePile))
  if testRect = rect(0, 0, 0, 0) and getAt(rectToCome, 4) <= bottomline then
    if diff = 0 then
      returnValue = #true
    else
      returnValue = point(getAt(thePoint, 1), getAt(thePoint, 2) - diff)
    end if
  else
    returnValue = #false
  end if
  return(returnValue)
  exit
end

on correctPosition(me, thePartId, thePartLoc)
  isFalling = 0
  partId = thePartId
  part = getPart(gMulleGlobals.parts, partId)
  showMember = getJunkView(part)
  tempRect = getAt(getProp(rects, #shopFloor), 1)
  tempLocH = getAt(thePartLoc, 1)
  if tempLocH < getAt(tempRect, 1) then
    tempLocH = getAt(tempRect, 1)
  else
    if tempLocH > getAt(tempRect, 3) then
      tempLocH = getAt(tempRect, 3)
    end if
  end if
  tempOffsetV = getAt(member(showMember).rect, 4) / 2
  floorLocV = getAt(tempRect, 4)
  put("floorLocV ", floorLocV)
  tempLocV = getAt(thePartLoc, 2)
  if tempLocV < floorLocV then
    isFalling = 1
    tempNewLocV = floorLocV
  else
    rndDiff = 35 + random(10)
    tempNewLocV = floorLocV + tempOffsetV - rndDiff
  end if
  return([point(tempLocH, tempNewLocV), isFalling])
  exit
end