on beginSprite(me)
  SP = me.spriteNum
  startLocH = sprite(SP).locH
  max = 4
  step = 11
  counter = 0
  mode = #in
  centerH = 640
  isInside = 0
  trackRect = rect(560, 400, 800, 650)
  checkForLeave = 0
  activeClick = 1
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on exitFrame(me)
  if checkForLeave then
    if not inside(point(the mouseH, the mouseV), trackRect) then
      mymouseLeave(me)
    end if
  end if
  if counter then
    counter = counter - 1
    if mode = #in then
      sprite(SP).locH = startLocH - counter * step
    else
      if mode = #Out then
        sprite(SP).locH = startLocH - max - counter * step
      end if
    end if
  end if
  exit
end

on mouseEnter(me)
  if activeClick then
    checkForLeave = 1
    if mode = #in then
      if counter < 4 then
        play(gSound, "00e040v0", #OPEFFECT)
      end if
      mode = #Out
      counter = max - counter
      isInside = 0
    end if
  else
    if mode = #Out then
      mode = #in
      counter = max - counter
    end if
  end if
  exit
end

on mymouseLeave(me)
  isInside = 0
  checkForLeave = 0
  if mode = #Out then
    mode = #in
    counter = max - counter
  end if
  exit
end

on mouseUp(me)
  if activeClick then
    if the movie.char[1..2] = "02" then
      sendSprite(getaProp(gDir.spriteList, #drag), #forceLetGo)
    end if
    counter = 0
    mode = #Out
    sprite(SP).locH = startLocH - max * step
    sendSprite(getProp(gDir.spriteList, #fDialog), #functionDialogSwitch)
  end if
  exit
end