on new(me)
  if the machineType = 256 then
    folderDelimit = "\\"
  else
    folderDelimit = ":"
  end if
  translateLetters = value(member("00t001v0").text)
  if voidp(gCDPath) then
    CDPath = the moviePath
    HDPath = the moviePath
    tempOff = offset(folderDelimit, HDPath)
    rootPath = HDPath.char[1..tempOff]
    if the machineType = 256 then
      pluginPath = rootPath & "Levande" & folderDelimit & "MulleBil" & folderDelimit & "Plugins" & folderDelimit
      helpFile = CDPath & "MulleBil.hlp"
    else
      pluginPath = rootPath & "Levande" & folderDelimit & "Mulle Meck bygger bil" & folderDelimit & "Plugins" & folderDelimit
      helpFile = CDPath & "Om Mulle"
    end if
    carPath = "c:\\levande\\mullebil\\bilar\\"
    xtrasPath = CDPath & "Xtras" & folderDelimit
  else
    CDPath = gCDPath
    HDPath = gHDPath
    pluginPath = HDPath & "Plugins" & folderDelimit
    helpFile = gHelpFile
    carPath = HDPath & "Bilar" & folderDelimit
    if the machineType = 256 then
      xtrasPath = CDPath & "Xtras" & folderDelimit
    else
      xtrasPath = CDPath & "HiddenXtras" & folderDelimit
    end if
  end if
  the searchPaths = [CDPath & "Movies" & folderDelimit, pluginPath, HDPath & "data" & folderDelimit]
  xtraFileList = []
  n = 1
  repeat while n <= the maxinteger
    tempName = getNthFileNameInFolder(xtrasPath, n)
    if tempName = "" then
    else
      add(xtraFileList, tempName)
      n = 1 + n
    end if
  end repeat
  return(me)
  exit
end

on kill(me)
  return(0)
  exit
end

on upperCase(me, theStr)
  n = 1
  repeat while n <= length(theStr)
    tempNum = charToNum(theStr.char[n])
    if tempNum >= 97 then
      if tempNum <= 122 then
        -- UNK_5A 20
      else
        if the machineType = 256 then
          temp = getProp(translateLetters, #PC)
        else
          temp = getProp(translateLetters, #Mac)
        end if
        found = getPos(temp, tempNum)
        if found then
          if found mod 2 = 0 then
            -- UNK_5A 20
          end if
        end if
      end if
    end if
    n = 1 + n
  end repeat
  return(theStr)
  exit
end

on openXtra(me, theXtra)
  temp = getXtraName(me, theXtra)
  xtraName = getAt(temp, 1)
  xtraFileName = getAt(temp, 2)
  if not findXtra(me, xtraName) then
    if findXtraFile(me, xtraFileName) then
      openXLib(xtrasPath & xtraFileName)
      if theXtra = #PrintOMatic then
        register(xtra("PrintOMatic"), "PMAT133-396-02312")
      end if
      return(1)
    end if
  end if
  return(0)
  exit
end

on closeXtra(me, theXtra)
  temp = getXtraName(me, theXtra)
  xtraName = getAt(temp, 1)
  xtraFileName = getAt(temp, 2)
  if findXtra(me, xtraName) and findXtraFile(me, xtraFileName) then
    closeXLib(xtrasPath & xtraFileName)
  end if
  exit
end

on findXtra(me, theXtraName)
  xtraNr = 1
  repeat while xtraNr <= the number of undefineds
    if xtra(xtraNr).name = theXtraName then
      return(1)
    end if
    xtraNr = 1 + xtraNr
  end repeat
  return(0)
  exit
end

on getXtraName(me, theXtra)
  if theXtra = #PrintOMatic then
    xtraName = "PrintOMatic"
    if the machineType = 256 then
      xtraFileName = "PMatic"
    else
      xtraFileName = "PrintOMatic"
    end if
  else
    if theXtra = #KeyPoll then
      xtraName = "KeyPoll"
      if the machineType = 256 then
        xtraFileName = "KeyPoll"
      else
        xtraFileName = "KeyPollFat"
      end if
    end if
  end if
  return([xtraName, xtraFileName])
  exit
end

on findXtraFile(me, theFileName)
  if the machineType = 256 then
    theFileName = theFileName & ".x"
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if index contains theFileName then
      return(1)
    end if
  end repeat
  -- UNK_65 3
  return(0)
  exit
end