on beginSprite(me)
  type = #Mulle
  mode = #wait
  currentAnimChart = #MulleJunk
  currentAction = #none
  ThoughtSounds = ["02d001v0", "02d002v0", "02d003v0", "02d004v0", "02d005v0"]
  sortSounds = ["02d006v0", "02d007v0", "02d008v0"]
  randomSounds = ThoughtSounds
  tempList = sprite(me.spriteNum).undefined
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if index.type = #SpriteAnim then
      animObject = index
    end if
  end repeat
  -- UNK_65 3
  activeClick = 1
  sendSprite(the currentSpriteNum, #setAnimChart, "MulleJunk")
  theSnd = ""
  exit
end

on activate(me, theState)
  put("the state :", theState)
  activeClick = theState
  exit
end

on exitFrame(me)
  if gDir.goToLoad = 0 then
    if activeClick then
      if mode = #wait then
        if getAnimWaitState(animObject) = #Still then
          if random(250) = 1 then
            move(me)
          end if
        end if
      end if
    end if
  end if
  exit
end

on addToSounList(me, what)
  if what = #Reject then
    randomSounds = sortSounds
  else
    randomSounds = ThoughtSounds
  end if
  exit
end

on describepart(me, theDescription)
  playAnimSound(animObject, "")
  mode = #Talk
  currentAction = #Describe
  if random(2) = 1 then
    currentAnimChart = #TalkToMeJunk
    sendSprite(me.spriteNum, #setAnimChart, "TalkToMeJunk")
  end if
  makeAnimSpeech(animObject, theDescription)
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end

on MakeMulleSpeak(me, theAction)
  currentAction = theAction
  playAnimSound(animObject, "")
  mode = #Talk
  if theAction = #shopFull then
    n = random(3)
    -- UNK_64 0
    if ERROR = 1 then
      theSnd = "02d009v0"
    else
      -- UNK_64 0
      if ERROR = 2 then
        theSnd = "02d010v0"
      else
        -- UNK_64 0
        if ERROR = 3 then
          theSnd = "02d011v0"
        end if
      end if
    end if
    -- UNK_65 1
  else
    if theAction = #pileFull then
      n = random(3)
      -- UNK_64 0
      if ERROR = 1 then
        theSnd = "02d013v0"
      else
        -- UNK_64 0
        if ERROR = 2 then
          theSnd = "02d014v0"
        else
          -- UNK_64 0
          if ERROR = 3 then
            theSnd = "02d015v0"
          end if
        end if
      end if
      -- UNK_65 1
    end if
  end if
  if random(2) = 1 then
    currentAnimChart = #TalkToMeJunk
    sendSprite(me.spriteNum, #setAnimChart, "TalkToMeJunk")
  end if
  makeAnimSpeech(animObject, theSnd)
  sendSprite(me.spriteNum, #setAnimAction, #Talk)
  exit
end

on move(me)
  tempMode = 0
  tempMode = #Talk
  theSnd = getAt(randomSounds, random(count(randomSounds)))
  if random(2) = 1 then
    currentAnimChart = #TalkToMeJunk
    sendSprite(me.spriteNum, #setAnimChart, "TalkToMeJunk")
  end if
  makeAnimSpeech(animObject, theSnd)
  mode = tempMode
  if mode <> 0 then
    sendSprite(me.spriteNum, #setAnimAction, mode)
  end if
  exit
end

on Stopped(me)
  -- UNK_64 0
  if ERROR = #Talk then
    if currentAnimChart = #TalkToMeJunk then
      sendSprite(the currentSpriteNum, #setAnimChart, "MulleJunk")
    end if
    if theSnd <> "" then
      unloadMember(theSnd)
    end if
    sprite(120).tmpId = 0
    setAnimNormal(animObject)
    tempMode = #wait
    currentAction = #none
  else
    tempMode = #wait
  end if
  -- UNK_65 1
  mode = tempMode
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end