on beginSprite(me)
  tempSP = -1 + me.spriteNum
  floorParts = getJunk(gMulleGlobals.user, #shopFloor)
  maxFloorParts = 35
  maxDraw = count(floorParts)
  n = 1
  repeat while n <= maxDraw
    partId = getPropAt(floorParts, n)
    partLoc = getAt(floorParts, n)
    part = getPart(gMulleGlobals.parts, partId)
    sprite(tempSP + n).undefined = member(getJunkView(part))
    sprite(tempSP + n).undefined = partLoc
    n = 1 + n
  end repeat
  exit
end

on drawJunk(me, isFalling, where)
  tempSP = -1 + me.spriteNum
  floorParts = getJunk(gMulleGlobals.user, #shopFloor)
  maxFloorParts = 35
  maxDraw = count(floorParts)
  n = 1
  repeat while n <= maxDraw - 1
    partId = getPropAt(floorParts, n)
    partLoc = getAt(floorParts, n)
    sendSprite(tempSP + n, #setPart, partId, partLoc, 0)
    n = 1 + n
  end repeat
  if maxDraw then
    partId = getPropAt(floorParts, maxDraw)
    partLoc = getAt(floorParts, maxDraw)
    sendSprite(tempSP + maxDraw, #setPart, partId, partLoc, isFalling, where)
  end if
  if maxDraw < maxFloorParts then
    sendSprite(tempSP + maxDraw + 1, #setPart, 0)
  end if
  exit
end

on setjunk(me)
  exit
end