on beginSprite(me)
  type = #Mulle
  mode = #wait
  currentAnimChart = #Verkstad
  currentTalk = #Silence
  startSounds = ["03d027v0", "03d060v0", "03d062v0"]
  okSounds = ["03d034v0", "03d035v0", "03d036v0", "03d061v0"]
  greatSounds = ["03d037v0", "03d038v0"]
  currentSound = "start"
  randomSounds = startSounds
  tempList = sprite(me.spriteNum).undefined
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if index.type = #SpriteAnim then
      animObject = index
    end if
  end repeat
  -- UNK_65 3
  activeClick = 1
  aboutToOpen = 0
  makeHimLeave = 0
  FrozenAction = ""
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on exitFrame(me)
  if currentTalk = #Silence then
    if activeClick then
      if mode = #wait then
        if getAnimWaitState(animObject) = #Still then
          if random(250) = 1 then
            if gMulleGlobals.loadIndicator then
              randomMove(me, 1)
            else
              randomMove(me, 1)
            end if
          end if
        end if
      end if
    end if
  end if
  exit
end

on removeLoop(me)
  deleteLoopObject(gDir, me)
  updateLoopObjects(gDir)
  exit
end

on waitForProtest(me, YesNo, extraInfo)
  if YesNo = 1 then
    currentSound = "nothing"
    activeClick = 0
    addLoopObject(gDir, me)
    loopCount = 0
  else
    activeClick = 1
    deleteLoopObject(gDir, me)
    updateLoopObjects(gDir)
    loopCount = 0
    if extraInfo = #cut then
      if mode = #Talk then
        gDir.partsCommon.waitin = 0
        sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 1)
        sendSprite(me.spriteNum, #setAnimAction, #wait)
        stopAllEffects(gSound)
      end if
    end if
  end if
  exit
end

on loop(me)
  if currentSound = "nothing" then
    if loopCount = 14 then
      activeClick = 1
      deleteLoopObject(gDir, me)
      loopCount = 0
      if mode = #Talk or mode = #wait then
        MakeMulleSpeak(me, #noPoints)
      end if
    else
      loopCount = loopCount + 1
    end if
  else
    if currentSound = "start" then
      if the frame = 2 then
        deleteLoopObject(gDir, me)
        updateLoopObjects(gDir)
        MakeMulleSpeak(me, FrozenAction)
      end if
    else
      if finished(gSound, currentSound) and mode = #wait then
        if mode <> #Work and mode <> #GoTable and mode <> #GoBack then
          mode = #wait
          sendSprite(me.spriteNum, #setAnimAction, mode)
        end if
        deleteLoopObject(gDir, me)
        updateLoopObjects(gDir)
      end if
    end if
  end if
  exit
end

on MakeMulleSpeak(me, theAction, extraInfo)
  currentTalk = theAction
  if the frame = 1 then
    FrozenAction = theAction
    addLoopObject(gDir, me)
  else
    if finished(gSound, currentSound) then
      playAnimSound(animObject, "")
      if theAction = #noWheels then
        theSnd = "03d011v0"
      else
        if theAction = #noSeat then
          theSnd = "03d039v0"
        else
          if theAction = #yourTurn then
            theSnd = "03d028v0"
          else
            if theAction = #fullPile then
              theSnd = "03d033v0"
            else
              if theAction = #greetFigge then
                makeHimLeave = 1
                theSnd = "03d045v0"
              else
                if theAction = #noPoints then
                  -- UNK_64 0
                  if ERROR = 1 then
                    theSnd = "03d040v0"
                  else
                    -- UNK_64 0
                    if ERROR = 2 then
                      theSnd = "03d041v0"
                    else
                      -- UNK_64 0
                      if ERROR = 3 then
                        theSnd = "03d042v0"
                      end if
                    end if
                  end if
                  -- UNK_65 1
                else
                  if theAction = #InspireYou then
                    -- UNK_64 0
                    if ERROR = 1 then
                      theSnd = "03d052v0"
                    else
                      -- UNK_64 0
                      if ERROR = 2 then
                        theSnd = "03d053v0"
                      else
                        -- UNK_64 0
                        if ERROR = 3 then
                          theSnd = "03d054v0"
                        else
                          -- UNK_64 0
                          if ERROR = 4 then
                            theSnd = "03d055v0"
                          else
                            -- UNK_64 0
                            if ERROR = 5 then
                              theSnd = "03d056v0"
                            end if
                          end if
                        end if
                      end if
                    end if
                    -- UNK_65 1
                  else
                    if theAction = #Describe then
                      theSnd = extraInfo
                    else
                      if theAction = #afterTrash0 then
                        theSnd = "03d031v0"
                      else
                        if theAction = #AfterTrash1 then
                          theSnd = "03d030v0"
                        else
                          if theAction = #AfterTrash2 then
                            theSnd = "03d029v0"
                          else
                            if theAction = #AfterTrash3 then
                              theSnd = "03d028v0"
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
      if mode = #wait or mode = #Talk then
        makeAnimSpeech(animObject, theSnd)
        if theAction = #noPoints then
          tempMode = #Talk
          currentAnimChart = #TalkToMe
          sendSprite(the currentSpriteNum, #setAnimChart, "TalkToMe")
        else
          if theAction = #greetFigge then
            tempMode = #Talk
          else
            if random(2) = 1 then
              tempMode = #Talk
            else
              tempMode = #Talk
              currentAnimChart = #TalkToMe
              sendSprite(the currentSpriteNum, #setAnimChart, "TalkToMe")
            end if
          end if
        end if
        mode = tempMode
        sendSprite(me.spriteNum, #setAnimAction, mode)
        currentSound = 0
      else
        if mode <> #LookUnderCar then
          deleteLoopObject(gDir, me)
          updateLoopObjects(gDir)
          currentSound = play(gSound, theSnd, #EFFECT)
          addLoopObject(gDir, me)
        end if
      end if
    end if
  end if
  exit
end

on randomMove(me, maxRnd)
  if mode = #wait then
    tempMode = 0
    -- UNK_64 0
    if ERROR = 1 then
      if randomSounds <> [] then
        sendSprite(the currentSpriteNum, #setAnimFirstFrame, "00a001v0")
        sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 0)
        if random(2) = 1 then
          tempMode = #Talk
        else
          tempMode = #Talk
          currentAnimChart = #TalkToMe
          sendSprite(the currentSpriteNum, #setAnimChart, "TalkToMe")
        end if
        theSnd = getAt(randomSounds, random(count(randomSounds)))
        makeAnimSpeech(animObject, theSnd)
        mode = tempMode
      end if
    else
      -- UNK_64 0
      if ERROR = 2 then
        sendSprite(the currentSpriteNum, #setAnimFirstFrame, "00a001v0")
        tempMode = #LookUnderCar
        mode = tempMode
      else
        -- UNK_64 0
        if ERROR = 3 then
          sendSprite(the currentSpriteNum, #setAnimFirstFrame, "03a003v0")
          tempMode = #GoTable
          mode = tempMode
        end if
      end if
    end if
    -- UNK_65 1
    sendSprite(me.spriteNum, #setAnimAction, mode)
  end if
  exit
end

on checkEquipment(me, Specific)
  if Specific <> #none then
    if Specific = #wheels then
      if areTheseFree(gDir.carCopy, [#a1]) = 1 or areTheseFree(gDir.carCopy, [#a13]) = 1 then
        return(1)
      else
        return(0)
      end if
    else
      if Specific = #Seat then
        if getaProp(gDir.carCopy.carProperties, #Comfort) = 0 then
          return(1)
        else
          return(0)
        end if
      end if
    end if
  else
    updateProperties(gMulleGlobals.user.car)
    leadSounds = []
    if count(gDir.carCopy.parts) >= 12 then
      randomSounds = greatSounds
    else
      if count(gDir.carCopy.parts) >= 8 then
        randomSounds = okSounds
      else
        randomSounds = startSounds
      end if
    end if
    if areTheseFree(gDir.carCopy, [#a1]) = 0 and areTheseFree(gDir.carCopy, [#a13]) = 0 then
      add(leadSounds, "03d005v0")
      add(leadSounds, "03d006v0")
      add(leadSounds, "03d007v0")
    else
      if areTheseFree(gDir.carCopy, [#a1]) = 1 or areTheseFree(gDir.carCopy, [#a13]) = 1 then
        add(leadSounds, "03d011v0")
        add(leadSounds, "03d012v0")
      end if
    end if
    if getaProp(gDir.carCopy.carProperties, #break) = 0 then
      add(leadSounds, "03d018v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #FuelConsumption) = 0 then
      add(leadSounds, "03d013v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #ElectricVolume) = 0 then
      add(leadSounds, "03d014v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #FuelVolume) = 0 then
      add(leadSounds, "03d015v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #acceleration) = 0 then
      add(leadSounds, "03d016v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #Steering) = 0 then
      add(leadSounds, "03d017v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #Horn) = 0 then
      add(leadSounds, "03d019v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #ExhaustPipe) = 0 then
      add(leadSounds, "03d020v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #Lamps) = 0 then
      add(leadSounds, "03d021v0")
    end if
  end if
  exit
end

on mouseUp(me)
  if activeClick then
    if mode = #wait then
      sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 0)
      if random(2) = 1 then
        tempMode = #Talk
      else
        tempMode = #Talk
        currentAnimChart = #TalkToMe
        sendSprite(the currentSpriteNum, #setAnimChart, "TalkToMe")
      end if
      mode = tempMode
      theSnd = getAt(leadSounds, random(count(leadSounds)))
      makeAnimSpeech(animObject, theSnd)
      sendSprite(me.spriteNum, #setAnimAction, mode)
    end if
  end if
  exit
end

on mouseEnter(me)
  sendSprite(getaProp(gDir.spriteList, #DoorToYard), #resizeRect, 1)
  exit
end

on mouseLeave()
  sendSprite(getaProp(gDir.spriteList, #DoorToYard), #resizeRect, 0)
  exit
end

on Stopped(me)
  -- UNK_64 0
  if ERROR = #OpenDoor then
    play(gSound, "02e016v0", #EFFECT)
    sprite(getaProp(gDir.spriteList, #garage)).undefined = sprite(getaProp(gDir.spriteList, #garage)).undefined + 1
    sprite(getaProp(gDir.spriteList, #Mulle)).undefined = sprite(getaProp(gDir.spriteList, #Mulle)).undefined + 1
    sendSprite(getaProp(gDir.spriteList, #Mikro), #runMikro)
    updateStage()
    updateProperties(gMulleGlobals.user.car)
    tempMode = #Still
    sendSprite(the currentSpriteNum, #setAnimFirstFrame, "freeze")
    gMulleGlobals.user.toYardThroughDoor = 0
  else
    -- UNK_64 0
    if ERROR = #GoTable then
      tempMode = #Work
    else
      -- UNK_64 0
      if ERROR = #Work then
        if random(8) = 1 then
          tempMode = #GoBack
        else
          tempMode = #Work
        end if
      else
        -- UNK_64 0
        if ERROR = #Talk then
          if makeHimLeave then
            sendSprite(getaProp(gDir.spriteList, #Figge), #FiggeLeave)
            makeHimLeave = 0
          end if
          if currentAnimChart = #TalkToMe then
            sendSprite(the currentSpriteNum, #setAnimChart, "Verkstad")
          end if
          setAnimNormal(animObject)
          tempMode = #wait
          currentTalk = #Silence
          gDir.partsCommon.waitin = 0
          gDir.partsCommon.tmpId = 0
        else
          -- UNK_64 0
          if ERROR = #LookUnderCar then
            tempMode = #wait
          else
            tempMode = #wait
            sendSprite(the currentSpriteNum, #setAnimFirstFrame, "00a001v0")
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 1)
  mode = tempMode
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end