on beginSprite(me)
  doortracking = 0
  trackRect = sprite(me.spriteNum).undefined
  screenObject = new(script("screenObject"), me, trackRect, 0)
  addScreenObject(gDir, screenObject)
  activeClick = 1
  overPart = 0
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on mouseEnter(me)
  if activeClick then
    if count(gDir.mouseOverCar) = 0 then
      if not doortracking then
        doortracking = 1
        sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 0)
        play(gSound, "02e016v0", #OPEFFECT)
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
        if mediaName = "04" then
          if gDir.mouseOverMulle = [] then
            if not the mouseDown then
              sendSprite(115, #c_Left)
            end if
          end if
        else
          if gDir.partsCommon.tracking then
            sendSprite(115, #c_MoveIn)
          else
            sendSprite(115, #c_click)
          end if
        end if
      end if
    end if
  end if
  exit
end

on prepareFrame(me)
  if doortracking then
    if not inside(point(the mouseH, the mouseV), trackRect) then
      sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 1)
      play(gSound, "02e015v0", #OPEFFECT)
      sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
      if sprite(getaProp(gDir.spriteList, #drag)).Active = 1 then
        sendSprite(115, #c_grab)
      else
        if overPart = 0 then
          sendSprite(115, #C_Standard)
        end if
      end if
      doortracking = 0
    end if
  end if
  exit
end

on resizeRect(me, small)
  if small = 1 then
    trackRect = rect(70, 25, 45, 100)
  else
    trackRect = sprite(the currentSpriteNum).undefined
  end if
  exit
end

on CheckMouse(me)
  if inside(point(the mouseH, the mouseV), trackRect) then
    return(1)
  else
    return(0)
  end if
  exit
end

on report(me, theObject, what)
  if what = #clicked then
    if count(gDir.mouseOverCar) = 0 then
      if inside(point(the mouseH, the mouseV), trackRect) then
        updateProperties(gMulleGlobals.user.car)
        gMulleGlobals.user.toYardThroughDoor = 1
        gMulleGlobals.WhereFrom = "03"
        if goToType = #marker then
          go(string(mediaName))
        else
          go(1, mediaName)
        end if
      end if
    end if
  end if
  exit
end

on getPropertyDescriptionList()
  p_list = [#mediaName:[#comment:"the name of the destination marker:", #format:#string, #default:""], #goToType:[#comment:"Destination is:", #format:#symbol, #range:[#movie, #marker], #default:#marker]]
  return(p_list)
  exit
end