on beginSprite(me)
  doortracking = 0
  trackRect = sprite(the currentSpriteNum).undefined
  screenObject = new(script("screenObject"), me, trackRect, 0)
  addScreenObject(gDir, screenObject)
  activeClick = 1
  currentSound = ""
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on mouseEnter(me)
  if activeClick then
    if count(gDir.mouseOverCar) = 0 then
      if not doortracking then
        doortracking = 1
        sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 0)
        play(gSound, "02e016v0", #OPEFFECT)
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
        if not the mouseDown then
          sendSprite(115, #c_Left)
        end if
      end if
    end if
  end if
  exit
end

on prepareFrame(me)
  if doortracking then
    if not inside(point(the mouseH, the mouseV), trackRect) then
      sendSprite(getaProp(gDir.spriteList, #Figge), #activateClick, 1)
      play(gSound, "02e015v0", #OPEFFECT)
      sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
      if not the mouseDown then
        sendSprite(115, #C_Standard)
      end if
      doortracking = 0
    end if
  end if
  exit
end

on report(me, theObject, what)
  if activeClick then
    Test = 0
    if what = #clicked then
      if sendSprite(getaProp(gDir.spriteList, #Mulle), #checkEquipment, #wheels) then
        sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #noWheels)
        Test = 1
      else
        if sendSprite(getaProp(gDir.spriteList, #Mulle), #checkEquipment, #Seat) then
          sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #noSeat)
          Test = 1
        end if
      end if
      if Test = 0 then
        activeClick = 0
        updateProperties(gMulleGlobals.user.car)
        gMulleGlobals.user.toYardThroughDoor = 0
        gMulleGlobals.WhereFrom = "03"
        stopAllEffects(gSound)
        go("garage")
      end if
    end if
  end if
  exit
end

on checkMyRect(me)
  if inside(point(the mouseH, the mouseV), trackRect) then
    go(string(mediaName))
  end if
  exit
end

on getPropertyDescriptionList()
  p_list = [#mediaName:[#comment:"the name of the destination marker:", #format:#string, #default:""], #goToType:[#comment:"Destination is:", #format:#symbol, #range:[#movie, #marker], #default:#marker]]
  return(p_list)
  exit
end