on beginSprite(me)
  tempSP = -1 + me.spriteNum
  floorParts = getJunk(gMulleGlobals.user, #yard)
  maxYardParts = 35
  maxDraw = count(floorParts)
  n = 1
  repeat while n <= maxDraw
    partId = getPropAt(floorParts, n)
    partLoc = getAt(floorParts, n)
    part = getPart(gMulleGlobals.parts, partId)
    sprite(tempSP + n).undefined = member(getJunkView(part))
    partLoc = point(500 + random(30), 380 + random(30))
    sprite(tempSP + n).undefined = partLoc
    n = 1 + n
  end repeat
  exit
end

on drawJunk(me, WorldParts)
  tempSP = -1 + me.spriteNum
  floorParts = getJunk(gMulleGlobals.user, #yard)
  maxYardParts = 20
  maxDraw = count(floorParts)
  n = 1
  repeat while n <= maxYardParts
    if n <= maxDraw then
      partId = getPropAt(floorParts, n)
      partLoc = getAt(floorParts, n)
      sendSprite(tempSP + n, #setPart, partId, partLoc)
    else
      sprite(tempSP + n).undefined = point(-200, -200)
    end if
    n = 1 + n
  end repeat
  if maxDraw < maxYardParts then
    sendSprite(tempSP + maxDraw + 1, #setPart, 0)
  end if
  exit
end