on beginSprite(me)
  SP = me.spriteNum
  isFalling = 0
  velV = 0
  velH = 0
  activeClick = 1
  nrOfMoveSteps = 14
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on setPart(me, thePartId, thePartLoc)
  isFalling = 0
  if thePartId = 0 then
    sprite(SP).undefined = member("Dummy")
  else
    partId = thePartId
    part = getPart(gMulleGlobals.parts, partId)
    showMember = getJunkView(part)
    sprite(SP).undefined = member(showMember)
    tempLocH = getAt(thePartLoc, 1)
    if tempLocH < 290 then
      velH = 20
    else
      if tempLocH > 640 then
        tempLocH = 640
      end if
    end if
    tempOffsetV = getAt(member(showMember).rect, 4) / 2
    floorLocV = 460 - tempOffsetV
    tempLocV = getAt(thePartLoc, 2)
    rect = getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1)
    if tempLocV < getAt(rect, 2) or tempLocH < 290 then
      put("isfalling1 + id", thePartId)
      isFalling = 1
      velV = 0
      tempNewLocV = floorLocV
      sprite(SP).undefined = point(tempLocH, tempLocV)
    else
      if tempLocV > floorLocV + 2 * tempOffsetV then
        tempNewLocV = floorLocV + 2 * tempOffsetV
        sprite(SP).undefined = point(tempLocH, tempNewLocV)
      else
        tempNewLocV = tempLocV
        sprite(SP).undefined = point(tempLocH, tempNewLocV)
      end if
    end if
    setJunkPartProp(gMulleGlobals.user, #yard, partId, point(tempLocH, tempNewLocV))
  end if
  exit
end

on mouseDown(me)
  if activeClick then
    grabbedPart(gDir.partsCommon, partId, #Floor)
  end if
  exit
end

on exitFrame(me)
  if isFalling then
    if sprite(SP).locV >= getAt(getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1), 2) then
      Hmax = getAt(getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1), 3)
      if sprite(SP).locH < 290 then
        sprite(SP).locH = velH + sprite(SP).locH
      else
        if sprite(SP).locH > Hmax then
          sprite(SP).locH = Hmax
        else
          velV = 0
          newPoint = sprite(SP).undefined
          isFalling = 0
          kickPartSound(gMulleGlobals.SharedSound, SP, partId, #InternalGround)
          setJunkPartProp(gMulleGlobals.user, #yard, partId, newPoint)
        end if
      end if
    else
      if velV < 30 then
        velV = velV + 8
      end if
      sprite(SP).locV = velV + sprite(SP).locV
      if sprite(SP).locH < 290 then
        sprite(SP).locH = velH + sprite(SP).locH
      end if
    end if
  end if
  exit
end

on forcePart(me)
  if isFalling then
    tempNewPos = setPartPosition(gMulleGlobals.junkPileHandlers, #yard, partId)
    put("kick in force")
    kickPartSound(gMulleGlobals.SharedSound, SP, partId, #InternalGround)
    sprite(me.spriteNum).undefined = tempNewPos
    setJunkPartProp(gMulleGlobals.user, #yard, partId, tempNewPos)
  end if
  exit
end