on new(me, theReportObject, theRects, theMouseOver, theRegLoc)
  Active = 1
  rects = theRects
  reportObject = theReportObject
  mouseOver = theMouseOver
  closeHand = 0
  downOn = 0
  if stringp(mouseOver) then
    if theMouseOver = #OpenHand then
      closeHand = 1
    end if
  end if
  if voidp(theRegLoc) then
  else
    regLoc = theRegLoc
  end if
  return(me)
  exit
end

on checkDown(me, thePoint)
  if Active then
    if inside(thePoint, rects) then
      downOn = 1
      report(reportObject, me, #downOn)
      screenPriority(gDir, me, 1)
      return(1)
    end if
  end if
  return(0)
  exit
end

on checkUp(me, thePoint)
  if Active then
    if downOn then
      screenPriority(gDir, me, 0)
      report(reportObject, me, #stillDown)
      if inside(thePoint, rects) then
        downOn = 0
        report(reportObject, me, #clicked)
        return(1)
      else
        report(reportObject, me, #UpOutside)
      end if
    end if
    downOn = 0
  end if
  return(0)
  exit
end

on checkBetween(me, thePoint, mouseChange)
  if Active then
    if downOn then
      report(reportObject, me, #stillDown)
    end if
    oldOver = over
    over = 0
    if inside(thePoint, rects) then
      over = 1
      if not oldOver then
        report(reportObject, me, #over)
      end if
      if not mouseOver = #normal and mouseChange then
        if downOn then
          if closeHand then
            cursorChange(gDir, 120, #ClosedHand)
          else
            cursorChange(gDir, 120, mouseOver)
          end if
        else
          cursorChange(gDir, 120, mouseOver)
        end if
        return(1)
      end if
    end if
    if not over and oldOver then
      report(reportObject, me, #NotOver)
    end if
  end if
  return(0)
  exit
end

on moveRegLoc(me, newLoc)
  diffH = getAt(newLoc, 1) - getAt(regLoc, 1)
  diffV = getAt(newLoc, 2) - getAt(regLoc, 2)
  rects = offset(rects, diffH, diffV)
  regLoc = newLoc
  exit
end

on kill(me)
  return(0)
  exit
end