on startMovie(me)
  stopAllEffects(gSound)
  stopBG(gSound)
  if gMulleGlobals.loadIndicator = 0 then
    play(gSound, "02e010v0", #BG)
  end if
  the keyDownScript = "systemkeys"
  if gDir.carOnYard then
    sendSprite(getProp(gDir.spriteList, #mulleInCar), #activate, 1)
    sendSprite(getProp(gDir.spriteList, #mulleInCar), #init, 1)
    sendSprite(getProp(gDir.spriteList, #mulleStand), #activate, 0)
    sendSprite(getProp(gDir.spriteList, #Buffa), #activate, 0)
    sendSprite(getProp(gDir.spriteList, #CarStart), #drawCar)
  else
    sendSprite(getProp(gDir.spriteList, #mulleStand), #activate, 1)
    sendSprite(getProp(gDir.spriteList, #mulleStand), #init, 1)
    sendSprite(getProp(gDir.spriteList, #Buffa), #activate, 1)
    sendSprite(getProp(gDir.spriteList, #Buffa), #init, 1)
    sendSprite(getProp(gDir.spriteList, #mulleInCar), #activate, 0)
  end if
  sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk)
  sendSprite(getaProp(gDir.spriteList, #mulleInCar), #setMulleSpeak)
  checKPostal()
  if gMulleGlobals.user.gifts <> [] then
    if gDir.carOnYard then
      sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #package)
    else
      sendSprite(getaProp(gDir.spriteList, #mulleStand), #MakeMulleSpeak, #package)
    end if
    sprite("04b004v0").undefined = sprite(0).number
    sprite(getaProp(gDir.spriteList, #giftSprite)).undefined = point(180, 410)
  else
    if gMulleGlobals.junkPileHandlers.figgeBeenHere then
      if gDir.carOnYard then
        sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #FiggeRemark)
      else
        sendSprite(getaProp(gDir.spriteList, #mulleStand), #MakeMulleSpeak, #FiggeRemark)
      end if
      gMulleGlobals.junkPileHandlers.figgeBeenHere = 0
    end if
  end if
  checkMissions(gMulleGlobals.missions)
  if objectp(gMulleGlobals.missions.currentMission) = 1 then
    if gMulleGlobals.user.missionIsComing = 1 then
      if getType(gMulleGlobals.missions.currentMission) = #Mail then
        sendSprite(getaProp(gDir.spriteList, #mailBox), #showMail, 1)
      end if
    end if
  end if
  sprite(115).undefined = point(-20, -20)
  if gMulleGlobals.CustomCursorActive then
    cursor(200)
  else
    sendSprite(115, #C_Standard)
  end if
  preloadMember("02e015v0")
  preloadMember("02e016v0")
  preloadMember("open1")
  preloadMember("open2")
  exit
end

on checKPostal(me)
  calcCurrentlyAvailable(gMulleGlobals.externalParts, #Postal)
  newGiftList = getCurrentlyAvailable(gMulleGlobals.externalParts, #Postal)
  n = 1
  repeat while n <= count(newGiftList)
    add(gMulleGlobals.user.gifts, list(getAt(newGiftList, n)))
    n = 1 + n
  end repeat
  exit
end

on cuePassed(channel, number, name)
  x = value(the last char in string(channel))
  if gDir.carOnYard then
    sendSprite(getaProp(gDir.spriteList, #mulleInCar), #spritecuePassed, x, number, name)
  else
    sendSprite(getaProp(gDir.spriteList, #mulleStand), #spritecuePassed, x, number, name)
  end if
  if name = "toNextFrame" then
    go(the frame + 1)
  end if
  exit
end