on beginSprite(me)
  doortracking = 0
  trackRect = sprite(the currentSpriteNum).undefined
  screenObject = new(script("screenObject"), me, trackRect, 0)
  addScreenObject(gDir, screenObject)
  activeClick = 1
  locked = 0
  missionIsOn = 0
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on mouseEnter(me)
  if not locked then
    if missionIsOn = 0 then
      if activeClick then
        if not doortracking then
          doortracking = 1
          play(gSound, "04e009v0", #EFFECT)
          sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
          sendSprite(115, #c_click)
        end if
      end if
    end if
  end if
  exit
end

on prepareFrame(me)
  if not locked then
    if missionIsOn = 0 then
      if doortracking then
        if not inside(point(the mouseH, the mouseV), trackRect) then
          sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
          play(gSound, "04e010v0", #EFFECT)
          sendSprite(115, #C_Standard)
          doortracking = 0
        end if
      end if
    end if
  end if
  exit
end

on showMail(me)
  sprite(me.spriteNum).undefined = "02b005v0"
  missionIsOn = 1
  exit
end

on mouseUp(me)
  if activeClick then
    if not locked then
      if missionIsOn = 1 then
        sendAllSprites(#activateClick, 0)
        if gDir.carOnYard = 0 then
          sendSprite(getaProp(gDir.spriteList, #mulleStand), #MakeMulleSpeak, #Mail)
        else
          sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #Mail)
        end if
        missionIsOn = 0
      end if
    end if
  end if
  exit
end

on report(me, theObject, what)
  if activeClick then
    if not locked then
      if what = #clicked then
        if missionIsOn = 0 then
          if gDir.carOnYard = 0 then
            if sprite(getaProp(gDir.spriteList, #mulleStand)).mode = #wait then
              sendSprite(getaProp(gDir.spriteList, #mulleStand), #MakeMulleSpeak, #noMail)
            end if
          else
            if sprite(getaProp(gDir.spriteList, #mulleInCar)).mode = #wait then
              sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #noMail)
            end if
          end if
        end if
      end if
    end if
  end if
  exit
end