on new(me, theReportObject)
  tracking = 0
  reportObject = theReportObject
  chassisNr = gDir.carCopy.chassisSPOffset
  carOffset = sprite(getProp(gDir.spriteList, #CarStart) + chassisNr).undefined
  return(me)
  exit
end

on grabbedPart(me, thePartId)
  tracking = 1
  put("in grabbpart")
  sendAllSprites(#forcePart)
  removeJunkPart(gMulleGlobals.user, #yard, thePartId)
  sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk)
  sendSprite(getProp(gDir.spriteList, #drag), #startDrag, thePartId, "floor", 0)
  exit
end

on letGoOfPart(me, thePartId, where, onDoorWhere)
  if symbolp(where) then
    if getaProp(gMulleGlobals.junkPileHandlers.maxParts, #shopFloor) <= count(getaProp(getaProp(gMulleGlobals.user, #junk), #shopFloor)) then
      if gDir.carOnYard then
        sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #shopFull)
      else
        sendSprite(getaProp(gDir.spriteList, #mulleStand), #MakeMulleSpeak, #shopFull)
      end if
      addJunkPart(gMulleGlobals.user, #yard, thePartId, onDoorWhere)
    else
      kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #ExternalGround)
      addJunkPart(gMulleGlobals.user, #shopFloor, thePartId)
      sendSprite(115, #C_Right)
    end if
  else
    tmp = checkPos(me, thePartId, where)
    if tmp = 1 then
      put("kick tmppos= TRUE")
      kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #InternalGround)
    end if
    if getAt(where, 2) > getAt(getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1), 4) then
      addJunkPart(gMulleGlobals.user, #yard, thePartId)
      put("kick 22")
      kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #InternalGround)
      isFalling = 0
    else
      addJunkPart(gMulleGlobals.user, #yard, thePartId, where)
    end if
  end if
  sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk)
  tracking = 0
  exit
end

on checkPos(me, thePartId, thePartLoc)
  partId = thePartId
  part = getPart(gMulleGlobals.parts, partId)
  showMember = getJunkView(part)
  checkRect = getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1)
  tempLocH = getAt(thePartLoc, 1)
  if tempLocH > 640 then
    tempLocH = 640
  end if
  tempOffsetV = getAt(member(showMember).rect, 4) / 2
  floorLocV = 460 - tempOffsetV
  tempLocV = getAt(thePartLoc, 2)
  if not inside(thePartLoc, getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #yard), 1)) then
    r = 0
  else
    r = 1
  end if
  return(r)
  exit
end

on freeOrBindParts(me)
  freeParts = []
  boundParts = []
  parts = getParts(gDir.carCopy)
  n = 2
  repeat while n <= count(parts)
    part = getPart(gMulleGlobals.parts, getAt(parts, n))
    newPoints = getNewPoints(part)
    if listp(newPoints) then
      tempList = []
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        add(tempList, getAt(index, 1))
      end repeat
      -- UNK_65 3
      if areTheseFree(gDir.carCopy, tempList) then
        add(freeParts, part)
      else
        add(boundParts, part)
      end if
    else
      add(freeParts, part)
    end if
    n = 1 + n
  end repeat
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    snapPoint = getAt(getCoveredPoints(index), 1)
    layer = getAt(getSnapInfo(gDir.carCopy, snapPoint, #layers), 1)
    if layer > 0 then
      sendSprite(getProp(gDir.spriteList, #CarStart) + layer, #activate, 1)
    end if
  end repeat
  -- UNK_65 3
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    snapPoint = getAt(getCoveredPoints(index), 1)
    layer = getAt(getSnapInfo(gDir.carCopy, snapPoint, #layers), 1)
    if layer > 0 then
      sendSprite(getProp(gDir.spriteList, #CarStart) + layer, #activate, 0)
    end if
  end repeat
  -- UNK_65 3
  exit
end

on kill(me)
  return(0)
  exit
end