on beginSprite(me)
  if gMulleGlobals.WhereFrom = "04" or gMulleGlobals.WhereFrom = "03" and gMulleGlobals.user.nrOfBuiltCars < 4 then
    ShowOff = new(script("ShowCarDriving"))
    init(ShowOff)
    SP = getProp(gDir.spriteList, #ShowOff)
    keyList = [#left:["05b003v0", "05b004v0"], #right:["05b007v0", "05b008v0"], #up:["05b001v0", "05b002v0"], #down:["05b005v0", "05b006v0"]]
    n = 1
    repeat while n <= 4
      sprite(SP + n).undefined = member(getAt(getAt(keyList, n), 1))
      n = 1 + n
    end repeat
    sprite(SP + 1).undefined = point(260, 240)
    sprite(SP + 2).undefined = point(380, 240)
    sprite(SP + 3).undefined = point(320, 190)
    sprite(SP + 4).undefined = point(320, 240)
    actionList = [0, 0, 0, [#Accelerate:1], 0, 0, 0, 0, [#Accelerate:0], 0, 0, 0, 0, [#Accelerate:-1], 0, 0, 0, 0, 0, [#Accelerate:0], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, [#Accelerate:-1], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, [#Accelerate:0], 0, 0, 0, 0, 0, 0, 0, 0, 0, [#Accelerate:1], 0, 0, 0, 0, [#Accelerate:0], [#stop:1], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, [#steer:1], 0, 0, 0, 0, 0, [#steer:0], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, [#steer:-1], 0, 0, 0, 0, 0, [#steer:0], 0, 0, 0, 0, 0, 0, 0, 0, 0]
    counter = 0
    if the machineType = 256 then
      delayList = [0, 0, 0, 0, 0, 0, 0, 0, 0]
    else
      delayList = [0]
    end if
    Active = 1
    sprite(SP).undefined = member("Platta")
    sprite(SP).undefined = point(320, 220)
    waitAndKill = 0
  else
    Active = 1
    waitAndKill = 1
  end if
  exit
end

on kill(me)
  if objectp(ShowOff) then
    sprite(SP).undefined = member("Dummy")
    sprite(SP + 1).undefined = member("Dummy")
    sprite(SP + 2).undefined = member("Dummy")
    sprite(SP + 3).undefined = member("Dummy")
    sprite(SP + 4).undefined = member("Dummy")
    ShowOff = kill(ShowOff)
  end if
  setProp(gDir.spriteList, #car, getProp(gDir.spriteList, #RealCar))
  startCar(gDir)
  Active = 0
  exit
end

on mouseUp(me)
  waitAndKill = 1
  exit
end

on fakeMouse(me)
  waitAndKill = 1
  exit
end

on exitFrame(me)
  if Active then
    if waitAndKill then
      kill(me)
      exit
    end if
    counter = counter + 1
    tempList = getAt(actionList, counter)
    doIt(me, tempList)
    if counter = count(actionList) then
      counter = 0
    end if
  end if
  exit
end

on doIt(me, tempList)
  add(delayList, tempList)
  deleteAt(delayList, 1)
  if listp(tempList) then
    n = 1
    repeat while n <= count(tempList)
      -- UNK_64 0
      if ERROR = #steer then
        Dir = getAt(tempList, n)
        if Dir then
          play(gSound, "P38ef005", #EFFECT)
        end if
      else
        -- UNK_64 0
        if ERROR = #Accelerate then
          acc = getAt(tempList, n)
          if acc then
            play(gSound, "P38ef005", #EFFECT)
          end if
        end if
      end if
      -- UNK_65 1
      n = 1 + n
    end repeat
  end if
  memberChange(me, getAt(delayList, 1))
  exit
end

on memberChange(me, tempList)
  if listp(tempList) then
    n = 1
    repeat while n <= count(tempList)
      -- UNK_64 0
      if ERROR = #stop then
        setSpeed(ShowOff, 0)
      else
        -- UNK_64 0
        if ERROR = #steer then
          Dir = getAt(tempList, n)
          steer(ShowOff, Dir)
          if Dir = 1 then
            sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 2))
            sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 1))
          else
            if Dir = -1 then
              sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 2))
              sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 1))
            else
              sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 1))
              sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 1))
            end if
          end if
        else
          -- UNK_64 0
          if ERROR = #Accelerate then
            acc = getAt(tempList, n)
            changeSpeed(ShowOff, acc)
            if acc = 1 then
              sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 2))
              sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 1))
            else
              if acc = -1 then
                sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 2))
                sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 1))
              else
                sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 1))
                sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 1))
              end if
            end if
          end if
        end if
      end if
      -- UNK_65 1
      n = 1 + n
    end repeat
  end if
  exit
end

on ZZdoIt(me, tempList)
  add(delayList, tempList)
  deleteAt(delayList, 1)
  if listp(tempList) then
    n = 1
    repeat while n <= count(tempList)
      -- UNK_64 0
      if ERROR = #stop then
        setSpeed(ShowOff, 0)
      else
        -- UNK_64 0
        if ERROR = #steer then
          Dir = getAt(tempList, n)
          steer(ShowOff, Dir)
          if Dir = 1 then
            play(gSound, "P38ef005", #EFFECT)
            sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 2))
            sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 1))
          else
            if Dir = -1 then
              play(gSound, "P38ef005", #EFFECT)
              sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 2))
              sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 1))
            else
              play(gSound, "P38ef006", #EFFECT)
              sprite(SP + 2).undefined = member(getAt(getProp(keyList, #right), 1))
              sprite(SP + 1).undefined = member(getAt(getProp(keyList, #left), 1))
            end if
          end if
        else
          -- UNK_64 0
          if ERROR = #Accelerate then
            acc = getAt(tempList, n)
            changeSpeed(ShowOff, acc)
            if acc = 1 then
              play(gSound, "P38ef005", #EFFECT)
              sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 2))
              sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 1))
            else
              if acc = -1 then
                play(gSound, "P38ef005", #EFFECT)
                sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 2))
                sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 1))
              else
                play(gSound, "P38ef006", #EFFECT)
                sprite(SP + 3).undefined = member(getAt(getProp(keyList, #up), 1))
                sprite(SP + 4).undefined = member(getAt(getProp(keyList, #down), 1))
              end if
            end if
          end if
        end if
      end if
      -- UNK_65 1
      n = 1 + n
    end repeat
  end if
  memberChange(me, tempList)
  exit
end