on beginSprite(me)
  SP = me.spriteNum
  nrOfSteps = 13
  firstMember = sprite(0).number
  mode = #normal
  exit
end

on init(me)
  updateFuelMeter(me)
  addLoopObject(gDir, me)
  mode = #normal
  exit
end

on updateFuelMeter(me)
  tempGas = getaProp(gDir.carDriving.quickCarProps, #FuelVolume)
  tempElec = getaProp(gDir.carDriving.quickCarProps, #ElectricVolume)
  gotElectricEngine = gDir.carDriving.gotElectricEngine
  gotCombustionEngine = not getaProp(gDir.carDriving.quickCarProps, #FuelConsumption) = 0
  maxFuel = 0
  if gotElectricEngine then
    maxFuel = maxFuel + tempElec
  end if
  if gotCombustionEngine then
    maxFuel = maxFuel + tempGas
  end if
  if maxFuel = 0 then
    maxFuel = 1
  else
    sprite(SP).undefined = member(firstMember + nrOfSteps - 1)
  end if
  exit
end

on loop(me)
  if gDir.mode = #Driving then
    if mode = #normal then
      percentElec = 0
      percentComb = 0
      if gotElectricEngine then
        percentElec = 100 * getAt(getFuel(gDir.carDriving), 2)
      end if
      if gotCombustionEngine then
        percentComb = 100 * getAt(getFuel(gDir.carDriving), 1)
      end if
      percent = percentElec + percentComb / maxFuel
      if percent > 0 then
        if percent = 100 then
          percent = 99
        end if
        nr = percent * nrOfSteps / 100
        sprite(SP).undefined = member(firstMember + nr)
      else
        sprite(SP).undefined = member(firstMember)
      end if
    else
      if mode = #Filling then
        if wait then
          wait = wait - 1
        else
          sprite(SP).undefined = member(firstMember + nr / 10)
          nr = nr + 5
          if nr / 10 > nrOfSteps + fillMax then
            mode = #normal
          end if
        end if
      end if
    end if
  end if
  exit
end

on fillErUp(me, xtra)
  mode = #Filling
  wait = 20
  nr = nr * 10
  if xtra > 0 then
    fillMax = 3
  else
    fillMax = 0
  end if
  exit
end