on new(me)
  nrOfDirections = 16
  return(me)
  exit
end

on kill(me)
  return(0)
  exit
end

on calcDirection(me, theStart, theEnd, option)
  diffX = getAt(theEnd, 1) - getAt(theStart, 1)
  diffY = getAt(theStart, 2) - getAt(theEnd, 2)
  hypo = sqrt(diffX * diffX + diffY * diffY)
  if diffY = 0 then
    diffY = 0.1
  end if
  tempDirection = atan(diffX / float(diffY))
  if diffX > 0 then
    if diffY > 0 then
      nothing()
    else
      tempDirection = tempDirection + pi()
    end if
  else
    if diffY > 0 then
      tempDirection = tempDirection + 2 * pi()
    else
      tempDirection = tempDirection + pi()
    end if
  end if
  tempDirection = tempDirection / pi()
  tempDirection = integer(tempDirection * nrOfDirections / 2)
  if tempDirection = 0 then
    tempDirection = nrOfDirections
  end if
  if option = #WithHypo then
    return([tempDirection, hypo])
  end if
  return(tempDirection)
  exit
end

on checkRadius(me, reportObject, carLoc, myLoc, option)
  tempDiff = carLoc - myLoc
  tempH = getAt(tempDiff, 1)
  tempV = getAt(tempDiff, 2)
  hypo = sqrt(tempH * tempH + tempV * tempV)
  if voidp(option) or option = #both then
    if hypo <= reportObject.OuterRadius then
      if hypo <= reportObject.InnerRadius then
        if not reportObject.insideInner then
          reportObject.insideInner = 1
          if reportObject.insideOuter then
            return(#EnterInnerRadius)
          else
            reportObject.insideOuter = 1
            return(#EnterBoth)
          end if
        end if
      else
        if not reportObject.insideOuter then
          reportObject.insideOuter = 1
          return(#enterOuterRadius)
        end if
        if reportObject.insideInner then
          reportObject.insideInner = 0
          return(#ExitInnerRadius)
        end if
      end if
    else
      if reportObject.insideOuter then
        reportObject.insideOuter = 0
        if reportObject.insideInner then
          reportObject.insideInner = 0
          return(#ExitBoth)
        else
          return(#ExitOuterRadius)
        end if
      end if
    end if
  else
    if option = #Inner then
      if hypo <= reportObject.InnerRadius then
        if not reportObject.insideInner then
          reportObject.insideInner = 1
          return(#EnterInnerRadius)
        end if
      else
        if reportObject.insideInner then
          reportObject.insideInner = 0
          return(#ExitInnerRadius)
        end if
      end if
    else
      if option = #Outer then
        if hypo <= reportObject.OuterRadius then
          if not reportObject.insideOuter then
            reportObject.insideOuter = 1
            return(#enterOuterRadius)
          end if
        else
          if reportObject.insideOuter then
            reportObject.insideOuter = 0
            return(#ExitOuterRadius)
          end if
        end if
      end if
    end if
  end if
  return(0)
  exit
end

on correctDirection(me, theDir)
  if theDir > nrOfDirections then
    return(theDir - nrOfDirections)
  else
    if theDir < 1 then
      return(theDir + nrOfDirections)
    end if
  end if
  return(theDir)
  exit
end

on updateEngine(me, what)
  parts = getParts(gMulleGlobals.user.car)
  carProperties = [#speed:0, #Strength:0, #EngineType:0]
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    if getProperty(part, #Strength) > 0 then
      elecCons = getProperty(part, #ElectricConsumption)
      gasCons = getProperty(part, #FuelConsumption)
      if not elecCons > 0 and what = #NoElectricity and not gasCons > 0 and what = #NoGas and not gasCons > 0 or elecCons > 0 and what = #NoFuel then
        if getProperty(part, #speed) > getaProp(carProperties, #speed) then
          setProp(carProperties, #speed, getProperty(part, #speed))
        end if
        setProp(carProperties, #Strength, getaProp(carProperties, #Strength) + getProperty(part, #Strength))
        if getProperty(part, #EngineType) > getaProp(carProperties, #EngineType) then
          setProp(carProperties, #EngineType, getProperty(part, #EngineType))
        end if
      end if
    end if
  end repeat
  -- UNK_65 3
  setProp(gMulleGlobals.user.car.carProperties, #speed, getProp(carProperties, #speed))
  setProp(gMulleGlobals.user.car.carProperties, #Strength, getProp(carProperties, #Strength))
  setProp(gMulleGlobals.user.car.carProperties, #EngineType, getProp(carProperties, #EngineType))
  exit
end