on beginSprite(me)
  play(gSound, "18d001v0", #EFFECT)
  postSP = 2
  maxSigns = 6
  middleLoc = point(200, 150)
  mode = #Still
  width = sprite(me.spriteNum).width
  steps = 10
  cpList = []
  n = 1
  repeat while n <= maxSigns
    add(cpList, n)
    n = 1 + n
  end repeat
  if objectp(gMulleGlobals) and 1 then
    gTheseAreTheWorlds = []
    tempObj = new(script("World"))
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      if fromList(tempObj, index) then
        tempId = getId(tempObj)
        tempSign = getPosition(tempObj)
        addProp(gTheseAreTheWorlds, tempSign, tempId)
      end if
    end repeat
    -- UNK_65 3
  else
    gTheseAreTheWorlds = [1:"World1", 2:"World2", 3:"World3", 4:"World4", 5:"World5", 6:"World6", 1:"World3", 3:"World4", 1:"World4"]
  end if
  calcPosts(me)
  exit
end

on calcPosts(me)
  postList = []
  tempObj = new(script("World"))
  n = 1
  repeat while n <= count(gTheseAreTheWorlds)
    nr = getPropAt(gTheseAreTheWorlds, n)
    id = getAt(gTheseAreTheWorlds, n)
    if fromList(tempObj, id) then
      memb = getSymbol(tempObj)
    else
      memb = id
    end if
    foundPlace = 0
    m = 1
    repeat while m <= count(postList)
      tempList = getAt(postList, m)
      if voidp(getaProp(tempList, nr)) then
        addProp(tempList, nr, [#id:id, #member:memb])
        foundPlace = 1
      else
        m = 1 + m
      end if
    end repeat
    if not foundPlace then
      temp = []
      addProp(temp, nr, [#id:id, #member:memb])
      add(postList, temp)
    end if
    n = 1 + n
  end repeat
  nrOfPosts = count(postList)
  lookinAtPost = 1
  prepareDraw(me)
  draw(me)
  drawArrows(me)
  exit
end

on scroll(me, rightLeft)
  if rightLeft = 1 then
    lookinAtPost = lookinAtPost + 1
    if lookinAtPost > nrOfPosts then
      lookinAtPost = nrOfPosts
    else
      prepareDraw(me, rightLeft)
      mode = #right
    end if
  else
    lookinAtPost = lookinAtPost - 1
    if lookinAtPost < 1 then
      lookinAtPost = 1
    else
      prepareDraw(me, rightLeft)
      mode = #left
    end if
  end if
  drawArrows(me)
  counter = 0
  exit
end

on exitFrame(me)
  if not mode = #Still then
    counter = counter + 1
    if counter = steps + 1 then
      mode = #Still
    end if
    if mode = #right then
      draw(me, 1, steps - counter * width / steps)
    else
      if mode = #left then
        draw(me, -1, -steps - counter * width / steps)
      end if
    end if
  end if
  exit
end

on prepareDraw(me, rightLeft)
  tempStartSP = postSP
  usedSprites = []
  isTwo = 2
  if nrOfPosts = 1 then
    isTwo = 1
  end if
  x = 1
  repeat while x <= isTwo
    freeSprites = duplicate(cpList)
    tempList = getAt(postList, lookinAtPost + x - 1 * -rightLeft)
    tempUsed = []
    n = 1
    repeat while n <= count(tempList)
      tempSP = getPropAt(tempList, n)
      deleteOne(freeSprites, tempSP)
      add(tempUsed, tempSP)
      tempSP = tempSP + tempStartSP
      sprite(tempSP).undefined = member(getProp(getAt(tempList, n), #member))
      sprite(tempSP).locH = -4711
      n = 1 + n
    end repeat
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      tempSP = index + tempStartSP
      sprite(tempSP).undefined = member("Dummy")
    end repeat
    -- UNK_65 3
    tempStartSP = postSP + maxSigns + 1
    add(usedSprites, duplicate(tempUsed))
    x = 1 + x
  end repeat
  exit
end

on draw(me, rightLeft, theOffsetH)
  if voidp(theOffsetH) then
    theOffsetH = 0
  end if
  if voidp(rightLeft) then
    rightLeft = -1
  end if
  tempStartSP = postSP
  isTwo = 2
  if nrOfPosts = 1 then
    isTwo = 1
  end if
  x = 1
  repeat while x <= isTwo
    sprite(tempStartSP).undefined = member("18b005v0")
    sprite(tempStartSP).undefined = middleLoc + point(theOffsetH, 0)
    tempList = getAt(postList, lookinAtPost + x - 1 * -rightLeft)
    n = 1
    repeat while n <= count(tempList)
      tempSP = getPropAt(tempList, n) + tempStartSP
      sprite(tempSP).undefined = middleLoc + point(theOffsetH, 0)
      n = 1 + n
    end repeat
    tempStartSP = postSP + maxSigns + 1
    theOffsetH = theOffsetH - width * rightLeft
    x = 1 + x
  end repeat
  exit
end

on drawArrows(me)
  tempLeft = 18
  tempRight = 17
  if nrOfPosts > 1 then
    if lookinAtPost > 1 then
      sprite(tempLeft).undefined = member("18b003v0")
    else
      sprite(tempLeft).undefined = member("Dummy")
    end if
    if lookinAtPost < nrOfPosts then
      sprite(tempRight).undefined = member("18b004v0")
    else
      sprite(tempRight).undefined = member("Dummy")
    end if
  else
    sprite(tempLeft).undefined = member("Dummy")
    sprite(tempRight).undefined = member("Dummy")
  end if
  exit
end

on choseWorld(me, theName)
  foundIt = 0
  if stringp(theName) then
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      aList = getAt()
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        bList = getAt()
        if getProp(bList, #member) = theName then
          foundIt = getProp(bList, #id)
        else
        end if
      end repeat
      -- UNK_65 3
      if stringp(foundIt) then
      else
      end if
    end repeat
    -- UNK_65 3
  end if
  if objectp(gDir) then
    cursor(200)
    choseWorld(gDir, foundIt)
    cursor(200)
    gMulleGlobals.worlds.activeWorld = foundIt
    cursor(-1)
    cursor(200)
  else
    put(foundIt)
  end if
  exit
end