on new(me)
  myMarker = "JustDoIt"
  spriteList = [#CarStart:35]
  tempCar = new(script("DrawCar"), 1)
  drawCar(tempCar, getProp(spriteList, #CarStart))
  tempCar = 0
  return(me)
  exit
end

on init(me)
  testing = 0
  if objectp(gMulleGlobals.world) then
    objId = getEnteredObject(gMulleGlobals.world)
  else
    objId = 0
  end if
  if objId then
    tempObj = new(script("Object"))
    fromList(tempObj, objId)
    cacheToCheck = getAt(getCheckFor(tempObj, #Cache), 1)
    partToGive = getAt(getSetWhenDone(tempObj, #parts), 1)
    mission = getAt(getSetWhenDone(tempObj, #missions), 1)
    tempObj = 0
  else
    testing = 1
    cacheToCheck = #Lemonade
    partToGive = 121
    mission = 3
  end if
  myMarker = the frame
  if not testing then
    if isMissionCompleted(gMulleGlobals.user, mission) or not findPart(gMulleGlobals.user, partToGive) = 0 then
      myMarker = "Done"
    else
      if not getCacheProp(gMulleGlobals.user.car, cacheToCheck) = #NoProp then
        addJunkPart(gMulleGlobals.user, #yard, partToGive)
        addCompletedMission(gMulleGlobals.user, mission)
        myMarker = "JustDoIt"
      else
        myMarker = "CantDoIt"
        sprite(1).undefined = member("88b002v0")
      end if
    end if
  end if
  exit
end

on startMovie(me)
  sendSprite(115, #C_Standard)
  go(myMarker)
  exit
end

on getPartToGive(me)
  return(partToGive)
  exit
end

on kill(me)
  return(0)
  exit
end