on new(me, theChild)
  child = theChild
  sndId = 0
  insideInner = 0
  insideOuter = 0
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  if getProperty(gMulleGlobals.user.car, #HornType) <> 0 then
    allowed = 1
  else
    allowed = 0
  end if
  FrameList = getProp(getFrameList(child), #normal)
  listLen = count(FrameList)
  SP = child.SPUnder
  sprite(SP).name = member(getAt(FrameList, 1))
  sprite(SP).position = child.myLoc
  counter = 0
  exit
end

on step(me, carLoc)
  counter = counter + 1
  if counter > listLen then
    if mode = #Parting then
      setFrames(me, #Outer)
    else
      if mode = #Gathering then
        setFrames(me, #normal)
      else
        counter = 1
      end if
    end if
  end if
  sprite(SP).name = member(getAt(FrameList, counter))
  temp = checkRadius(gDir.drivingHandlers, me, carLoc, child.myLoc, #both)
  -- UNK_64 0
  if ERROR = #EnterInnerRadius then
    EnterInnerRadius(me)
  else
    -- UNK_64 0
    if ERROR = #ExitInnerRadius then
      ExitInnerRadius(me)
    else
      -- UNK_64 0
      if ERROR = #enterOuterRadius then
        enterOuterRadius(me)
      else
        -- UNK_64 0
        if ERROR = #ExitOuterRadius then
          ExitOuterRadius(me)
        else
          -- UNK_64 0
          if ERROR = #EnterBoth then
            enterOuterRadius(me)
            EnterInnerRadius(me)
          else
            -- UNK_64 0
            if ERROR = #ExitBoth then
              ExitInnerRadius(me)
              ExitOuterRadius(me)
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  exit
end

on enterOuterRadius(me)
  opSndId = play(gSound, getAt(child.sounds, 2), #OPEFFECT)
  exit
end

on ExitOuterRadius(me)
  stop(gSound, opSndId)
  exit
end

on EnterInnerRadius(me)
  if allowed then
    setFrames(me, #Parting)
    sndId = play(gSound, gDir.carDriving.hornSound, #EFFECT)
  else
    if finished(gSound, sndId) then
      sndId = play(gSound, getAt(child.sounds, 1), #EFFECT)
    end if
    setSpeed(gDir.carDriving, 0)
    stepback(gDir.carDriving, 2)
    insideInner = 0
  end if
  exit
end

on ExitInnerRadius(me)
  if allowed then
    setFrames(me, #Gathering)
  end if
  exit
end

on setFrames(me, theMode)
  mode = theMode
  FrameList = getProp(getFrameList(child), mode)
  listLen = count(FrameList)
  sprite(SP).name = member(getAt(FrameList, 1))
  counter = 1
  exit
end