on new(me, theChild)
  child = theChild
  insideInner = 0
  carOnBoard = 0
  carCounter = 0
  carLeaving = 0
  waitCounter = 0
  decimalPrec = 100
  nrOfDirections = 16
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  sndId = 0
  FrameList = getProp(getFrameList(child), #normal)
  listLen = count(FrameList)
  back = -1
  sprite(child.SPUnder).name = member(getAt(FrameList, 1))
  tempEndLoc = getaProp(child.optionalData, #endLoc)
  if voidp(tempEndLoc) then
    tempEndLoc = point(0, 0)
  end if
  endLocs = [child.myLoc, tempEndLoc]
  myDirections = [calcDirection(gDir.drivingHandlers, getAt(endLocs, 1), getAt(endLocs, 2)), calcDirection(gDir.drivingHandlers, getAt(endLocs, 2), getAt(endLocs, 1))]
  myLoc = child.myLoc * decimalPrec
  tempSpeed = 5
  diff = getAt(endLocs, 2) - getAt(endLocs, 1)
  hypo = sqrt(getAt(diff, 1) * getAt(diff, 1) + getAt(diff, 2) * getAt(diff, 2))
  fact = hypo / float(tempSpeed)
  step = point(integer(decimalPrec * getAt(diff, 1) / fact), integer(decimalPrec * getAt(diff, 2) / fact))
  maxCounter = integer(fact)
  counter = random(maxCounter - 2) + 1
  back = integer(random(2) * 1.5 - 2)
  myLoc = myLoc + counter * step
  sprite(child.SPUnder).position = myLoc / decimalPrec
  if back = 1 then
    atStart = -1
    endLoc = getAt(endLocs, 2)
  else
    atStart = 1
    endLoc = getAt(endLocs, 1)
  end if
  tempProp = getAt(getCheckFor(child, #UserStuff), 1)
  if getUserProp(gMulleGlobals.user, tempProp) = #NoProp then
    Active = 0
  else
    Active = 1
  end if
  carWasntOnBoard = 1
  exit
end

on step(me, carLoc)
  if counter > maxCounter then
    counter = maxCounter
    waitCounter = 15
    back = -1
    if carOnBoard then
      carBoardInit(me, 1)
    else
      if carClose(me, carLoc) then
        carBoardInit(me, -1)
      end if
    end if
  else
    if counter < 0 then
      counter = 0
      waitCounter = 15
      back = 1
      if carOnBoard then
        carBoardInit(me, 1)
      else
        if carClose(me, carLoc) then
          carBoardInit(me, -1)
        end if
      end if
    else
      if counter = maxCounter / 2 then
        if back = 1 then
          endLoc = getAt(endLocs, 2)
          atStart = -1
        else
          endLoc = getAt(endLocs, 1)
          atStart = 1
        end if
      end if
    end if
  end if
  if waitCounter then
    waitCounter = waitCounter - 1
    if carOnBoard then
      carBoarding(me)
    else
      if carWasntOnBoard then
        if carClose(me, carLoc) then
          carBoardInit(me, -1)
          waitCounter = 15
        end if
      end if
    end if
    if waitCounter = 0 and not carOnBoard then
      carWasntOnBoard = 1
    end if
  else
    counter = counter + back
    myLoc = myLoc + step * back
    sprite(child.SPUnder).position = myLoc / decimalPrec
    if carOnBoard then
      setCoordinate(gDir.carDriving, myLoc / decimalPrec)
    end if
  end if
  exit
end

on carClose(me, carLoc)
  if Active then
    tempDiff = carLoc - myLoc / decimalPrec
    tempH = getAt(tempDiff, 1)
    tempV = getAt(tempDiff, 2)
    hypo = sqrt(tempH * tempH + tempV * tempV)
    if hypo < child.InnerRadius then
      return(1)
    end if
  else
    if finished(gSound, sndId) then
      tempDiff = carLoc - myLoc / decimalPrec
      tempH = getAt(tempDiff, 1)
      tempV = getAt(tempDiff, 2)
      hypo = sqrt(tempH * tempH + tempV * tempV)
      if hypo < child.InnerRadius then
        sndId = play(gSound, getAt(child.sounds, 1), #EFFECT)
      end if
    end if
  end if
  return(0)
  exit
end

on carBoardInit(me, theLeave)
  if Active then
    carLeaving = theLeave
    carOrgLoc = getCoordinate(gDir.carDriving)
    if carLeaving = -1 then
      carWasntOnBoard = 0
      carOnBoard = 1
      setDirection(gDir.carDriving, calcDirection(gDir.drivingHandlers, carOrgLoc, endLoc))
      carStep = endLoc - carOrgLoc * decimalPrec / 10
    else
      carStep = -step / 2 * atStart
    end if
  end if
  exit
end

on carBoarding(me)
  if carLeaving then
    carCounter = carCounter + 1
    setCoordinate(gDir.carDriving, carOrgLoc + carStep * carCounter / decimalPrec)
    if carCounter > 10 then
      if carLeaving = 1 then
        stop(gSound, sndId)
        programControl(gDir.carDriving, 0)
        carOnBoard = 0
      else
        play(gSound, getAt(child.sounds, 2), #EFFECT)
        sndId = play(gSound, getAt(child.sounds, 3), #EFFECT)
        programControl(gDir.carDriving, 1, #NoCheck)
        setDirection(gDir.carDriving, getAt(myDirections, integer(-atStart + 2 / 1.5)))
      end if
      carCounter = 0
      carLeaving = 0
    end if
  end if
  exit
end

on enterOuterRadius(me)
  exit
end

on ExitOuterRadius(me)
  exit
end

on EnterInnerRadius(me)
  exit
end

on ExitInnerRadius(me)
  exit
end