on new(me, theChild)
  child = theChild
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  hillType = getaProp(getOptionalData(child), #hillType)
  if not hillType = #BigHill then
    hillType = #SmallHill
  end if
  if getProp(gDir.carDriving.criteria, hillType) = 1 then
    OKToPass = 1
    medalId = getAt(getSetWhenDone(child, #medals), 1)
  else
    OKToPass = 0
  end if
  exit
end

on step(me, carLoc)
  temp = checkRadius(gDir.drivingHandlers, me, carLoc, child.myLoc, #both)
  -- UNK_64 0
  if ERROR = #enterOuterRadius then
    enterOuterRadius(me)
  else
    -- UNK_64 0
    if ERROR = #ExitOuterRadius then
      ExitOuterRadius(me)
    else
      -- UNK_64 0
      if ERROR = #EnterInnerRadius then
        EnterInnerRadius(me)
      else
        -- UNK_64 0
        if ERROR = #ExitInnerRadius then
          ExitInnerRadius(me)
        else
          -- UNK_64 0
          if ERROR = #EnterBoth then
            enterOuterRadius(me)
            EnterInnerRadius(me)
          else
            -- UNK_64 0
            if ERROR = #ExitBoth then
              ExitInnerRadius(me)
              ExitOuterRadius(me)
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  exit
end

on enterOuterRadius(me)
  saveData(gDir.carDriving, 1)
  exit
end

on ExitOuterRadius(me)
  saveData(gDir.carDriving, #none)
  exit
end

on ExitInnerRadius(me)
  exit
end

on EnterInnerRadius(me)
  if not OKToPass then
    if finished(gSound, sndId) then
      if hillType = #BigHill then
        sndId = play(gSound, getAt(child.sounds, 1), #EFFECT)
      else
        sndId = play(gSound, getAt(child.sounds, 2), #EFFECT)
      end if
    end if
    restoreData(gDir.carDriving)
    setSpeed(gDir.carDriving, 0)
  else
    if hillType = #BigHill then
      medalId = 1
      if not getMedal(gMulleGlobals.user.car, medalId) then
        addMedal(gMulleGlobals.user.car, medalId)
        sendSprite(getProp(gDir.spriteList, #medal), #Blink, medalId)
      end if
    end if
  end if
  exit
end