on beginSprite(me)
  if waitFrames = "sound" then
    waitFrames = #sound
  else
    waitFrames = value(waitFrames)
  end if
  if waitFrames = 0 then
    waitFrames = 9999
  end if
  if length(soundName) then
    sndId = play(gSound, soundName, #OPEFFECT)
  end if
  if id = "Auto" then
    isPart = 1
    id = getPartToGive(gDir)
  end if
  if isPart then
    part = getPart(gMulleGlobals.parts, id)
    id = getJunkView(part)
  end if
  isOn = 1
  SP = me.spriteNum
  tempHeight = getAt(member(id).rect, 4)
  if isPart then
    sprite(SP).position = sprite(SP).position - point(0, tempHeight / 2)
  end if
  sprite(SP).name = member(id)
  counter = 0
  Active = 1
  exit
end

on exitFrame(me)
  if Active then
    counter = counter + 1
    if freq then
      if counter mod freq = 0 then
        if isOn then
          isOn = 0
          sprite(SP).name = member("dummy")
        else
          if repeatSound then
            sndId = play(gSound, soundName, #OPEFFECT)
          end if
          isOn = 1
          sprite(SP).name = member(id)
        end if
      end if
    end if
    if waitFrames = #sound then
      if finished(gSound, sndId) then
        sprite(SP).name = member("dummy")
        doTheWhat(me)
      end if
    else
      if counter = waitFrames then
        doTheWhat(me)
      end if
    end if
  end if
  exit
end

on doTheWhat(me)
  Active = 0
  if doWhat = #GoNextFrame then
    go(the frame + 1)
  else
    if doWhat = #GoNextMarker then
      go(#next)
    end if
  end if
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#isPart:[#comment:"Is it a part:", #format:#boolean, #default:1], #id:[#comment:"PartId, 'Auto' or resource name:", #format:#string, #default:"Auto"], #freq:[#comment:"Frequency, frames per blink:", #format:#integer, #default:2], #waitFrames:[#comment:"Wait nr of frames (or Sound):", #format:#string, #default:""], #doWhat:[#comment:"Then:", #format:#symbol, #range:[#none, #GoNextFrame, #GoNextMarker], #default:#none], #soundName:[#comment:"Play sound:", #format:#string, #default:""], #repeatSound:[#comment:"Repeat sound every blink:", #format:#boolean, #default:0]]
  return(p_list)
  exit
end