on new(me)
  partId = 0
  MorphsTo = []
  junkView = ""
  UseView = ""
  UseView2 = ""
  description = ""
  offset = point(0, 0)
  partProperties = []
  requiredPoints = ""
  coveredPoints = []
  newPoints = []
  morphList = []
  master = 0
  return(me)
  exit
end

on kill(me)
  partProperties = 0
  requiredPoints = 0
  coveredPoints = 0
  newPoints = 0
  morphList = 0
  return(0)
  exit
end

on getId(me)
  return(partId)
  exit
end

on getJunkView(me)
  return(junkView)
  exit
end

on getHeight(me)
  return(member(junkView).height / 2)
  exit
end

on getWidth(me)
  return(member(junkView).width / 2)
  exit
end

on getUseView(me)
  return(UseView)
  exit
end

on getUseView2(me)
  return(UseView2)
  exit
end

on getDescription(me)
  return(description)
  exit
end

on getOffset(me)
  return(offset)
  exit
end

on getRequiredPoints(me)
  return(requiredPoints)
  exit
end

on getCoveredPoints(me)
  return(coveredPoints)
  exit
end

on getNewPoints(me)
  return(newPoints)
  exit
end

on getMorphList(me)
  return(morphList)
  exit
end

on getMaster(me)
  return(master)
  exit
end

on isMaster(me)
  return(master <> 0)
  exit
end

on isMorphPart(me)
  return(listp(morphList))
  exit
end

on isNormalpart(me)
  return(master = 0 and not listp(morphList))
  exit
end

on getProperty(me, prop)
  return(getaProp(partProperties, prop))
  exit
end

on toList(me)
  return([#partId:partId, #junkView:junkView, #UseView:UseView, #UseView2:UseView2, #description:description, #offset:offset, #partProperties:partProperties, #requiredPoints:requiredPoints, #coveredPoints:coveredPoints, #newPoints:newPoints, #morphList:morphList, #master:master])
  exit
end

on fromList(me, theid)
  memberName = "Part" & string(theid) & "DB"
  if sprite(0).number = -1 then
    alert(memberName & " not found!")
    stop()
    return(0)
  end if
  objectList = value(member(memberName).text)
  partId = getaProp(objectList, #partId)
  master = getaProp(objectList, #master)
  morphList = getaProp(objectList, #MorphsTo)
  description = getaProp(objectList, #description)
  junkView = getaProp(objectList, #junkView)
  UseView = getaProp(objectList, #UseView)
  UseView2 = getaProp(objectList, #UseView2)
  offset = getaProp(objectList, #offset)
  partProperties = getaProp(objectList, #Properties)
  requiredPoints = getaProp(objectList, #Requires)
  coveredPoints = getaProp(objectList, #Covers)
  newPoints = getaProp(objectList, #new)
  return(1)
  exit
end

on import(me, fileName)
  exit
end