on new(me)
  WorldId = ""
  map = []
  symbol = ""
  StartMap = point(0, 0)
  StartCoordinate = point(0, 0)
  StartDirection = 0
  enteredObjectId = 0
  rDests = []
  allRDests = []
  symbolPosition = 0
  return(me)
  exit
end

on kill(me)
  map = 0
  return(0)
  exit
end

on getId(me)
  return(WorldId)
  exit
end

on getPosition(me)
  return(symbolPosition)
  exit
end

on enteredObject(me, theid)
  enteredObjectId = theid
  exit
end

on getEnteredObject(me, theid)
  return(enteredObjectId)
  exit
end

on getStartInfo(me)
  return([#map:StartMap, #coordinate:StartCoordinate, #direction:StartDirection, #fuel:#Full])
  exit
end

on getSymbol(me)
  return(symbol)
  exit
end

on getCurrentMapId(me)
  tempY = getAt(currentMap, 2)
  if tempY >= 1 and tempY <= count(map) then
    tempList = getAt(map, tempY)
  else
    return(#InvalidYIndex)
  end if
  tempX = getAt(currentMap, 1)
  if tempX >= 1 and tempX <= count(tempList) then
    return(getAt(tempList, tempX))
  else
    return(#InvalidXIndex)
  end if
  exit
end

on getNewMapId(me, thePoint, theMode, theJustCheck)
  if theMode = #Relational then
    thePoint = thePoint + currentMap
  end if
  if getAt(thePoint, 2) >= 1 and getAt(thePoint, 2) <= count(map) then
    tempList = getAt(map, getAt(thePoint, 2))
  else
    return(#InvalidYIndex)
  end if
  if getAt(thePoint, 1) >= 1 and getAt(thePoint, 1) <= count(tempList) then
    if not theJustCheck = 1 then
      currentMap = thePoint
    end if
    return(getAt(tempList, getAt(thePoint, 1)))
  else
    return(#InvalidXIndex)
  end if
  exit
end

on calcRandomDestinations(me)
  tempMap = new(script("Map"))
  tempObj = new(script("Object"))
  allRDests = []
  y = 1
  repeat while y <= count(map)
    yArray = getAt(map, y)
    x = 1
    repeat while x <= count(yArray)
      MapId = getAt(yArray, x)
      fromList(tempMap, MapId)
      tempObjects = getObjects(tempMap)
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        tempObjId = getAt(index, 1)
        if fromList(tempObj, tempObjId) then
          tempType = getType(tempObj)
          if tempType = #rdest then
            tempProp = getaProp(allRDests, tempObjId)
            if voidp(tempProp) then
              addProp(allRDests, tempObjId, [point(x, y)])
            else
              add(tempProp, point(x, y))
              setProp(allRDests, tempObjId, tempProp)
            end if
          end if
        end if
      end repeat
      -- UNK_65 3
      x = 1 + x
    end repeat
    y = 1 + y
  end repeat
  exit
end

on randomizeDestinations(me)
  rDests = []
  n = 1
  repeat while n <= count(allRDests)
    tempDest = getAt(allRDests, n)
    tempNrOfMaps = count(tempDest)
    tempMap = random(tempNrOfMaps)
    addProp(rDests, getPropAt(allRDests, n), getAt(tempDest, tempMap))
    n = 1 + n
  end repeat
  exit
end

on getRandomDestinations(me)
  return(rDests)
  exit
end

on toList(me)
  return([#WorldId:WorldId, #map:map, #symbol:symbol, #StartMap:StartMap, #StartCoordinate:StartCoordinate, #StartDirection:StartDirection, #symbolPosition:symbolPosition])
  exit
end

on fromList(me, theid)
  memberName = "World" & theid & "DB"
  if sprite(0).number = -1 then
    alert(memberName & " not found!")
    return(0)
  end if
  objectList = value(member(memberName).text)
  WorldId = getaProp(objectList, #WorldId)
  map = getaProp(objectList, #map)
  symbol = getaProp(objectList, #symbol)
  StartMap = getaProp(objectList, #StartMap)
  currentMap = StartMap
  StartCoordinate = getaProp(objectList, #StartCoordinate)
  StartDirection = getaProp(objectList, #StartDirection)
  symbolPosition = getaProp(objectList, #symbolPosition)
  return(1)
  exit
end