on new(me)
  worlds = []
  activeWorld = 0
  lastWorld = 0
  return(me)
  exit
end

on kill(me)
  worlds = 0
  return(0)
  exit
end

on nrOfWorlds(me)
  return(count(worlds))
  exit
end

on isSameWorld(me)
  if activeWorld = 0 then
    return(0)
  end if
  return(activeWorld = lastWorld)
  exit
end

on getWorldSymbols(me)
  symbolList = []
  tempWorld = new(script("World"))
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    l = getAt()
    if fromList(tempWorld, l) then
      add(symbolList, [getSymbol(tempWorld), l])
    else
    end if
  end repeat
  -- UNK_65 3
  return(duplicate(symbolList))
  exit
end

on loadWorld(me, world, WorldId)
  if not objectp(world) then
    return(#InvalidObject)
  end if
  if getPos(worlds, WorldId) = 0 then
    return(#InvalidId)
  end if
  if fromList(world, WorldId) then
    lastWorld = WorldId
    activeWorld = WorldId
    return(0)
  else
    return(#InvalidMember)
  end if
  exit
end

on toList(me)
  return(worlds)
  exit
end

on fromList(me, objectList)
  worlds = objectList
  exit
end