on new(me)
  parts = new(script("Parts"))
  externalParts = new(script("ExternalParts"))
  users = new(script("Users"))
  worlds = new(script("Worlds"))
  maps = new(script("Maps"))
  missions = new(script("Missions"))
  junkPileHandlers = new(script("junkPileHandlers"))
  SharedSound = new(script("SharedSound"))
  justStarted = 1
  WhereFrom = "00"
  CustomCursorActive = 1
  loadIndicator = 0
  checkmemory = 0
  tempPlugs = checkForPlugins()
  plugCasts = getProp(tempPlugs, #cast)
  if count(plugCasts) = 0 then
    allFromList(me)
  end if
  chassis = 1
  user = 0
  world = 0
  return(me)
  exit
end

on kill(me)
  save(me)
  parts = kill(parts)
  externalParts = kill(externalParts)
  users = kill(users)
  worlds = kill(worlds)
  maps = kill(maps)
  missions = kill(missions)
  junkPileHandlers = kill(junkPileHandlers)
  SharedSound = kill(SharedSound)
  if objectp(user) then
    user = kill(user)
  end if
  if objectp(world) then
    world = kill(world)
  end if
  return(0)
  exit
end

on allFromList(me)
  fromList(parts, value(member("PartsDB", "data").text))
  fromList(externalParts, value(member("ExternalPartsDB", "data").text))
  fromList(users, value(member("UsersDB", "data").text))
  fromList(worlds, value(member("WorldsDB", "data").text))
  fromList(maps, value(member("MapsDB", "data").text))
  fromList(missions, value(member("MissionsDB", "data").text))
  exit
end

on save(me)
  member("UsersDB", "data").text = string(toList(users))
  if objectp(user) then
    tempMember = "User" & getUserId(user) & "DB"
    if sprite("data").number > -1 then
      member(tempMember, "data").text = string(toList(user))
    else
      alert("Save member not found: " & tempMember & ". Game not saved!")
    end if
  end if
  save(castLib("data"))
  exit
end

on emptyDbs(me)
  tempList = ["PartsDB", "JunkManPartsDB", "WorldPartsDB", "UsersDB", "WorldsDB", "MapsDB", "ObjectsDB", "MissionsDB"]
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    member(index).text = "[]"
  end repeat
  -- UNK_65 3
  exit
end