on new(me)
  userId = ""
  car = new(script("Car"))
  junk = []
  nrOfBuiltCars = 0
  saves = []
  gifts = [[27, point(462, 179)]]
  completedMissions = []
  ownStuff = []
  myLastPile = 1
  drivingInfo = 0
  figgeIsComing = 0
  missionIsComing = 0
  return(me)
  exit
end

on kill(me)
  car = kill(car)
  junk = 0
  saves = 0
  completedMissions = 0
  return(0)
  exit
end

on getUserId(me)
  return(userId)
  exit
end

on setId(me, theid)
  userId = theid
  exit
end

on getDrivingInfo(me)
  return(drivingInfo)
  exit
end

on setDrivingInfo(me, newInfo)
  drivingInfo = newInfo
  exit
end

on getJunk(me, place)
  return(getaProp(junk, place))
  exit
end

on removeJunkPart(me, fromWhere, partId)
  tempPart = getPart(gMulleGlobals.parts, partId)
  tempMaster = getMaster(tempPart)
  if integerp(tempMaster) then
    if tempMaster > 0 then
      partId = tempMaster
    end if
  end if
  if not symbolp(fromWhere) then
    foundIt = 0
    n = 1
    repeat while n <= count(junk)
      tempJunk = getAt(junk, n)
      deleteProp(tempJunk, partId)
      if the result = 1 then
        foundIt = 1
      else
      end if
      n = 1 + n
    end repeat
    if foundIt then
      setAt(junk, n, tempJunk)
    else
      alert("(RemoveJunk/User) Part not found:" && string(partId))
    end if
  else
    tempJunk = getaProp(junk, fromWhere)
    deleteProp(tempJunk, partId)
    setProp(junk, fromWhere, tempJunk)
  end if
  exit
end

on addJunkPart(me, toWhere, partId, extraInfo)
  if voidp(extraInfo) and toWhere = #yard then
    addYardPart(me, toWhere, partId, extraInfo)
  else
    if listp(extraInfo) then
      tempJunk = getaProp(junk, toWhere)
      addProp(tempJunk, partId, extraInfo)
      setProp(junk, toWhere, tempJunk)
    else
      if toWhere = #RandomPile then
        tempJunkSymbol = getRandomPile(gMulleGlobals.junkPileHandlers)
        if tempJunkSymbol = 0 then
          alert("All piles are full!")
          exit
        end if
      else
        if symbolp(toWhere) then
          tempJunkSymbol = toWhere
        else
          tempJunkSymbol = symbol("pile" & myLastPile)
        end if
      end if
      if checkFull(gMulleGlobals.junkPileHandlers, tempJunkSymbol) then
        put(string(tempJunkSymbol) & " is full")
        exit
      end if
      tempJunk = getaProp(junk, tempJunkSymbol)
      tempNewPos = setPartPosition(gMulleGlobals.junkPileHandlers, tempJunkSymbol, partId)
      addProp(tempJunk, partId, tempNewPos)
      setProp(junk, tempJunkSymbol, tempJunk)
    end if
  end if
  exit
end

on addYardPart(me, toWhere, partId, extraInfo)
  tempJunkSymbol = toWhere
  if checkFull(gMulleGlobals.junkPileHandlers, tempJunkSymbol) then
    removeId = getPropAt(getaProp(junk, tempJunkSymbol), 1)
    removeJunkPart(gMulleGlobals.user, #yard, removeId)
    addJunkPart(me, #RandomPile, removeId)
  end if
  tempJunk = getaProp(junk, tempJunkSymbol)
  tempNewPos = setPartPosition(gMulleGlobals.junkPileHandlers, tempJunkSymbol, partId)
  addProp(tempJunk, partId, tempNewPos)
  setProp(junk, tempJunkSymbol, tempJunk)
  exit
end

on getJunkPartProp(me, where, partId)
  tempJunk = getaProp(junk, where)
  return(getaProp(tempJunk, partId))
  exit
end

on setJunkPartProp(me, where, partId, Info)
  tempJunk = getaProp(junk, where)
  setaProp(tempJunk, partId, Info)
  setProp(junk, where, tempJunk)
  exit
end

on initJunk(me)
  junk = value(member("InitialJunkDB").text)
  exit
end

on addCompletedMission(me, theid)
  if getPos(completedMissions, theid) = 0 then
    add(completedMissions, theid)
  end if
  if getPos(givenMissions, theid) = 0 then
    add(givenMissions, theid)
  end if
  exit
end

on isMissionCompleted(me, theid)
  if getPos(completedMissions, theid) then
    return(1)
  end if
  return(0)
  exit
end

on getUserProp(me, theProp)
  temp = getaProp(ownStuff, theProp)
  if voidp(temp) then
    return(#NoProp)
  else
    return(temp)
  end if
  exit
end

on setUserProp(me, theProp, optionalData)
  if voidp(optionalData) then
    optionalData = 0
  end if
  if voidp(getaProp(ownStuff, theProp)) then
    addProp(ownStuff, theProp, optionalData)
  else
    setProp(ownStuff, theProp, optionalData)
  end if
  exit
end

on clearUserProps(me)
  ownStuff = []
  exit
end

on saveCar(me, which)
  if which > 0 then
    setAt(saves, which, duplicate(toList(car)))
  end if
  exit
end

on loadCar(me, which)
  if which <= count(saves) and which > 0 then
    fromList(car, getAt(saves, which))
  end if
  exit
end

on changeCarName(me, which, NewName)
  tempCar = new(script("Car"))
  if which <= count(saves) and which > 0 then
    fromList(tempCar, getAt(saves, which))
    setName(tempCar, NewName)
    setAt(saves, which, toList(tempCar))
  end if
  tempCar = 0
  exit
end

on getSavedCars(me, which)
  if which = #all then
    return(saves)
  end if
  if integerp(which) then
    if which <= count(saves) and which > 0 then
      return(getAt(saves, which))
    end if
  end if
  return(0)
  exit
end

on findPart(me, partId)
  n = 1
  repeat while n <= count(junk)
    if not voidp(getaProp(getAt(junk, n), partId)) then
      return(getPropAt(junk, n))
    end if
    n = 1 + n
  end repeat
  if findPart(car, partId) then
    return(#car)
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if getAt(index, 1) = partId then
      return(#Gift)
    end if
  end repeat
  -- UNK_65 3
  return(0)
  exit
end

on toList(me)
  return([#userId:userId, #car:toList(car), #junk:junk, #nrOfBuiltCars:nrOfBuiltCars, #saves:saves, #completedMissions:completedMissions, #ownStuff:ownStuff, #myLastPile:myLastPile, #gifts:gifts, #toYardThroughDoor:toYardThroughDoor, #givenMissions:givenMissions, #figgeIsComing:figgeIsComing, #missionIsComing:missionIsComing])
  exit
end

on fromList(me, objectList)
  userId = getaProp(objectList, #userId)
  fromList(car, getaProp(objectList, #car))
  junk = getaProp(objectList, #junk)
  nrOfBuiltCars = getaProp(objectList, #nrOfBuiltCars)
  saves = getaProp(objectList, #saves)
  completedMissions = getaProp(objectList, #completedMissions)
  ownStuff = getaProp(objectList, #ownStuff)
  myLastPile = getaProp(objectList, #myLastPile)
  gifts = getaProp(objectList, #gifts)
  toYardThroughDoor = getaProp(objectList, #toYardThroughDoor)
  givenMissions = getaProp(objectList, #givenMissions)
  figgeIsComing = getaProp(objectList, #figgeIsComing)
  missionIsComing = getaProp(objectList, #missionIsComing)
  exit
end