on new(me, theChild)
  child = theChild
  sndId = 0
  insideInner = 0
  insideOuter = 0
  counter = 0
  FrameList = []
  readyToGo = 1
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me, carLoc)
  tempDiff = carLoc - child.myLoc
  tempH = getAt(tempDiff, 1)
  tempV = getAt(tempDiff, 2)
  hypo = sqrt(tempH * tempH + tempV * tempV)
  if hypo <= child.OuterRadius then
    insideOuter = 1
    readyToGo = 0
  end if
  if hypo <= child.InnerRadius then
    insideInner = 1
  end if
  FrameList = getProp(getFrameList(child), #normal)
  listLen = count(FrameList)
  counter = 0
  sprite(child.SPUnder).name = member(getAt(FrameList, 1))
  sprite(child.SPUnder).position = child.myLoc
  exit
end

on step(me, carLoc)
  temp = checkRadius(gDir.drivingHandlers, me, carLoc, child.myLoc, #both)
  -- UNK_64 0
  if ERROR = #EnterInnerRadius then
    EnterInnerRadius(me)
  else
    -- UNK_64 0
    if ERROR = #ExitInnerRadius then
      ExitInnerRadius(me)
    else
      -- UNK_64 0
      if ERROR = #enterOuterRadius then
        enterOuterRadius(me)
      else
        -- UNK_64 0
        if ERROR = #ExitOuterRadius then
          ExitOuterRadius(me)
        else
          -- UNK_64 0
          if ERROR = #EnterBoth then
            enterOuterRadius(me)
            EnterInnerRadius(me)
          else
            -- UNK_64 0
            if ERROR = #ExitBoth then
              ExitInnerRadius(me)
              ExitOuterRadius(me)
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  if externalSoundFinished then
    if readyToGo and insideInner and child.canEnter then
      if finished(gSound, sndId) then
        enteredObject(gMulleGlobals.world, getId(child))
        prepareToLeave(gDir, getDirResource(child))
        exit
      end if
    end if
  else
    if readyToGo and insideOuter then
      externalSoundFinished = sendSprite(getProp(gDir.spriteList, #medal), #FinishedSound)
      if externalSoundFinished then
        playSound(me)
      end if
    end if
  end if
  counter = counter + 1
  sprite(child.SPUnder).name = member(getAt(FrameList, counter))
  if counter = listLen then
    counter = 0
  end if
  exit
end

on enterOuterRadius(me)
  temp = getProp(getFrameList(child), #Outer)
  if listp(temp) then
    FrameList = temp
    listLen = count(FrameList)
    counter = 0
  end if
  externalSoundFinished = sendSprite(getProp(gDir.spriteList, #medal), #FinishedSound)
  if externalSoundFinished then
    playSound(me)
  end if
  exit
end

on playSound(me)
  if child.canEnter then
    if count(child.sounds) then
      if finished(gSound, sndId) then
        sndId = play(gSound, getAt(child.sounds, 1), #EFFECT)
      end if
    end if
  else
    if count(child.sounds) > 1 then
      if finished(gSound, sndId) then
        sndId = play(gSound, getAt(child.sounds, 2), #EFFECT)
      end if
    end if
  end if
  exit
end

on ExitOuterRadius(me)
  FrameList = getProp(getFrameList(child), #normal)
  listLen = count(FrameList)
  counter = 0
  readyToGo = 1
  exit
end

on EnterInnerRadius(me)
  if readyToGo and child.canEnter then
    programControl(gDir.carDriving, 1)
    saveThis = symbol("Visited" & getDirResource(child))
    setUserProp(gMulleGlobals.user, saveThis)
    setSpeed(gDir.carDriving, 0)
    steer(gDir.carDriving, 0)
  end if
  exit
end

on ExitInnerRadius(me)
  exit
end