on beginSprite(me)
  puttingBack = ""
  tempNewPos = 0
  nrOfMoveSteps = 10
  loopCount = 0
  releaseOk = 0
  tmpId = 0
  tmp = symbol("pile" & whichPile)
  myRects = getaProp(gMulleGlobals.junkPileHandlers.rects, tmp)
  maxTop = 999
  minLeft = 999
  maxRight = 0
  bottomline = 0
  x = 1
  repeat while x <= 3
    if getAt(getAt(myRects, x), 1) < minLeft then
      minLeft = getAt(getAt(myRects, x), 1)
    end if
    if getAt(getAt(myRects, x), 3) > maxRight then
      maxRight = getAt(getAt(myRects, x), 3)
    end if
    if getAt(getAt(myRects, x), 4) > bottomline then
      bottomline = getAt(getAt(myRects, x), 4)
    end if
    if getAt(getAt(myRects, x), 2) < maxTop then
      maxTop = getAt(getAt(myRects, x), 2)
    end if
    x = 1 + x
  end repeat
  distributeParts(me)
  checkNrofParts(me)
  exit
end

on checkNrofParts(me)
  check = symbol("Pile" & whichPile)
  check = symbol("Pile" & whichPile)
  if getaProp(gMulleGlobals.junkPileHandlers.maxParts, check) <= count(getaProp(getaProp(gMulleGlobals.user, #junk), check)) + 20 then
    sendSprite(getaProp(gDir.spriteList, #Mulle), #addToSounList, #Reject)
  else
    sendSprite(getaProp(gDir.spriteList, #Mulle), #addToSounList, #Think)
  end if
  exit
end

on distributeParts(me)
  myPile = getJunk(gMulleGlobals.user, symbol("Pile" & string(whichPile)))
  startChannel = getaProp(gDir.spriteList, #JunkStart) - 1
  channel = getaProp(gDir.spriteList, #JunkStart)
  n = 1
  repeat while n <= count(myPile)
    sendSprite(channel, #setPart, [getPropAt(myPile, n), getAt(myPile, n)])
    channel = channel + 1
    n = 1 + n
  end repeat
  topLayer = count(myPile) + startChannel
  sprite(channel).undefined = "Dummy"
  exit
end

on forcePartInPlace(me)
  loopCount = 0
  puttingBack = ""
  sprite(topLayer).undefined = tempNewPos
  if voidp(getaProp(myPile, partId)) then
    alert("No ID for part " & partId)
  else
    removeJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId)
    addJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId, tempNewPos)
  end if
  exit
end

on exitFrame(me)
  cFrame = the frame
  mFrame = marker(0) + 9
  if cFrame = mFrame then
    go("Pile" & string(whichPile))
  end if
  if puttingBack <> "" then
    if puttingBack = "center" then
      if loopCount < nrOfMoveSteps then
        sprite(topLayer).undefined = point(getAt(sprite(topLayer).undefined, 1) + xDiff / nrOfMoveSteps, getAt(sprite(topLayer).undefined, 2) + yDiff / nrOfMoveSteps)
        loopCount = loopCount + 1
      else
        loopCount = 0
        puttingBack = ""
        kickPartSound(gMulleGlobals.SharedSound, partSprite, partId, #InternalGround)
        if voidp(getaProp(myPile, partId)) then
          alert("No ID for part " & partId)
        else
          removeJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId)
          newPoint = sprite(topLayer).undefined
          put("exitAddjunk")
          addJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId, newPoint)
        end if
      end if
    end if
  end if
  exit
end

on GoLeft(me)
  if puttingBack = "center" then
    forcePartInPlace(me)
  end if
  sprite(getaProp(gDir.spriteList, #Buffa)).undefined = "Dummy"
  if whichPile > 1 then
    gMulleGlobals.user.myLastPile = whichPile - 1
    if gDir.goToLoad then
      gMulleGlobals.WhereFrom = "02"
      go("left", "unload")
    else
      doorToPreload = "open" & whichPile - 1
      preloadMember(doorToPreload)
      go("Pile" & string(whichPile - 1))
      sendSprite(getaProp(gDir.spriteList, #Buffa), #changePile, -1)
    end if
  else
    gMulleGlobals.user.myLastPile = 6
    if gDir.goToLoad then
      gMulleGlobals.WhereFrom = "02"
      go("left", "unload")
    else
      doorToPreload = "open6"
      preloadMember(doorToPreload)
      go("Pile6")
      sendSprite(getaProp(gDir.spriteList, #Buffa), #changePile, -1)
    end if
  end if
  exit
end

on GoRight(me)
  if puttingBack = "center" then
    forcePartInPlace(me)
  end if
  sprite(getaProp(gDir.spriteList, #Buffa)).undefined = "Dummy"
  if whichPile < 6 then
    gMulleGlobals.user.myLastPile = whichPile + 1
    if gDir.goToLoad then
      gMulleGlobals.WhereFrom = "02"
      go("right", "unload")
    else
      doorToPreload = "open" & whichPile + 1
      preloadMember(doorToPreload)
      go("Pile" & string(whichPile + 1))
      sendSprite(getaProp(gDir.spriteList, #Buffa), #changePile, 1)
    end if
  else
    gMulleGlobals.user.myLastPile = 1
    if gDir.goToLoad then
      gMulleGlobals.WhereFrom = "02"
      go("right", "unload")
    else
      doorToPreload = "open1"
      preloadMember(doorToPreload)
      go("Pile1")
      sendSprite(getaProp(gDir.spriteList, #Buffa), #changePile, 1)
    end if
  end if
  exit
end

on grabPart(me, grabbedPartId, grabbedPartSprite)
  if puttingBack = "center" then
    forcePartInPlace(me)
  end if
  releaseOk = 1
  partSprite = grabbedPartSprite
  dragSprite = grabbedPartSprite
  partId = grabbedPartId
  sendSprite(getaProp(gDir.spriteList, #drag), #setPart, sprite(grabbedPartSprite).undefined)
  sprite(getaProp(gDir.spriteList, #drag)).undefined = sprite(grabbedPartSprite).undefined
  trackRect = rect(the mouseH - 2, the mouseV - 2, the mouseH + 2, the mouseV + 2)
  tracking = 1
  exit
end

on releasePart(me)
  if releaseOk = 1 then
    if sprite(getaProp(gDir.spriteList, #Mulle)).currentAction = #none then
      playedDescription = 0
    else
      playedDescription = 1
    end if
    if tracking and inside(point(the mouseH, the mouseV), trackRect) and partId <> tmpId then
      tmpId = partId
      playedDescription = 1
      sendSprite(partSprite, #PlayDescription)
    end if
    tracking = 0
    sprite(partSprite).undefined = sprite(getaProp(gDir.spriteList, #drag)).undefined
    sprite(getaProp(gDir.spriteList, #drag)).undefined = member("dummy")
    if inside(point(the mouseH, the mouseV), sprite(getaProp(gDir.spriteList, #rightSign)).undefined) then
      if whichPile = 6 then
        toPile = 1
      else
        toPile = whichPile + 1
      end if
      sendSprite(partSprite, #moveToDifferentPile, whichPile, toPile)
      sendSprite(115, #C_Right)
      distributeParts(me)
    else
      if inside(point(the mouseH, the mouseV), sprite(getaProp(gDir.spriteList, #leftSign)).undefined) then
        if whichPile = 1 then
          toPile = 6
        else
          toPile = whichPile - 1
        end if
        sendSprite(partSprite, #moveToDifferentPile, whichPile, toPile)
        sendSprite(115, #c_Left)
        distributeParts(me)
      else
        if inside(point(the mouseH, the mouseV), getAt(myRects, 1)) or inside(point(the mouseH, the mouseV), getAt(myRects, 2)) or inside(point(the mouseH, the mouseV), getAt(myRects, 3)) then
          tmp = checkPoint(gMulleGlobals.junkPileHandlers, point(the mouseH, the mouseV), partId, whichPile)
          if tmp = #true then
            if playedDescription = 0 then
              kickPartSound(gMulleGlobals.SharedSound, partSprite, partId, #InternalGround)
            end if
            putOnTop(me, partSprite)
          else
            if tmp = #false then
              flowBack(me)
            else
              loopCount = 0
              tempNewPos = tmp
              xDiff = getAt(tempNewPos, 1) - the mouseH
              yDiff = getAt(tempNewPos, 2) - the mouseV
              puttingBack = "center"
              putOnTop(me, partSprite)
            end if
          end if
        else
          if inside(point(the mouseH, the mouseV), sprite(getaProp(gDir.spriteList, #DoorStart)).trackRect) then
            sendSprite(partSprite, #moveToShop, whichPile)
            kickPartSound(gMulleGlobals.SharedSound, the currentSpriteNum, partId, #ExternalGround)
            sendSprite(115, #c_click)
            distributeParts(me)
          else
            flowBack(me)
          end if
        end if
      end if
    end if
    releaseOk = 0
  end if
  exit
end

on flowBack(me)
  tempJunkSymbol = symbol("pile" & whichPile)
  tempNewPos = setPartPosition(gMulleGlobals.junkPileHandlers, tempJunkSymbol, partId)
  xDiff = getAt(tempNewPos, 1) - the mouseH
  yDiff = getAt(tempNewPos, 2) - the mouseV
  loopCount = 0
  puttingBack = "center"
  putOnTop(me, partSprite)
  exit
end

on prepareFrame(me)
  if tracking then
    if not inside(point(the mouseH, the mouseV), trackRect) then
      sendSprite(getaProp(gDir.spriteList, #drag), #drag)
      sprite(partSprite).undefined = member("dummy")
    end if
  end if
  exit
end

on putOnTop(me, theSprite, extraInfo)
  if voidp(getaProp(myPile, partId)) then
  else
    removeJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId)
  end if
  if voidp(extraInfo) then
    if inside(point(the mouseH, the mouseV), trackRect) then
      newPoint = sprite(theSprite).undefined
    else
      newPoint = point(the mouseH, the mouseV)
    end if
  else
    newPoint = extraInfo
  end if
  addJunkPart(gMulleGlobals.user, symbol("pile" & whichPile), partId, newPoint)
  distributeParts(me)
  exit
end

on getPropertyDescriptionList(me)
  return([#whichPile:[#comment:"Which pile (1-6):", #format:#integer, #default:1, #range:[#min:1, #max:6]]])
  exit
end