on beginSprite(me)
  tracking = 0
  trackRect = ""
  Active = 1
  exit
end

on activate(me, theState)
  Active = theState
  exit
end

on mouseEnter(me)
  if Active and not tracking then
    tracking = 1
    trackRect = sprite(me.spriteNum).undefined
    if sprite(120).releaseOk = 0 then
      sendSprite(115, #c_click)
    else
      sendSprite(115, #c_MoveIn)
    end if
    play(gSound, "02e016v0", #OPEFFECT)
    sprite(me.spriteNum).undefined = sprite(me.spriteNum).undefined + 1
  end if
  exit
end

on isMouseOver(me)
  if inside(point(the mouseH, the mouseV), trackRect) then
    return(1)
  else
    return(0)
  end if
  exit
end

on enterFrame(me)
  if trackRect = "" then
    trackRect = sprite(me.spriteNum).undefined
  end if
  exit
end

on prepareFrame(me)
  if tracking then
    if not inside(point(the mouseH, the mouseV), trackRect) then
      play(gSound, "02e015v0", #OPEFFECT)
      sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
      tracking = 0
      if sprite(120).releaseOk then
        sendSprite(115, #c_grab)
      else
        sendSprite(115, #C_Standard)
      end if
    end if
  end if
  exit
end

on checkMyRect(me)
  put("DOWN UP")
  put("RELEASEOK? ", sprite(120).releaseOk)
  if Active then
    if inside(point(the mouseH, the mouseV), trackRect) then
      if sprite(120).puttingBack = "center" then
        sendSprite(120, #forcePartInPlace)
      end if
      put("settin the wherefrom")
      gMulleGlobals.WhereFrom = "02"
      put("the wherefrom in ceckrect ", gMulleGlobals.WhereFrom)
      go(string(mediaName))
    end if
  end if
  exit
end

on getPropertyDescriptionList()
  p_list = [#mediaName:[#comment:"the name of the destination marker:", #format:#string, #default:""]]
  return(p_list)
  exit
end