on beginSprite(me)
  type = #Figge
  mode = #Still
  tempList = sprite(me.spriteNum).undefined
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if index.type = #SpriteAnim then
      animObject = index
    end if
  end repeat
  -- UNK_65 3
  setAnimNormal(animObject)
  sprite(the currentSpriteNum).visible = 0
  activeClick = 1
  exitLoopAction = 0
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on loop(me)
  if finished(gSound, currentSound) = 0 then
    nothing()
  else
    -- UNK_64 0
    if ERROR = 1 then
      currentSound = play(gSound, "03d043v0", #EFFECT)
      exitLoopAction = 2
    else
      -- UNK_64 0
      if ERROR = 2 then
        finishFigge(me)
        exitLoopAction = 3
        deleteLoopObject(gDir, me)
      else
        -- UNK_64 0
        if ERROR = 4 then
          mode = #Talk
          sendSprite(me.spriteNum, #setAnimAction, mode)
          deleteLoopObject(gDir, me)
        end if
      end if
    end if
    -- UNK_65 1
  end if
  exit
end

on doFigge(me)
  if activeClick then
    activate(gDir, 0)
    currentSound = play(gSound, "03e009v0", #EFFECT)
    addLoopObject(gDir, me)
    exitLoopAction = 1
  end if
  exit
end

on finishFigge(me)
  if mode = #Still then
    play(gSound, "02e016v0", #EFFECT)
    sprite(getaProp(gDir.spriteList, #DoorStart)).undefined = sprite(getaProp(gDir.spriteList, #DoorStart)).undefined + 1
    leaveStuff()
    tempMode = 0
    tempMode = #ComeIn
    mode = tempMode
    sprite(me.spriteNum).visible = 1
    put("sendin come in")
    sendSprite(me.spriteNum, #setAnimAction, mode)
  end if
  exit
end

on Interupt(me)
  if exitLoopAction = 3 then
    sprite(getaProp(gDir.spriteList, #Mulle)).makeHimLeave = 0
    sendSprite(getaProp(gDir.spriteList, #Mulle), #Stopped, #Talk)
  end if
  exitLoopAction = 4
  stopAllEffects(gSound)
  exit
end

on FiggeLeave(me)
  mode = #Talk
  makeAnimSpeech(animObject, "03d046v0")
  addLoopObject(gDir, me)
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exitLoopAction = 4
  exit
end

on leaveStuff(me)
  calcCurrentlyAvailable(gMulleGlobals.externalParts)
  tmpList = getCurrentlyAvailable(gMulleGlobals.externalParts, #JunkMan)
  if count(tmpList) <= 3 then
    tmpNewParts = tmpList
    n = 1
    repeat while n <= count(tmpList)
      addJunkPart(gMulleGlobals.user, #yard, getAt(tmpNewParts, n))
      n = 1 + n
    end repeat
    exit repeat
  end if
  n = 1
  repeat while n <= 3
    addJunkPart(gMulleGlobals.user, #yard, getAt(tmpList, n))
    n = 1 + n
  end repeat
  sprite(getaProp(gDir.spriteList, #FiggeInterup)).undefined = point(0, 0)
  exit
end

on Stopped(me)
  -- UNK_64 0
  if ERROR = #ComeIn then
    makeAnimSpeech(animObject, "03d044v0")
    tempMode = #Talk
  else
    -- UNK_64 0
    if ERROR = #Talk then
      if exitLoopAction = 3 then
        currentSound = sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #greetFigge)
        addLoopObject(gDir, me)
        tempMode = #Freeze
      else
        setAnimNormal(animObject)
        tempMode = #GoOut
        exitLoopAction = 0
      end if
    else
      -- UNK_64 0
      if ERROR = #Freeze then
        tempMode = #Freeze
      else
        -- UNK_64 0
        if ERROR = #GoOut then
          tempMode = #Still
          sprite(the currentSpriteNum).visible = 0
          play(gSound, "02e015v0", #EFFECT)
          sprite(getaProp(gDir.spriteList, #DoorStart)).undefined = sprite(getaProp(gDir.spriteList, #DoorStart)).undefined - 1
          play(gSound, "03e010v0", #EFFECT)
          sprite(getaProp(gDir.spriteList, #FiggeInterup)).undefined = point(700, 500)
          activate(gDir, 1)
        else
          -- UNK_64 0
          if ERROR = #Still then
            tempMode = #Still
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  mode = tempMode
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end