on beginSprite(me)
  SP = me.spriteNum
  isFalling = 0
  velV = 0
  velH = 0
  activeClick = 1
  loopCount = 0
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on setPart(me, thePartId, thePartLoc, theIsFalling, fallingFrom)
  isFalling = theIsFalling
  if thePartId = 0 then
    sprite(SP).undefined = member("Dummy")
  else
    if isFalling then
      sprite(SP).undefined = fallingFrom
      velV = 0
      floorLocV = getAt(thePartLoc, 2)
    else
      sprite(SP).undefined = thePartLoc
    end if
    velH = 30
    partId = thePartId
    part = getPart(gMulleGlobals.parts, partId)
    showMember = getJunkView(part)
    sprite(SP).undefined = member(showMember)
  end if
  exit
end

on mouseDown(me)
  if activeClick then
    grabbedPart(gDir.partsCommon, partId, #Floor)
  end if
  exit
end

on loop(me)
  loopCount = loopCount + 1
  if loopCount = 2 then
    if the mouseDown = 0 then
    else
      grabbedPart(gDir.partsCommon, partId, #Floor)
    end if
    loopCount = 0
    deleteLoopObject(gDir, me)
  end if
  exit
end

on exitFrame(me)
  if isFalling then
    if sprite(SP).locV = floorLocV then
      Hmax = getAt(getAt(getaProp(gMulleGlobals.junkPileHandlers.rects, #shopFloor), 1), 3)
      if sprite(SP).locH > Hmax then
        sprite(SP).locH = Hmax
      end if
      velV = 0
      isFalling = 0
      if gDir.partsCommon.playedDescription = 0 then
        kickPartSound(gMulleGlobals.SharedSound, SP, partId, #InternalGround)
      end if
      setJunkPartProp(gMulleGlobals.user, #shopFloor, partId, point(getAt(sprite(SP).undefined, 1), floorLocV))
    else
      if velV < 60 then
        velV = velV + 8
      end if
      if velV + sprite(SP).locV < floorLocV then
        sprite(SP).locV = velV + sprite(SP).locV
      else
        sprite(SP).locV = floorLocV
      end if
    end if
  end if
  exit
end