on new(me, theReportObject)
  waitin = 0
  reportObject = theReportObject
  chassisNr = gDir.carCopy.chassisSPOffset
  carOffset = sprite(getProp(gDir.spriteList, #CarStart) + chassisNr).undefined
  mulleLayer = gMulleGlobals.user.car.driverLayer
  trackRect = 0
  tracking = 0
  tmpId = 0
  return(me)
  exit
end

on grabbedPart(me, thePartId, fromWhere)
  sendSprite(getaProp(gDir.spriteList, #fButton), #activateClick, 0)
  dragPartFromWhere = fromWhere
  if fromWhere = #car then
    clearCar(gMulleGlobals.user.car)
    deletePart(gDir.carCopy, thePartId)
    rebuild(gDir.carCopy)
    part = getPart(gMulleGlobals.parts, thePartId)
    tempMaster = getMaster(part)
    if tempMaster then
      thePartId = tempMaster
    end if
    kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #car)
  else
    if fromWhere = #Floor then
      removeJunkPart(gMulleGlobals.user, #shopFloor, thePartId)
    end if
  end if
  snapRects = generateSnapRects(me, thePartId)
  tmpCurrentLoc = point(the mouseH, the mouseV)
  if fromWhere = #car then
    pixDecrease = 25
    n = 1
    repeat while n <= count(snapRects)
      if inside(tmpCurrentLoc, getAt(snapRects, n)) then
        oldrect = getAt(snapRects, n)
        newrect = rect(getAt(oldrect, 1) + pixDecrease, getAt(oldrect, 2) - pixDecrease, getAt(oldrect, 3) - pixDecrease, getAt(oldrect, 4) - pixDecrease)
        setAt(snapRects, n, newrect)
      end if
      n = 1 + n
    end repeat
  end if
  sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk)
  sendSprite(getProp(gDir.spriteList, #drag), #startDrag, thePartId, fromWhere, snapRects)
  trackRect = rect(the mouseH - 2, the mouseV - 2, the mouseH + 2, the mouseV + 2)
  tracking = 1
  exit
end

on generateSnapRects(me, thePartId)
  part = getPart(gMulleGlobals.parts, thePartId)
  if voidp(part) then
    alert("no file for part " & string(thePartId))
  end if
  tempMaster = getMaster(part)
  if tempMaster then
    part = getPart(gMulleGlobals.parts, tempMaster)
  end if
  tempMorph = getMorphList(part)
  if listp(tempMorph) then
    if count(tempMorph) > 0 then
      partList = tempMorph
    else
      partList = [getId(part)]
    end if
  else
    partList = [getId(part)]
  end if
  freeList = []
  snapOffsets = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    Required = getRequiredPoints(getPart(gMulleGlobals.parts, partId))
    if areTheseFree(gDir.carCopy, Required) then
      add(freeList, partId)
      whichSnap = getAt(Required, 1)
      add(snapOffsets, getSnapInfo(gDir.carCopy, whichSnap, #offset))
    end if
  end repeat
  -- UNK_65 3
  snapRects = []
  rectSize = 40
  n = 1
  repeat while n <= count(freeList)
    partId = getAt(freeList, n)
    snapOffset = getAt(snapOffsets, n)
    part = getPart(gMulleGlobals.parts, partId)
    tempMembers = [getUseView(part)]
    tempBackMember = getUseView2(part)
    tempOffset = getOffset(part)
    if voidp(getAt(tempOffset, 1)) then
    else
      if stringp(tempBackMember) then
        if length(tempBackMember) > 0 then
          add(tempMembers, tempBackMember)
        end if
      end if
      drawCheatVar = 1
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        tempRect = member(index).rect
        midPoint = point(getAt(tempRect, 3) / 2, getAt(tempRect, 4) / 2)
        midPoint = midPoint - member(index).regPoint
        midPoint = midPoint + carOffset + tempOffset + snapOffset
        drawCheatVar = 0
        tempSnap = rect(getAt(midPoint, 1) - rectSize, getAt(midPoint, 2) - rectSize, getAt(midPoint, 1) + rectSize, getAt(midPoint, 2) + rectSize)
        addProp(snapRects, partId, tempSnap)
      end repeat
      -- UNK_65 3
    end if
    n = 1 + n
  end repeat
  if sprite(getaProp(gDir.spriteList, #Mulle)).currentTalk = #noPoints then
    sendSprite(getaProp(gDir.spriteList, #Mulle), #waitForProtest, 0, #cut)
  end if
  if snapRects = [] then
    if waitin = 0 then
      waitin = 1
      sendSprite(getaProp(gDir.spriteList, #Mulle), #waitForProtest, 1)
    end if
  end if
  return(snapRects)
  exit
end

on drawcheat(me, thePoint)
  tmpstart = getProp(gDir.spriteList, #cheatStart)
  if thePoint <> 0 then
    repeat while member(sprite(tmpstart).undefined).name <> "Dummy"
      tmpstart = tmpstart + 1
    end repeat
    sprite(tmpstart).undefined = "helpDot"
    sprite(tmpstart).undefined = thePoint
  else
    repeat while member(sprite(tmpstart).undefined).name <> "Dummy"
      sprite(tmpstart).undefined = "Dummy"
      sprite(tmpstart).undefined = point(-100, -100)
      tmpstart = tmpstart + 1
    end repeat
  end if
  exit
end

on showUseView(me, partId, YesNo)
  put("in showUseView with: ", partId)
  part = getPart(gMulleGlobals.parts, partId)
  whichSnap = getAt(getRequiredPoints(part), 1)
  layers = getSnapInfo(gDir.carCopy, whichSnap, #layers)
  snapOffset = getSnapInfo(gDir.carCopy, whichSnap, #offset)
  if YesNo then
    memberList = [getUseView(part), getUseView2(part)]
    offset = getOffset(part)
  else
    partId = 0
    memberList = ["Dummy", "Dummy"]
    offset = point(0, 0)
  end if
  n = 1
  repeat while n <= count(layers)
    layer = getAt(layers, n)
    if layer >= -1 and length(getAt(memberList, n)) > 0 then
      if layer > mulleLayer - 1 then
        layer = layer + 2
      end if
      tempSP = getProp(gDir.spriteList, #CarStart) + layer
      sprite(tempSP).undefined = member(getAt(memberList, n))
      sprite(tempSP).undefined = carOffset + offset + snapOffset
      sendSprite(tempSP, #setPart, partId)
    end if
    n = 1 + n
  end repeat
  exit
end

on letGoOfPart(me, thePartId, where)
  playedDescription = 0
  if dragPartFromWhere = #Floor then
    if tracking and inside(point(the mouseH, the mouseV), trackRect) then
      if sprite(getaProp(gDir.spriteList, #Mulle)).currentTalk <> #noPoints and thePartId <> tmpId then
        tmpId = thePartId
        snd = getDescription(getPart(gMulleGlobals.parts, thePartId))
        sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #Describe, snd)
      end if
      playedDescription = 1
    end if
  end if
  tracking = 0
  sendSprite(getaProp(gDir.spriteList, #fButton), #activateClick, 1)
  if waitin = 1 then
    waitin = 0
    sendSprite(getaProp(gDir.spriteList, #Mulle), #waitForProtest, 0, #noCut)
  end if
  shallCheckFree = 1
  isFalling = 0
  if where = #car then
    clearCar(gMulleGlobals.user.car)
    addPart(gDir.carCopy, thePartId)
  else
    if symbolp(where) then
      kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #ExternalGround)
      sendSprite(115, #c_click)
      addJunkPart(gMulleGlobals.user, 0, thePartId, 0)
    else
      if dragPartFromWhere = #Floor then
        shallCheckFree = 0
      end if
      temp = correctPosition(gMulleGlobals.junkPileHandlers, thePartId, where)
      isFalling = getAt(temp, 2)
      if isFalling = 0 then
        kickPartSound(gMulleGlobals.SharedSound, 0, thePartId, #InternalGround)
      end if
      addJunkPart(gMulleGlobals.user, #shopFloor, thePartId, getAt(temp, 1))
    end if
  end if
  sendSprite(getProp(gDir.spriteList, #JunkStart), #drawJunk, isFalling, where)
  sendSprite(getaProp(gDir.spriteList, #Mulle), #checkEquipment, #none)
  if shallCheckFree then
    freeOrBindParts(me)
  end if
  drawcheat(me, 0)
  exit
end

on freeOrBindParts(me)
  freeParts = []
  boundParts = []
  parts = getParts(gDir.carCopy)
  n = 2
  repeat while n <= count(parts)
    part = getPart(gMulleGlobals.parts, getAt(parts, n))
    newPoints = getNewPoints(part)
    if listp(newPoints) then
      tempList = []
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        add(tempList, getAt(index, 1))
      end repeat
      -- UNK_65 3
      if areTheseFree(gDir.carCopy, tempList) then
        add(freeParts, part)
      else
        add(boundParts, part)
      end if
    else
      add(freeParts, part)
    end if
    n = 1 + n
  end repeat
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    snapPoint = getAt(getRequiredPoints(index), 1)
    n = 1
    repeat while n <= 2
      layer = getAt(getSnapInfo(gDir.carCopy, snapPoint, #layers), n)
      if layer > mulleLayer - 1 then
        layer = layer + 2
      end if
      if layer > -1 then
        sendSprite(getProp(gDir.spriteList, #CarStart) + layer, #activate, 1)
      end if
      n = 1 + n
    end repeat
  end repeat
  -- UNK_65 3
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    snapPoint = getAt(getRequiredPoints(index), 1)
    n = 1
    repeat while n <= 2
      layer = getAt(getSnapInfo(gDir.carCopy, snapPoint, #layers), n)
      if layer > mulleLayer - 1 then
        layer = layer + 2
      end if
      if layer > -1 then
        sendSprite(getProp(gDir.spriteList, #CarStart) + layer, #activate, 0)
      end if
      n = 1 + n
    end repeat
  end repeat
  -- UNK_65 3
  exit
end

on kill(me)
  return(0)
  exit
end