on new(me)
  put("A new ancestor")
  ancestor = new(script("GeneralAncestor"), me)
  spriteList = [#CarStart:10, #drag:100, #JunkStart:46, #DoorStart:3, #garage:4, #DoorToYard:5, #fDialog:114, #cheatStart:102, #fButton:101, #Mulle:6, #Buffa:7, #Figge:8, #TeleSmall:2, #TeleBig:109, #Mikro:13, #HighLight:9, #FiggeInterup:120]
  carCopy = gMulleGlobals.user.car
  sprite(getProp(spriteList, #fDialog)).undefined = point(320, 240)
  sprite(getProp(spriteList, #HighLight)).undefined = point(320, 240)
  the mouseUpScript = "virtualMouseUp"
  the mouseDownScript = "virtualMouseDown"
  the keyDownScript = "systemkeys"
  mouseOverCar = []
  mouseOverMulle = []
  EnterShopEvent = 0
  mouseButtonActive = 1
  StopSpeak = 0
  mouseButtonActive = 1
  return(me)
  exit
end

on activate(me, theState)
  put("in activate")
  if theState then
    sendAllSprites(#activateClick, 1)
    mouseButtonActive = 1
    sendSprite(getProp(spriteList, #CarStart), #drawCar)
  else
    sendAllSprites(#activateClick, 0)
    mouseButtonActive = 0
  end if
  exit
end

on init(me)
  partsCommon = new(script("PartsCommon"), me)
  exit
end

on startMovie(me)
  stopAllEffects(gSound)
  stopBG(gSound)
  sprite(getaProp(spriteList, #FiggeInterup)).undefined = point(700, 500)
  sendSprite(getProp(spriteList, #JunkStart), #drawJunk)
  sendSprite(getProp(spriteList, #CarStart), #drawCar)
  sendSprite(getaProp(spriteList, #Mulle), #checkEquipment, #none)
  checkMissions(gMulleGlobals.missions)
  if objectp(gMulleGlobals.missions.currentMission) = 1 then
    if gMulleGlobals.user.missionIsComing = 1 then
      if not gMulleGlobals.user.nrOfBuiltCars mod 3 = 0 and gMulleGlobals.user.figgeIsComing = 1 then
        if getType(gMulleGlobals.missions.currentMission) = #Telephone then
          EnterShopEvent = 1
          StopSpeak = 1
          performMission(gMulleGlobals.missions)
        end if
      end if
    end if
  end if
  if EnterShopEvent = 0 then
    checkFigge()
  end if
  if StopSpeak = 0 then
    if gMulleGlobals.justStarted and gMulleGlobals.user.car.parts = [1, 82, 133, 152] then
      sendSprite(getaProp(spriteList, #Mulle), #MakeMulleSpeak, #yourTurn)
      gMulleGlobals.justStarted = 0
    else
      if random(6) = 1 then
        sendSprite(getaProp(spriteList, #Mulle), #MakeMulleSpeak, #InspireYou)
      end if
    end if
  end if
  sprite(115).undefined = point(-20, -20)
  if gMulleGlobals.CustomCursorActive then
    cursor(200)
  else
    sendSprite(115, #C_Standard)
  end if
  preloadMember("02e015v0")
  preloadMember("02e016v0")
  preloadMember("open1")
  preloadMember("open2")
  preloadMember("open3")
  exit
end

on checkFigge()
  NotMetHim = getUserProp(gMulleGlobals.user, #Visited92)
  if not NotMetHim = #NoProp then
    calcCurrentlyAvailable(gMulleGlobals.externalParts)
    if count(getCurrentlyAvailable(gMulleGlobals.externalParts, #JunkMan)) > 0 then
      if gMulleGlobals.user.nrOfBuiltCars mod 3 = 0 and gMulleGlobals.user.figgeIsComing = 1 then
        StopSpeak = 1
        sendSprite(getaProp(spriteList, #Figge), #doFigge)
        gMulleGlobals.user.figgeIsComing = 0
        gMulleGlobals.junkPileHandlers.figgeBeenHere = 1
      end if
    end if
  end if
  exit
end

on kill(me)
  if objectp(partsCommon) then
    partsCommon = kill(partsCommon)
  end if
  if objectp(ancestor) then
    ancestor = kill(ancestor)
  end if
  return(0)
  exit
end