on beginSprite(me)
  Active = 0
  showingUseView = 0
  dragObject = new(script("SafeDragScript"), me)
  activate(dragObject, 0)
  exit
end

on startDrag(me, thePartId, fromWhere, theSnapRects)
  dragging = 1
  snapRects = theSnapRects
  partId = thePartId
  part = getPart(gMulleGlobals.parts, partId)
  myMember = getJunkView(part)
  sprite(me.spriteNum).undefined = member(myMember)
  justStarted = 1
  Active = 1
  showingUseView = 0
  activate(dragObject, 1)
  exit
end

on exitFrame(me)
  if Active then
    tempMouseLoc = point(the mouseH, the mouseV)
    sprite(me.spriteNum).undefined = tempMouseLoc
    checkSnapRects(me, tempMouseLoc)
  end if
  exit
end

on checkSnapRects(me, theLoc)
  tempInside = 0
  n = 1
  repeat while n <= count(snapRects)
    if inside(theLoc, getAt(snapRects, n)) then
      tempInside = 1
      tempId = getPropAt(snapRects, n)
      if not showingUseView = tempId and not justStarted then
        if showingUseView then
          showUseView(gDir.partsCommon, showingUseView, 0)
        end if
        showingUseView = tempId
        kickPartSound(gMulleGlobals.SharedSound, 0, partId, #car)
        showUseView(gDir.partsCommon, showingUseView, 1)
        sprite(me.spriteNum).undefined = member("Dummy")
      end if
    else
      n = 1 + n
    end if
  end repeat
  if not tempInside then
    if justStarted then
      justStarted = 0
    end if
    if showingUseView then
      showUseView(gDir.partsCommon, showingUseView, 0)
      kickPartSound(gMulleGlobals.SharedSound, 0, partId, #car)
      showingUseView = 0
      sprite(me.spriteNum).undefined = member(myMember)
    end if
  end if
  exit
end

on mouseUp(me)
  dragging = 0
  if sprite(getaProp(gDir.spriteList, #Mulle)).currentSound = "nothing" then
    sendSprite(getaProp(gDir.spriteList, #Mulle), #removeLoop)
  end if
  exit
end

on report(me, theObject, what)
  if what = #clicked then
    if the mouseH > 630 then
      mouseH = 630
    else
      if the mouseH < 10 then
        mouseH = 10
      else
        mouseH = the mouseH
      end if
    end if
    activate(dragObject, 0)
    Active = 0
    sprite(me.spriteNum).undefined = member("Dummy")
    overDoor = 0
    tempSP = getProp(gDir.spriteList, #DoorStart) - 1
    n = 1
    repeat while n <= 3
      tempObj = getAt(sprite(n + tempSP).undefined, 1)
      if tempObj.doortracking = 1 then
        if tempObj.mediaName = "02" then
          overDoor = #ToJunkPile
        else
          n = 1 + n
        end if
        if showingUseView then
          letGoOfPart(gDir.partsCommon, showingUseView, #car)
        else
          if symbolp(overDoor) and count(gDir.mouseOverCar) = 0 then
            tmpPile = symbol("pile" & gMulleGlobals.user.myLastPile)
            if checkFull(gMulleGlobals.junkPileHandlers, tmpPile) then
              letGoOfPart(gDir.partsCommon, partId, point(mouseH, the mouseV))
              sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #fullPile)
            else
              letGoOfPart(gDir.partsCommon, partId, overDoor)
            end if
          else
            letGoOfPart(gDir.partsCommon, partId, point(mouseH, the mouseV))
          end if
        end if
        exit
      end if
    end repeat
  end if
end