on beginSprite(me)
  Active = 0
  showingUseView = 0
  dragObject = new(script("SafeDragScript"), me)
  activate(dragObject, 0)
  dragging = 0
  exit
end

on startDrag(me, thePartId)
  dragging = 1
  partId = thePartId
  part = getPart(gMulleGlobals.parts, partId)
  myMember = getJunkView(part)
  sprite(me.spriteNum).undefined = member(myMember)
  justStarted = 1
  Active = 1
  showingUseView = 0
  activate(dragObject, 1)
  exit
end

on exitFrame(me)
  if Active then
    tempMouseLoc = point(the mouseH, the mouseV)
    sprite(me.spriteNum).undefined = tempMouseLoc
  end if
  exit
end

on mouseUp(me)
  dragging = 0
  exit
end

on report(me, theObject, what)
  if what = #clicked then
    activate(dragObject, 0)
    Active = 0
    sprite(me.spriteNum).undefined = member("Dummy")
    overDoor = 0
    tempSP = getProp(gDir.spriteList, #DoorStart) - 1
    n = 1
    repeat while n <= 2
      tempObj = getAt(sprite(n + tempSP).undefined, 1)
      if tempObj.doortracking = 1 then
        if tempObj.mediaName = "03" or tempObj.mediaName = "garage" then
          overDoor = #ToShopFloor
        else
          n = 1 + n
        end if
        if showingUseView then
          letGoOfPart(gDir.partsCommon, showingUseView, #car)
        else
          if symbolp(overDoor) then
            letGoOfPart(gDir.partsCommon, partId, overDoor, point(the mouseH, the mouseV))
          else
            letGoOfPart(gDir.partsCommon, partId, point(the mouseH, the mouseV))
          end if
        end if
        exit
      end if
    end repeat
  end if
end