on translate_cursor(me, Setting, image, mask, Custom)
  if Custom then
    val = [member(image), member(mask)]
    return(val)
  end if
  return(Setting)
  exit
end

on beginSprite(me)
  oldcursor = sprite(me.spriteNum).cursor
  val = translate_cursor(me, me.incursSet, customImage, customMask, useCustom)
  sprite(me.spriteNum).cursor = val
  exit
end

on endSprite(me)
  sprite(me.spriteNum).cursor = oldcursor
  exit
end

on getPropertyDescriptionList()
  p_list = [#incursSet:[#comment:"Pointer Image:", #format:#cursor, #default:1], #useCustom:[#comment:"Use Custom Pointer:", #format:#boolean, #default:0], #customImage:[#comment:"Custom Image:", #format:#bitmap, #default:member(1)], #customMask:[#comment:"Custom Mask:", #format:#bitmap, #default:member(1)]]
  return(p_list)
  exit
end

on getBehaviorDescription()
  return("Changes the pointer image when the pointer rolls over the current sprite. Choose one of the pointers included with Director, or specify a 1-bit bitmapped cast member." & "\r" & "PARAMETERS:" & "\r" & "� Pointer Image - Choose one of Director's included pointers." & "\r" & "� Use Custom Pointer - Turn this option on to specify a cast member instead of an included pointer." & "\r" & "� Custom Image  - ( optional ) Choose a cast member to use as the pointer image.  This choice is ignored unless Use Custom Pointer is on." & "\r" & "� Custom Mask - ( optional ) Choose a cast member to use as mask image.")
  exit
end