on beginSprite(me)
  doortracking = 0
  trackRect = sprite(me.spriteNum).undefined
  screenObject = new(script("screenObject"), me, trackRect, 0)
  addScreenObject(gDir, screenObject)
  activeClick = 1
  locked = 0
  if gDir.carOnYard then
    locked = 1
  end if
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on mouseEnter(me)
  if not locked then
    if activeClick then
      if not doortracking then
        doortracking = 1
        play(gSound, "02e016v0", #EFFECT)
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
        if gDir.partsCommon.tracking then
          sendSprite(115, #c_MoveRight)
        else
          sendSprite(115, #C_Right)
        end if
      end if
    end if
  end if
  exit
end

on prepareFrame(me)
  if not locked then
    if doortracking then
      if not inside(point(the mouseH, the mouseV), trackRect) then
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
        play(gSound, "02e015v0", #EFFECT)
        sendSprite(115, #C_Standard)
        doortracking = 0
      end if
    end if
  end if
  exit
end

on report(me, theObject, what)
  if not locked then
    tempCheck = 0
    if what = #clicked then
      tempCheck = 0
      if gDir.carOnYard then
        if mediaName = "05" then
          startCheck = sendSprite(getaProp(gDir.spriteList, #mulleInCar), #getProperty, #OkToRun)
          if startCheck then
            crashCheck = sendSprite(getaProp(gDir.spriteList, #mulleInCar), #getProperty, #CrashState)
            if crashCheck = 0 then
              if goToType = #marker then
              else
              end if
            else
              if count(crashCheck) = 2 then
                tempCheck = 1
                tmpmarker = getAt(crashCheck, random(count(crashCheck)))
              else
                if count(crashCheck) = 1 then
                  tempCheck = 1
                  tmpmarker = getAt(crashCheck, 1)
                end if
              end if
            end if
          end if
        else
          if tempCheck = 0 then
            gMulleGlobals.user.toYardThroughDoor = 1
            if goToType = #marker then
              go(string(mediaName))
            else
              go(1, mediaName)
            end if
          end if
        end if
      else
        gMulleGlobals.user.toYardThroughDoor = 1
        gMulleGlobals.WhereFrom = "04"
        if goToType = #marker then
          go(string(mediaName))
        else
          go(1, mediaName)
        end if
      end if
    end if
  end if
  exit
end

on getPropertyDescriptionList()
  p_list = [#mediaName:[#comment:"the name of the destination marker:", #format:#string, #default:""], #goToType:[#comment:"Destination is:", #format:#symbol, #range:[#movie, #marker], #default:#marker]]
  return(p_list)
  exit
end