on beginSprite(me)
  doortracking = 0
  trackRect = sprite(the currentSpriteNum).undefined
  screenObject = new(script("screenObject"), me, trackRect, 0)
  addScreenObject(gDir, screenObject)
  activeClick = 1
  alwaysOpen = 0
  locked = 0
  if gDir.carOnYard then
    alwaysOpen = 1
    sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
  end if
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on mouseEnter(me)
  if not locked then
    if activeClick then
      if not doortracking and not alwaysOpen then
        doortracking = 1
        play(gSound, "02e016v0", #OPEFFECT)
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined + 1
        if gDir.partsCommon.tracking then
          sendSprite(115, #c_MoveRight)
        else
          sendSprite(115, #C_Right)
        end if
      end if
    end if
  end if
  exit
end

on prepareFrame(me)
  if not locked then
    if doortracking and not alwaysOpen then
      if not inside(point(the mouseH, the mouseV), trackRect) then
        sprite(the currentSpriteNum).undefined = sprite(the currentSpriteNum).undefined - 1
        play(gSound, "02e015v0", #OPEFFECT)
        sendSprite(115, #C_Standard)
        doortracking = 0
      end if
    end if
  end if
  exit
end

on report(me, theObject, what)
  if not locked then
    if activeClick then
      if alwaysOpen then
        if what = #over then
          doortracking = 1
          if the mouseDown then
            sendSprite(115, #c_MoveRight)
          else
            sendSprite(115, #C_Right)
          end if
        else
          if what = #NotOver then
            doortracking = 0
            sendSprite(115, #C_Standard)
          end if
        end if
      end if
      tempCheck = 0
      gMulleGlobals.user.toYardThroughDoor = 0
      if what = #clicked then
        if gDir.carOnYard then
          activeClick = 0
          gMulleGlobals.WhereFrom = "04_car"
          gMulleGlobals.user.toYardThroughDoor = 0
          if goToType = #marker then
            go(string(mediaName))
          else
            go(1, mediaName)
          end if
        else
          gMulleGlobals.WhereFrom = "04_nocar"
          go("NoCar")
        end if
      end if
    end if
  end if
  exit
end

on getPropertyDescriptionList()
  p_list = [#mediaName:[#comment:"the name of the destination marker:", #format:#string, #default:""], #goToType:[#comment:"Destination is:", #format:#symbol, #range:[#movie, #marker], #default:#marker]]
  return(p_list)
  exit
end