on beginSprite(me)
  type = #Mulle
  mode = #wait
  tempList = sprite(me.spriteNum).undefined
  NoBreaks = 0
  NoStearing = 0
  OkToRun = 0
  activeClick = 1
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if index.type = #SpriteAnim then
      animObject = index
    end if
  end repeat
  -- UNK_65 3
  FrozenAction = ""
  intoMail = 0
  currentAnimChart = "MulleCar"
  exit
end

on activate(me, theState)
  activeClick = theState
  exit
end

on describepart(me, theDescription)
  �nejj()
  mode = #Talk
  makeAnimSpeech(animObject, theDescription)
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end

on randomMove(me, maxRnd)
  tempMode = 0
  -- UNK_64 0
  if ERROR = 1 then
    tempMode = #Talk
    makeAnimSpeech(animObject, getAt(startSounds, random(count(startSounds))))
  end if
  -- UNK_65 1
  if symbolp(tempMode) then
    mode = tempMode
    sendSprite(me.spriteNum, #setAnimAction, mode)
  end if
  exit
end

on getProperty(me, theProp)
  if theProp = #OkToRun then
    return(OkToRun)
  else
    if theProp = #CrashState then
      if NoBreaks = 1 and NoStearing = 1 then
        return(["noBrakes", "NoStearing"])
      else
        if NoBreaks = 1 then
          return(["noBrakes"])
        else
          if NoStearing = 1 then
            return(["NoStearing"])
          else
            return(0)
          end if
        end if
      end if
    end if
  end if
  exit
end

on setMulleSpeak(me)
  crashSounds = []
  startSounds = []
  if getaProp(gDir.carCopy.carProperties, #Steering) = 0 then
    add(crashSounds, "04d005v0")
    NoStearing = 1
  end if
  if getaProp(gDir.carCopy.carProperties, #break) = 0 then
    add(crashSounds, "04d006v0")
    NoBreaks = 1
  end if
  if getaProp(gDir.carCopy.carProperties, #Pedals) = 0 then
    if getaProp(gDir.carCopy.carProperties, #acceleration) = 0 then
      add(startSounds, "04d004v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #EngineType) = 0 then
      add(startSounds, "04d022v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #ElectricVolume) = 0 then
      add(startSounds, "04d003v0")
    end if
    if getaProp(gDir.carCopy.carProperties, #FuelVolume) = 0 then
      if getaProp(gDir.carCopy.carProperties, #EngineType) <> 3 then
        add(startSounds, "04d002v0")
      end if
    end if
  else
    startSounds = []
  end if
  if startSounds = [] then
    add(startSounds, "04d008v0")
    add(startSounds, "04d009v0")
    add(startSounds, "04d010v0")
    OkToRun = 1
  end if
  if crashSounds = [] and startSounds = [] then
    add(startSounds, "04d007v0")
  end if
  exit
end

on loop(me)
  if the frame = 2 then
    deleteLoopObject(gDir, me)
    MakeMulleSpeak(me, FrozenAction)
  end if
  exit
end

on MakeMulleSpeak(me, theAction)
  if the frame = 1 then
    FrozenAction = theAction
    addLoopObject(gDir, me)
  else
    if not theAction = #Refuse and mode = #Talk then
      playAnimSound(animObject, "")
    end if
    if theAction = #shopFull then
      n = random(3)
      -- UNK_64 0
      if ERROR = 1 then
        theSnd = "04d016v0"
      else
        -- UNK_64 0
        if ERROR = 2 then
          theSnd = "04d017v0"
        else
          -- UNK_64 0
          if ERROR = 3 then
            theSnd = "04d018v0"
          end if
        end if
      end if
      -- UNK_65 1
    else
      if theAction = #Refuse then
        if mode <> #Talk then
          theSnd = getAt(startSounds, random(count(startSounds)))
        end if
      else
        if theAction = #package then
          n = random(3)
          -- UNK_64 0
          if ERROR = 1 then
            theSnd = "04d013v0"
          else
            -- UNK_64 0
            if ERROR = 2 then
              theSnd = "04d014v0"
            else
              -- UNK_64 0
              if ERROR = 3 then
                theSnd = "04d015v0"
              end if
            end if
          end if
          -- UNK_65 1
        else
          if theAction = #FiggeRemark then
            theSnd = "04d021v0"
          else
            if theAction = #noMail then
              theSnd = "04d001v0"
            else
              if theAction = #Mail then
                intoMail = 1
                theSnd = "04d020v0"
              end if
            end if
          end if
        end if
      end if
    end if
    currentAnimChart = #TalkToMe
    sendSprite(the currentSpriteNum, #setAnimChart, "MulleCarTalk")
    if not theAction = #Refuse and mode = #Talk then
      mode = #Talk
      makeAnimSpeech(animObject, theSnd)
      sendSprite(me.spriteNum, #setAnimAction, #Talk)
    end if
    gDir.gCurrentSound = theSnd
  end if
  exit
end

on Stopped(me)
  -- UNK_64 0
  if ERROR = #Talk then
    if intoMail then
      intoMail = 0
      performMission(gMulleGlobals.missions)
    end if
    if currentAnimChart = #TalkToMe then
      sendSprite(the currentSpriteNum, #setAnimChart, "MulleCar")
    end if
    setAnimNormal(animObject)
    tempMode = #wait
    gDir.gCurrentSound = ""
  else
    tempMode = #wait
  end if
  -- UNK_65 1
  mode = tempMode
  sendSprite(me.spriteNum, #setAnimAction, mode)
  exit
end