on beginSprite(me)
  activeClick = 1
  engineSnd = 0
  crashSnd = 0
  SP = 0
  okToLeave = 0
  exit
end

on activateClick(me, theState)
  activeClick = theState
  exit
end

on loop(me)
  if finished(gSound, engineSnd) then
    deleteLoopObject(gDir, me)
    crashSnd = play(gSound, "04e002v0", #EFFECT)
    GoOut(me)
  end if
  exit
end

on mouseEnter(me)
  if activeClick then
    if gDir.carOnYard then
      sendSprite(115, #c_click)
    end if
  end if
  exit
end

on mouseLeave(me)
  if activeClick then
    if gDir.carOnYard then
      sendSprite(115, #C_Standard)
    end if
  end if
  exit
end

on mouseUp(me)
  if activeClick then
    if gDir.carOnYard then
      gMulleGlobals.WhereFrom = "04"
      SP = getaProp(gDir.spriteList, #mulleInCar)
      if sprite(SP).OkToRun then
        if sprite(SP).crashSounds = [] then
          put("Its ok, no crash")
          if nrOfWorlds(gMulleGlobals.worlds) > 1 then
            checkNrofBuiltCars(me)
            activate(gDir, 0)
            window("test").rect = rect(the stageLeft + 109, the stageTop + 90, the stageLeft + 531, the stageTop + 390)
            cursor(-1)
            cursor(200)
            window("test").titleVisible = 0
            window("test").fileName = "18"
            window("test").visible = 1
          else
            okToLeave = 1
            checkNrofBuiltCars(me)
            kickEngine(me)
          end if
        else
          kickEngine(me)
        end if
        sendSprite(getaProp(gDir.spriteList, #mulleInCar), #setAnimAction, #Still)
      else
        sendSprite(getaProp(gDir.spriteList, #mulleInCar), #MakeMulleSpeak, #Refuse)
      end if
    end if
  end if
  exit
end

on checkNrofBuiltCars(me)
  if gDir.carCopy.enterParts <> gDir.carCopy.parts then
    gMulleGlobals.user.nrOfBuiltCars = gMulleGlobals.user.nrOfBuiltCars + 1
    gMulleGlobals.user.figgeIsComing = 1
    gMulleGlobals.user.missionIsComing = 1
  end if
  gDir.carCopy.enterParts = duplicate(gDir.carCopy.parts)
  exit
end

on kickEngine(me)
  activate(gDir, 0)
  -- UNK_64 0
  if ERROR = 1 then
    engineSnd = play(gSound, "05e074v0", #EFFECT)
  else
    -- UNK_64 0
    if ERROR = 2 then
      engineSnd = play(gSound, "05e067v0", #EFFECT)
    else
      -- UNK_64 0
      if ERROR = 3 then
        engineSnd = play(gSound, "05e025v0", #EFFECT)
      else
        -- UNK_64 0
        if ERROR = 4 then
          engineSnd = play(gSound, "05e004v0", #EFFECT)
        else
          -- UNK_64 0
          if ERROR = 5 then
            engineSnd = play(gSound, "05e011v0", #EFFECT)
          else
            -- UNK_64 0
            if ERROR = 6 then
              engineSnd = play(gSound, "05e053v0", #EFFECT)
            else
              -- UNK_64 0
              if ERROR = 7 then
                engineSnd = play(gSound, "05e018v0", #EFFECT)
              else
                -- UNK_64 0
                if ERROR = 8 then
                  engineSnd = play(gSound, "05e060v0", #EFFECT)
                else
                  -- UNK_64 0
                  if ERROR = 9 then
                    engineSnd = play(gSound, "05e032v0", #EFFECT)
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  if okToLeave = 1 then
    okToLeave = 0
    gDir.gCurrentSound = engineSnd
    go("05")
  else
    addLoopObject(gDir, me)
  end if
  exit
end

on GoOut(me)
  put("SP ", SP)
  put("crashsounds ", sprite(SP).crashSounds)
  if count(sprite(SP).crashSounds) = 2 then
    if random(2) = 1 then
      go("fence")
    else
      go("offroad")
    end if
  else
    if count(sprite(SP).crashSounds) = 1 then
      if getAt(sprite(SP).crashSounds, 1) = "04d005v0" then
        go("offroad")
      else
        if getAt(sprite(SP).crashSounds, 1) = "04d006v0" then
          go("fence")
        end if
      end if
    end if
  end if
  exit
end