on mouseEnter(me)
  sprite(me.spriteNum).undefined = me.alternateImage
  exit
end

on mouseLeave(me)
  sprite(me.spriteNum).undefined = me.standardImage
  exit
end

on beginSprite(me)
  me.standardImage = sprite(me.spriteNum).undefined
  if nextCM = 1 then
    memref = sprite(the currentSpriteNum).undefined
    castLibNum = memref.castLibNum
    memdefault = member(member(memref).memberNum + 1, castLibNum)
    alternateImage = memdefault
  end if
  exit
end

on getPropertyDescriptionList()
  if the currentSpriteNum = 0 then
    memdefault = 0
  else
    memref = sprite(the currentSpriteNum).undefined
    castLibNum = memref.castLibNum
    memdefault = member(member(memref).memberNum + 1, castLibNum)
  end if
  p_list = [#nextCM:[#comment:"Use Next Member:", #format:#boolean, #default:1], #alternateImage:[#comment:"Rollover Cast Member:", #format:#graphic, #default:memdefault]]
  return(p_list)
  exit
end

on getBehaviorDescription()
  return("Change the sprite's cast member when the mouse rolls over the current sprite." & "\r" & "PARAMETERS:" & "\r" & "� Use Next Member - Turn this option on to automatically display the next cast member in the cast when mouse rolls over the sprite." & "\r" & "� Rollover Cast Member - Choose a specific cast member to appear when the mouse rolls over the sprite. This setting is ignored if Use Next Member is on.")
  exit
end