on new(me, theMaster, isShow)
  limitList = [10, 20, 40, 70]
  masterObject = theMaster
  sort(limitList)
  lastSpeed = 0
  SP = getProp(gDir.spriteList, #car)
  if isShow = #show then
    firstFrame = sprite(0).number - 36
  else
    firstFrame = sprite(0).number
  end if
  mode = #normal
  soundOn = 1
  visible = 1
  addLoopObject(gDir, me)
  return(me)
  exit
end

on setEngine(me, theEngineNr)
  if voidp(theEngineNr) then
    engine = getProp(masterObject.quickCarProps, #EngineType)
  else
    engine = theEngineNr
  end if
  if engine > 0 then
    tempSnds = [["05e073v0", "05e079v0", "05e074v0", "05e075v0", "05e076v0", "05e077v0", "05e078v0"], ["05e067v0", "05e073v0", "05e068v0", "05e069v0", "05e070v0", "05e071v0", "05e072v0"], ["05e025v0", "05e031v0", "05e026v0", "05e027v0", "05e028v0", "05e029v0", "05e030v0"], ["05e004v0", "05e010v0", "05e005v0", "05e006v0", "05e007v0", "05e008v0", "05e009v0"], ["05e011v0", "05e017v0", "05e012v0", "05e013v0", "05e014v0", "05e015v0", "05e016v0"], ["05e053v0", "05e059v0", "05e054v0", "05e055v0", "05e056v0", "05e057v0", "05e058v0"], ["05e018v0", "05e024v0", "05e019v0", "05e020v0", "05e021v0", "05e022v0", "05e023v0"], ["05e060v0", "05e066v0", "05e061v0", "05e062v0", "05e063v0", "05e064v0", "05e065v0"], ["05e032v0", "05e038v0", "05e033v0", "05e034v0", "05e035v0", "05e036v0", "05e037v0"]]
    if engine < 1 or engine > count(tempSnds) then
      engine = 1
    end if
    sndList = getAt(tempSnds, engine)
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      snd = getAt()
      preloadMember(snd)
    end repeat
    -- UNK_65 3
    changecarSound(me)
    changecarSound(me)
  end if
  exit
end

on kill(me)
  deleteLoopObject(gDir, me)
  sprite(SP).undefined = member("Dummy")
  return(0)
  exit
end

on changecarSound(me, onOff)
  if voidp(onOff) then
    soundOn = not soundOn
  else
    soundOn = onOff
  end if
  if soundOn then
    lastSpeed = -4711
  else
    stop(gSound, sndId)
  end if
  exit
end

on show(me, YesNo)
  visible = YesNo
  if YesNo = 0 then
    sprite(SP).undefined = member("Dummy")
  else
    SP = getProp(gDir.spriteList, #car)
    display(me)
  end if
  exit
end

on display(me)
  if gDir.mode = #Driving or gDir.mode = #Showing then
    if visible then
      -- UNK_64 0
      if ERROR = #normal then
        step(masterObject)
        sprite(SP).undefined = getShowCoordinate(masterObject)
        sprite(SP).undefined = member(firstFrame + getDirection(masterObject) + 2 + getInclination(masterObject) * 16)
        speed = abs(getSpeed(masterObject))
        maxSpeed = getProp(masterObject.quickCarProps, #speed) / 100
        percent = 100 * speed / maxSpeed
        if soundOn then
          add(limitList, percent)
          tempPos = getPos(limitList, percent)
          deleteAt(limitList, tempPos)
          if tempPos <> lastSpeed then
            lastSpeed = tempPos
            stop(gSound, sndId)
            sndId = play(gSound, getAt(sndList, tempPos + 2), #BG)
          end if
        end if
      end if
      -- UNK_65 1
    end if
  end if
  exit
end

on stopEngine(me)
  sndId = play(gSound, getAt(sndList, 2), #BG)
  exit
end

on loop(me)
  display(me)
  exit
end