on beginSprite(me)
  SP = me.spriteNum
  insideLast = 0
  firstFrame = sprite(0).number
  spriteRect = rect(0, 0, 640, 480)
  cursorList = []
  sort(cursorList)
  exit
end

on display(me)
  mouseLoc = point(the mouseH, the mouseV)
  sprite(SP).undefined = mouseLoc
  if mode = #mouse then
    if count(cursorList) = 1 then
      cursor([firstFrame + 2 * gDir.carDriving.cursorDirection - 2, firstFrame + 2 * gDir.carDriving.cursorDirection - 1])
      sprite(SP).undefined = member("Dummy")
    end if
  end if
  exit
end

on exitFrame(me)
  display(me)
  exit
end

on setMode(me, theMode)
  mode = theMode
  if mode = #Keys then
    cursor(200)
    sprite(SP).undefined = member(getAt(cursorList, count(cursorList)))
  end if
  exit
end

on MEnter(me, theCursor, theChannel)
  cursor(200)
  if voidp(theChannel) then
    theChannel = 200
  end if
  deleteProp(cursorList, theChannel)
  addProp(cursorList, theChannel, theCursor)
  sprite(SP).undefined = member(getAt(cursorList, count(cursorList)))
  exit
end

on MLeave(me, theChannel)
  cursor(200)
  if voidp(theChannel) then
    theChannel = 200
  end if
  deleteProp(cursorList, theChannel)
  sprite(SP).undefined = member(getAt(cursorList, count(cursorList)))
  exit
end

on C_Standard(me)
  MEnter(me, "C_Standard")
  exit
end

on c_grab(me)
  MEnter(me, "C_Grab")
  exit
end

on c_Left(me)
  MEnter(me, "C_Left")
  exit
end

on c_click(me)
  MEnter(me, "C_Click")
  exit
end

on C_Back(me)
  MEnter(me, "C_Back")
  exit
end

on C_Right(me)
  MEnter(me, "C_Right")
  exit
end