on beginSprite(me)
  Active = 1
  tempRect = sprite(me.spriteNum).undefined
  extend = 12
  tempRect = rect(getAt(tempRect, 1) - extend, getAt(tempRect, 2) - extend, getAt(tempRect, 3) + extend, getAt(tempRect, 4) + extend)
  screenObject = new(script("ScreenObject"), me, tempRect, #normal)
  addScreenObject(gDir, screenObject)
  exit
end

on activate(me, YesNo)
  Active = YesNo
  exit
end

on report(me, theObject, what)
  if what = #clicked then
    clicked(me)
  end if
  exit
end

on clicked(me)
  if Active then
    tempCar = getSavedCars(gMulleGlobals.user, SaveNr)
    if SaveNr <> gDir.chosenSlot then
      play(gSound, "06e003v0", #OPEFFECT)
    end if
    if listp(tempCar) then
      occupied = 1
      choseSlot(gDir, SaveNr, occupied)
      eraseCar(me)
      medals = getaProp(tempCar, #medals)
      tempStartLoc = point(570, 65)
      tempSP = getProp(gDir.spriteList, #MedalsStart)
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        -- UNK_64 0
        if ERROR = 1 then
          tempMedal = "00n004v0"
        else
          -- UNK_64 0
          if ERROR = 2 then
            tempMedal = "00n005v0"
          else
            -- UNK_64 0
            if ERROR = 3 then
              tempMedal = "00n006v0"
            else
              -- UNK_64 0
              if ERROR = 4 then
                tempMedal = "00n007v0"
              else
                -- UNK_64 0
                if ERROR = 5 then
                  tempMedal = "00n010v0"
                else
                  -- UNK_64 0
                  if ERROR = 6 then
                    tempMedal = "00n009v0"
                  end if
                end if
              end if
            end if
          end if
        end if
        -- UNK_65 1
        sprite(tempSP + index - 1).undefined = member(tempMedal)
        sprite(tempSP + index - 1).undefined = tempStartLoc + point(0, 62) * index - 1
      end repeat
      -- UNK_65 3
      name = getaProp(tempCar, #name)
      member("SavedCarName").text = name
      if gDir.mode = #save then
        member("SavedCarName").editable = 1
      end if
      the selStart = length(name)
      the selEnd = length(name)
      sendSprite(getProp(gDir.spriteList, #CarStart), #drawCar, void(), void(), getaProp(tempCar, #parts))
    else
      occupied = 0
      choseSlot(gDir, SaveNr, occupied)
      member("SavedCarName").editable = 0
      eraseCar(me)
      member("SavedCarName").text = " "
      member("SavedCarName").editable = 0
    end if
    sprite(SaveNr - 1).undefined = member("06n003v0" + sprite(0).number)
  end if
  exit
end

on eraseCar(me)
  tempSP = getProp(gDir.spriteList, #CarStart) - 1
  n = 1
  repeat while n <= 35
    sprite(tempSP + n).undefined = member("Dummy")
    n = 1 + n
  end repeat
  n = 1
  repeat while n <= 6
    sprite(getProp(gDir.spriteList, #MedalsStart) + n - 1).undefined = member("Dummy")
    n = 1 + n
  end repeat
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#SaveNr:[#comment:"Which save:", #format:#integer, #range:[#min:1, #max:12], #default:1]]
  return(p_list)
  exit
end