on mouseUp(me)
  file = new(xtra("FileIO"))
  if mode = #save then
    if gDir.slotOccupied then
      tempCar = gDir.chosenSlot
      tempDefault = correctFileName(me, member("SavedCarName").text)
      tempDefault = tempDefault.char[1..8] & ".car"
    else
      file = 0
      exit
      tempCar = 0
      tempDefault = "MinBil.car"
    end if
    tempTitle = "Spara din bil"
    path = displaySave(file, tempTitle, tempDefault)
    if length(path) = 0 then
      file = 0
      exit
    end if
    if the machineType = 256 then
      tempLength = length(path)
      n = tempLength
      repeat while n >= 1
        if path.char[n] = "\\" then
          tempPath = path.char[1..n]
          tempName = path.char[n + 1..tempLength]
        else
          n = 255 + n
        end if
      end repeat
      tempOff = offset(".", tempName)
      if tempOff then
      end if
      tempName = correctFileName(me, tempName)
      tempName = tempName.char[1..8]
      path = tempPath & tempName & ".car"
    end if
    openFile(file, path, 0)
    if status(file) = 0 then
      alert("File already exists")
      file = 0
      exit
    end if
    createFile(file, path)
    openFile(file, path, 2)
    if status(file) <> 0 then
      alert("Problem creating file (" & string(status(file)) & ")")
    end if
    if tempCar then
      tempCar = getSavedCars(gMulleGlobals.user, tempCar)
      tempStr = string(tempCar)
    else
      tempStr = string(toList(gMulleGlobals.user.car))
    end if
    writeString(file, tempStr)
    closeFile(file)
  else
    if mode = #load then
      if the machineType = 256 then
        setFilterMask(file, "Cars *.car, *.car, All Files *.*, *.*")
      end if
      path = displayOpen(file)
      if stringp(path) then
        openFile(file, path, 0)
        if status(file) <> 0 then
          alert("Problem opening file")
          file = 0
          exit
        end if
        tempStr = readFile(file)
        tempList = value(tempStr)
        if listp(tempList) then
          tempCar = new(script("Car"))
          fromList(tempCar, tempList)
          tempParts = tempCar.parts
          -- UNK_64 0
          -- UNK_64 0
          -- UNK_64 2
          repeat while ERROR <= ERROR
            -- UNK_64 2
            -- UNK_64 1
            index = getAt()
            if findPart(gMulleGlobals.user, index) = 0 then
              play(gSound, "07d002v0", #EFFECT)
              closeFile(file)
              file = 0
              exit
            end if
          end repeat
          -- UNK_65 3
          closeFile(file)
          file = 0
          loadCar(gDir, tempList)
          exit
        else
          alert("File corrupt")
        end if
      end if
    end if
  end if
  closeFile(file)
  file = 0
  exit
end

on correctFileName(me, theName)
  if the machineType = 256 then
    theName = changeChars(" ", "", theName)
    theName = changeChars("\\", "", theName)
    theName = changeChars("*", "", theName)
    theName = changeChars(":", "", theName)
    theName = changeChars("?", "", theName)
    theName = changeChars("\"", "", theName)
    theName = changeChars(".", "", theName)
  else
    theName = changeChars(":", "", theName)
    theName = changeChars(".", "", theName)
  end if
  return(theName)
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#mode:[#comment:"Save or load", #format:#symbol, #range:[#save, #load], #default:#save]]
  return(p_list)
  exit
end