on new(me)
  sndId = 0
  return(me)
  exit
end

on checkFolder(me)
  file = new(xtra("FileIO"))
  path = gPathGlobals.carPath
  fileList = []
  sort(fileList)
  n = 1
  repeat while n <= the maxinteger
    tempStr = getNthFileNameInFolder(path, n)
    if tempStr = "" then
    else
      tempLen = length(tempStr)
      if tempStr.char[tempLen - 3..tempLen] = ".car" then
        if gDir.mode = #load then
          openFile(file, path & tempStr, 1)
          tempStr = tempStr.char[1..tempLen - 4]
          if status(file) = 0 then
            tempLen = getLength(file)
            if tempLen > 0 and tempLen < 10 * 1024 then
              tempCar = value(readFile(file))
              if listp(tempCar) then
                if checkCar(me, tempCar) then
                  add(fileList, tempStr)
                else
                  add(fileList, "?" & tempStr)
                end if
              end if
            end if
          end if
        else
          tempStr = tempStr.char[1..tempLen - 4]
          add(fileList, tempStr)
        end if
        closeFile(file)
      end if
      n = 1 + n
    end if
  end repeat
  file = 0
  return(fileList)
  exit
end

on checkCar(me, theCar)
  tempParts = getaProp(theCar, #parts)
  if not listp(tempParts) then
    return(0)
  end if
  if gDir.cheatLoad then
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      part = getPart(gMulleGlobals.parts, index)
      if part = 0 then
        return(0)
      end if
      partId = getMaster(part)
      if not getMaster(part) > 0 then
        partId = index
      end if
      if getPart(gMulleGlobals.parts, partId) = 0 then
        return(0)
      end if
    end repeat
    -- UNK_65 3
  else
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      part = getPart(gMulleGlobals.parts, index)
      partId = getMaster(part)
      if not getMaster(part) > 0 then
        partId = index
      end if
      if findPart(gMulleGlobals.user, partId) = 0 then
        return(0)
      end if
    end repeat
    -- UNK_65 3
  end if
  return(1)
  exit
end

on loadCar(me, theName)
  path = gPathGlobals.carPath & theName & ".car"
  file = new(xtra("FileIO"))
  openFile(file, path, 0)
  if status(file) <> 0 then
    file = 0
    return("Problem opening file")
  end if
  tempStr = readFile(file)
  tempList = value(tempStr)
  if listp(tempList) then
    tempResult = checkCar(me, tempList)
    if tempResult = 0 then
      stopAllEffects(gSound)
      play(gSound, "07d002v0", #EFFECT)
      closeFile(file)
      file = 0
      return(0)
    end if
    closeFile(file)
    file = 0
    return(tempList)
  else
    closeFile(file)
    file = 0
    return("File corrupt")
  end if
  closeFile(file)
  file = 0
  return(0)
  exit
end

on saveCar(me, theName)
  if gDir.slotOccupied then
    tempCar = gDir.chosenSlot
  else
    tempCar = 0
  end if
  theName = correctFileName(theName) & ".car"
  path = gPathGlobals.carPath & theName
  file = new(xtra("FileIO"))
  openFile(file, path, 2)
  if status(file) = 0 then
    setPosition(file, 0)
    writeString(file, "")
    setPosition(file, 0)
  else
    createFile(file, path)
    openFile(file, path, 2)
  end if
  if status(file) <> 0 then
    alert("Problem creating file (" & string(status(file)) & ")")
    closeFile(file)
    file = 0
    exit
  end if
  if tempCar then
    tempCar = getSavedCars(gMulleGlobals.user, tempCar)
    tempStr = string(tempCar)
  else
    tempStr = string(toList(gMulleGlobals.user.car))
  end if
  writeString(file, tempStr)
  closeFile(file)
  file = 0
  exit
end