on beginSprite(me)
  init(me)
  exit
end

on init(me)
  spriteList = [#title:55, #Signature:56, #CarName:59, #userName:57, #to:58, #LeftR:60, #RightR:61]
  spriteStartV = [#CarName:0, #userName:0, #to:0]
  n = 1
  repeat while n <= count(spriteStartV)
    tempProp = getPropAt(spriteStartV, n)
    setProp(spriteStartV, tempProp, 240 - sprite(getProp(spriteList, tempProp)).locV)
    n = 1 + n
  end repeat
  carSP = 4
  carStartV = 240 - sprite(4 + 7).locV
  carStartH = sprite(4 + 7).locH
  nrOfSteps = 3
  nowAt = 1
  totHeight = 812 - 300
  stepV = totHeight / nrOfSteps
  startV = 240 + nowAt * stepV
  tempMembers = ["00n004v0", "00n005v0", "00n006v0", "00n007v0", "00n010v0", "00n009v0"]
  tempText = ["08t001v0", "08t002v0", "08t003v0", "08t004v0", "08t005v0", "08t006v0"]
  medalsSP = 63
  medalsStartV = 200 - sprite(medalsSP).locV
  tempStartH = 70
  tempWidth = 90
  n = 1
  repeat while n <= 6
    if getMedal(gMulleGlobals.user.car, n) then
      sprite(medalsSP + n - 1).undefined = member(getAt(tempMembers, n))
      sprite(medalsSP + n - 1 + 6).undefined = member(getAt(tempText, n))
      sprite(medalsSP + n - 1).locH = tempStartH + tempWidth * n - 1
      sprite(medalsSP + n - 1 + 6).locH = sprite(medalsSP + n - 1).locH - 43
    else
      sprite(medalsSP + n - 1).undefined = member("Dummy")
      sprite(medalsSP + n - 1 + 6).undefined = member("Dummy")
    end if
    n = 1 + n
  end repeat
  show(me)
  updateStage()
  exit
end

on ScrollToMid(me)
  nowAt = 2
  show(me)
  exit
end

on scroll(me, theDirection)
  if theDirection = -1 and nowAt > 1 then
    nowAt = nowAt + theDirection
    show(me)
  else
    if theDirection = 1 and nowAt < nrOfSteps then
      nowAt = nowAt + theDirection
      show(me)
    end if
  end if
  exit
end

on show(me)
  tempV = startV - nowAt - 1 * stepV
  n = 1
  repeat while n <= count(spriteList)
    tempOffset = getaProp(spriteStartV, getPropAt(spriteList, n))
    if voidp(tempOffset) then
      tempOffset = 0
    end if
    sprite(getAt(spriteList, n)).locV = tempV - tempOffset
    n = 1 + n
  end repeat
  n = 1
  repeat while n <= 6
    sprite(medalsSP + n - 1).locV = tempV - medalsStartV
    sprite(medalsSP + n - 1 + 6).locV = tempV - medalsStartV + 40
    n = 1 + n
  end repeat
  sendSprite(carSP, #drawCar, void(), point(carStartH, tempV - carStartV))
  exit
end