on mouseUp(me)
  play(gSound, "SndMouseClick", #EFFECT)
  print(me)
  exit
end

on print(me)
  -- UNK_46 101
  doc = new(xtra("PrintOMatic"))
  if not objectp(doc) then
    unloadMember()
    doc = new(xtra("PrintOMatic"))
    if not objectp(doc) then
      alert("Unable to contact printer", the freeBlock)
      exit
    end if
  end if
  sendSprite(getProp(gDir.spriteList, #Scroller), #ScrollToMid)
  updateStage()
  setMargins(doc, rect(20, 20, 20, 20))
  newPage(doc)
  w = getPageWidth(doc)
  h = getPageHeight(doc)
  carTop = 272
  carLeft = 50
  carWidth = 490
  carHeight = 530
  drawStagePicture(doc, rect(carLeft, carTop, carLeft + carWidth, carTop + carHeight), sprite(getProp(gDir.spriteList, #ToBeCaptured)).undefined)
  append(doc, member("Title"), 0)
  tempTop = 160
  tempLeft = 130
  tempOffset = getAt(charPosToLoc(member("UserName"), 1), 1)
  newFrame(doc, rect(tempLeft + tempOffset, tempTop, tempLeft + 400, tempTop + 50), 0)
  append(doc, member("UserName"), 0)
  tempTop = tempTop + 40
  tempOffset = getAt(charPosToLoc(member("08t007v0"), 1), 1)
  newFrame(doc, rect(tempLeft + tempOffset, tempTop, tempLeft + 400, tempTop + 50), 0)
  append(doc, member("08t007v0"), 0)
  tempTop = tempTop + 20
  tempOffset = getAt(charPosToLoc(member("SavedCarName"), 1), 1)
  newFrame(doc, rect(tempLeft + tempOffset, tempTop, tempLeft + 400, tempTop + 50), 0)
  append(doc, member("SavedCarName"), 0)
  signHeight = 55
  left = 0
  right = w - 1
  tempCorrect = 25
  bottom = h - signHeight + 40 - tempCorrect
  newFrame(doc, rect(195, h - signHeight - tempCorrect, w - 100, h - tempCorrect), 0)
  append(doc, member("08b005v0"), 0)
  drawLine(doc, point(left, 0), point(left, bottom))
  drawLine(doc, point(right, 0), point(right, bottom))
  drawLine(doc, point(left, bottom), point(left + 185, bottom))
  drawLine(doc, point(left + 365, bottom), point(right, bottom))
  medalSpace = 80
  medalLeft = 50
  medalTop = 620
  tempList = ["00n004v0", "00n005v0", "00n006v0", "00n007v0", "00n010v0", "00n009v0"]
  tempText = ["08t001v0", "08t002v0", "08t003v0", "08t004v0", "08t005v0", "08t006v0"]
  n = 1
  repeat while n <= 6
    if getMedal(gMulleGlobals.user.car, n) then
      newFrame(doc, rect(medalLeft + medalSpace * n - 1, medalTop, medalLeft + medalSpace * n - 1 + medalSpace, medalTop + 80), 0)
      append(doc, member(getAt(tempList, n)))
      newFrame(doc, rect(medalLeft + medalSpace * n - 1 - 10, medalTop + 60, medalLeft + medalSpace * n - 1 + medalSpace - 10, medalTop + 80 + 60), 0)
      append(doc, member(getAt(tempText, n)))
    end if
    n = 1 + n
  end repeat
  cursor(-1)
  cursor(200)
  print(doc)
  doc = 0
  cursor(200)
  exit
end