on beginSprite(me)
  soundList = ["11d002v0", "11d003v0", "11d004v0", "11d005v0", "11d006v0"]
  tempList = sprite(me.spriteNum).undefined
  animObject = getAt(tempList, 1)
  tempList = sprite(getProp(gDir.spriteList, #MulleBody)).undefined
  bodyAnimObject = getAt(tempList, 1)
  mode = #Still
  setAnimNormal(animObject)
  setAnimNormal(bodyAnimObject)
  SP = me.spriteNum
  exit
end

on exitFrame(me)
  if whichFrame = #wait then
    if mode = #Still then
      if random(50) = 1 then
        randomMove(me, 8)
      end if
    end if
  end if
  exit
end

on randomMove(me, maxRnd)
  tempRnd = random(maxRnd)
  -- UNK_64 0
  if ERROR = 1 then
    mode = #Kli
    setAnimAction(bodyAnimObject, mode)
    activate(animObject, 0)
    sprite(SP).undefined = member("Dummy")
  else
    -- UNK_64 0
    if ERROR <> 2 then
      -- UNK_64 0
      if ERROR <> 3 then
        -- UNK_64 0
        if ERROR = 4 then
          mode = #Blink
          setAnimAction(animObject, mode)
        else
          -- UNK_64 0
          if ERROR <> 5 then
            -- UNK_64 0
            if ERROR <> 6 then
              -- UNK_64 0
              if ERROR <> 7 then
                -- UNK_64 0
                if ERROR = 8 then
                  mode = #Talk
                  repeat while 1
                    tempSound = random(count(soundList))
                    if tempSound <> lastSound then
                    else
                    end if
                  end repeat
                  lastSound = tempSound
                  makeAnimSpeech(animObject, getAt(soundList, lastSound))
                  setAnimAction(animObject, mode)
                end if
                -- UNK_65 1
                exit
              end if
            end if
          end if
        end if
      end if
    end if
  end if
end

on BeginFrame(me, theLabel)
  whichFrame = theLabel
  -- UNK_64 0
  if ERROR = #Still then
    mode = #VeryStill
  else
    -- UNK_64 0
    if ERROR = #Talk then
      mode = #Talk
      makeAnimSpeech(animObject, "11d001v0")
      setAnimAction(animObject, mode)
    else
      -- UNK_64 0
      if ERROR = #wait then
        mode = #Still
      end if
    end if
  end if
  -- UNK_65 1
  exit
end

on WarnOfThrowing(me)
  if not whichFrame = #Talk then
    go("Wait")
  end if
  mode = #Talk
  setAnimAction(bodyAnimObject, #Still)
  activate(animObject, 1)
  makeAnimSpeech(animObject, "11d007v0")
  setAnimAction(animObject, mode)
  exit
end

on fullAlert(me)
  if not whichFrame = #Talk then
    go("Wait")
  end if
  mode = #Talk
  setAnimAction(bodyAnimObject, #Still)
  activate(animObject, 1)
  makeAnimSpeech(animObject, "11d008v0")
  setAnimAction(animObject, mode)
  exit
end

on Stopped(me)
  if not mode = #TalkPek then
    -- UNK_64 0
    if ERROR = #Kli then
      setAnimNormal(animObject)
      activate(animObject, 1)
    else
      -- UNK_64 0
      if ERROR = #Pek then
        setAnimNormal(animObject)
        activate(animObject, 1)
      else
        -- UNK_64 0
        if ERROR = #Talk then
          setAnimNormal(animObject)
          if whichFrame = #Talk then
            go("Wait")
          end if
        end if
      end if
    end if
    -- UNK_65 1
    mode = #Still
    setAnimAction(animObject, mode)
  else
    mode = #Talk
  end if
  exit
end

on spritecuePassed(me, theChannel, theNr, theName)
  if theName = "Point" then
    if theChannel = animObject.myChannel then
      mode = #TalkPek
      setAnimAction(bodyAnimObject, #Pek)
    end if
  end if
  exit
end