on beginSprite(me)
  SP = me.spriteNum
  myMember = sprite(SP).undefined
  dragging = 0
  ScrollBHType = #trash
  exit
end

on init(me, theMasterSP)
  masterSP = theMasterSP
  exit
end

on scrollThrowHere(me, theSpriteNum, theStr)
  dragging = 0
  if theSpriteNum = masterSP then
    if isInside then
      play(gSound, "11e002v0", #OPEFFECT)
      sendSprite(masterSP, #deleteLine, theStr)
      sprite(SP).undefined = member(myMember + 1)
    end if
  end if
  exit
end

on mouseEnter(me)
  if dragging then
    play(gSound, "11e001v0", #OPEFFECT)
    sendSprite(getProp(gDir.spriteList, #MulleHead), #WarnOfThrowing)
    sprite(SP).undefined = member(myMember + 1)
  end if
  isInside = 1
  exit
end

on mouseLeave(me)
  sprite(SP).undefined = member(myMember)
  isInside = 0
  exit
end

on startDrag(me)
  dragging = 1
  exit
end

on endDrag(me)
  dragging = 0
  exit
end

on mouseUp(me)
  exit
end

on mouseUpOutSide(me)
  exit
end