on beginSprite(me)
  SP = me.spriteNum
  spriteList = [#ArrowUp:arrowUpSP, #ArrowDown:arrowDownSP, #ScrollerBehind:scrollerBehindSP, #ScrollerUp:scrollerUpSP, #ScrollerMid:scrollerMidSP, #ScrollerDown:scrollerDownSP, #EnterField:enterFieldSP, #trash:trashSP, #Dragger:draggerSP]
  if RelativeSP then
    n = 1
    repeat while n <= count(spriteList)
      if getAt(spriteList, n) <> 0 then
        setAt(spriteList, n, SP + getAt(spriteList, n))
      end if
      n = 1 + n
    end repeat
  end if
  draggerSP = getProp(spriteList, #Dragger)
  trashSP = getProp(spriteList, #trash)
  myMember = sprite(me.spriteNum).undefined.name
  if AutoFind then
    autoFindSprites(me)
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    tempSP = getAt()
    if tempSP <> 0 then
      sendSprite(tempSP, #init, SP)
    end if
  end repeat
  -- UNK_65 3
  member(myMember).scrollTop = 0
  lineNr = 1
  nrOfLines = the number of line in member(myMember).text
  visibleLines = myMember / sprite(0).undefined
  tempScroll = getProp(spriteList, #ScrollerMid)
  if tempScroll <> 0 then
    sendSprite(tempScroll, #SetChildren, [getProp(spriteList, #ScrollerBehind), getProp(spriteList, #ScrollerUp), getProp(spriteList, #ScrollerDown)])
  end if
  exit
end

on endSprite(me)
  member(myMember).text = " "
  exit
end

on setText(me, theText)
  if listp(theText) then
    textList = duplicate(theText)
    sort(textList)
  else
    textList = []
    sort(textList)
    n = 1
    repeat while n <= nrOfLines
      add(textList, theText.line[n])
      n = 1 + n
    end repeat
  end if
  theText = ""
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    aLine = getAt()
    theText = theText & aLine & "\r"
  end repeat
  -- UNK_65 3
  member(myMember).text = theText
  nrOfLines = count(textList)
  member(myMember).scrollTop = 0
  scrollByLine(member(myMember), lineNr - 1)
  tempScroll = getProp(spriteList, #ScrollerMid)
  if tempScroll <> 0 then
    tempNrOf = nrOfLines
    if tempNrOf = 0 then
      tempNrOf = 1
    end if
    percentVisible = 100 * visibleLines / tempNrOf
    if percentVisible > 100 then
      percentVisible = 100
    end if
    tempNrOf = nrOfLines - visibleLines
    if tempNrOf = 0 then
      tempNrOf = 1
    end if
    percentDown = 100 * lineNr - 1 / tempNrOf
    sendSprite(tempScroll, #setScrollInfo, percentDown, percentVisible)
  end if
  exit
end

on autoFindSprites(me)
  tempNecessary = [#ArrowUp, #ArrowDown]
  n = 1
  repeat while n <= 120
    if sprite(n).undefined > 0 then
      tempObjects = sprite(n).undefined
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        bh = getAt()
        tempType = getaProp(bh, #ScrollBHType)
        if symbolp(tempType) then
          deleteOne(tempNecessary, tempType)
          setProp(spriteList, tempType, n)
        end if
      end repeat
      -- UNK_65 3
    end if
    n = 1 + n
  end repeat
  if count(tempNecessary) then
    alert("These scroller sprites were not found:" & string(tempNecessary))
  end if
  exit
end

on scroll(me, theMode, how)
  if theMode = #Relative then
    if lineNr + how > 0 and lineNr + how <= nrOfLines - visibleLines + 1 then
      lineNr = lineNr + how
      scrollByLine(member(myMember), how)
      tempNrOf = nrOfLines - visibleLines
      if tempNrOf = 0 then
        tempNrOf = 1
      end if
      tempPercent = 100 * lineNr - 1 / tempNrOf
      sendSprite(getProp(spriteList, #ScrollerMid), #setScrollInfo, tempPercent)
    end if
  else
    if theMode = #Absolute then
      if how < 1 then
        how = 1
      end if
      diff = how - lineNr
      lineNr = how
      scrollByLine(member(myMember), diff)
    else
      if theMode = #percent then
        how = 1 + integer(how * nrOfLines - visibleLines / 100)
        how = correctLine(me, how)
        diff = how - lineNr
        lineNr = how
        scrollByLine(member(myMember), diff)
      else
        if theMode = #Page then
          how = lineNr + how * visibleLines
          how = correctLine(me, how)
          diff = how - lineNr
          lineNr = how
          tempNrOf = nrOfLines - visibleLines
          if tempNrOf = 0 then
            tempNrOf = 1
          end if
          tempPercent = 100 * lineNr - 1 / tempNrOf
          sendSprite(getProp(spriteList, #ScrollerMid), #setScrollInfo, tempPercent)
          scrollByLine(member(myMember), diff)
        else
          if theMode = #Match then
            add(textList, how)
            how = getPos(textList, how)
            deleteAt(textList, how)
            how = how - 1
            how = correctLine(me, how)
            diff = how - lineNr
            lineNr = how
            tempNrOf = nrOfLines - visibleLines
            if tempNrOf = 0 then
              tempNrOf = 1
            end if
            tempPercent = 100 * lineNr - 1 / tempNrOf
            sendSprite(getProp(spriteList, #ScrollerMid), #setScrollInfo, tempPercent)
            scrollByLine(member(myMember), diff)
          end if
        end if
      end if
    end if
  end if
  exit
end

on deleteLine(me, theLine)
  if stringp(theLine) then
    tempOff = offset(theLine, member(myMember).text)
    if tempOff then
      theLine = the number of line in member(myMember).text.char[1..tempOff]
    else
      exit
    end if
  end if
  if theLine > 0 and theLine <= nrOfLines then
    nrOfLines = nrOfLines - 1
    if theLine <= lineNr then
      lineNr = lineNr - 1
    else
      if lineNr = nrOfLines - visibleLines + 1 then
        lineNr = lineNr - 1
      end if
    end if
    lineNr = correctLine(me, lineNr)
    tempStr = ""
    tempStr = getAt(textList, theLine)
    deleteAt(textList, theLine)
    setText(me, textList)
    resultsFromScroller(gDir, #DeletedLine, tempStr)
  end if
  exit
end

on AddLine(me, theLine)
  tempOff = offset(theLine & "\r", member(myMember).text)
  if tempOff = 0 and count(textList) then
    tempOff = theLine = getAt(textList, count(textList))
  end if
  if tempOff = 0 then
    if nrOfLines = 6 then
      sendSprite(getProp(gDir.spriteList, #MulleHead), #fullAlert)
      exit
    end if
    add(textList, theLine)
    lineNr = getPos(textList, theLine)
    lineNr = correctLine(me, lineNr)
    setText(me, textList)
    resultsFromScroller(gDir, #NewLine, theLine)
  else
    resultsFromScroller(gDir, #ChoseLine, theLine)
  end if
  exit
end

on correctLine(me, theLine)
  if theLine <= 1 then
    theLine = 1
  else
    if theLine > nrOfLines - visibleLines + 1 then
      theLine = nrOfLines - visibleLines + 1
    end if
  end if
  if nrOfLines < visibleLines then
    theLine = 1
  end if
  return(theLine)
  exit
end

on mouseDown(me)
  if nrOfLines = 0 then
    exit
  end if
  tempLine = the mouseV - sprite(SP).top + myMember / sprite(0).undefined
  if tempLine < 1 then
    tempLine = 1
  else
    if tempLine > nrOfLines then
      tempLine = nrOfLines
    end if
  end if
  downOnLine = tempLine
  waitFrames = 3
  if draggerSP then
    member(sprite(draggerSP).undefined).text = getAt(textList, tempLine)
    dragOffset = point(-getAt(member(sprite(draggerSP).undefined).rect, 3) / 2, -25)
    sendSprite(trashSP, #startDrag)
  end if
  exit
end

on mouseUp(me)
  if nrOfLines = 0 then
    exit
  end if
  sendSprite(trashSP, #endDrag)
  tempLine = the mouseV - sprite(SP).top + myMember / sprite(0).undefined
  if tempLine < 1 then
    tempLine = 1
  else
    if tempLine > nrOfLines then
      tempLine = nrOfLines
    end if
  end if
  if the doubleClick then
    if tempLine = downOnLine then
      resultsFromScroller(gDir, #ChoseLine, getAt(textList, tempLine))
    end if
  else
    if tempLine = downOnLine then
      if getProp(spriteList, #EnterField) then
        member(sprite(getProp(spriteList, #EnterField)).undefined).text = getAt(textList, tempLine)
      end if
    end if
  end if
  if draggerSP then
    sprite(draggerSP).locH = -4711
  end if
  downOnLine = 0
  exit
end

on mouseUpOutSide(me)
  if draggerSP then
    if downOnLine then
      sendSprite(trashSP, #scrollThrowHere, SP, getAt(textList, downOnLine))
      sprite(draggerSP).locH = -4711
    end if
  end if
  downOnLine = 0
  exit
end

on exitFrame(me)
  if draggerSP then
    if downOnLine then
      if waitFrames then
        waitFrames = waitFrames - 1
      else
        sprite(draggerSP).undefined = point(the mouseH, the mouseV) + dragOffset
      end if
    end if
  end if
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#AutoFind:[#comment:"Autofind necessary sprites: (might be slow)", #format:#boolean, #default:0], #RelativeSP:[#comment:"Sprite channels are offsets:", #format:#boolean, #default:1], #enterFieldSP:[#comment:"Use these channels (0 = unused):          Enter in field:", #format:#integer, #default:-8], #trashSP:[#comment:"Trash:", #format:#integer, #default:-7], #scrollerBehindSP:[#comment:"Behind scrollbar:", #format:#integer, #default:-6], #scrollerMidSP:[#comment:"Scrollbar stretch:", #format:#integer, #default:-5], #scrollerUpSP:[#comment:"Scrollbar top:", #format:#integer, #default:-4], #scrollerDownSP:[#comment:"Scrollbar bottom:", #format:#integer, #default:-3], #arrowUpSP:[#comment:"Arrow up:", #format:#integer, #default:-2], #arrowDownSP:[#comment:"Arrow down:", #format:#integer, #default:-1], #draggerSP:[#comment:"Drag text:", #format:#integer, #default:1]]
  return(p_list)
  exit
end

on getBehaviorDescription(me)
  str = "This BH is to be assigned to the scrolling field." & "\r" & "The arrows and scrollbars must be in lower (than this ch) numbered channels" & "\r" & "while drag text must be in a higher numbered channel." & "\r" & "\r" & "Results from clicking, entering new lines will be reported" & "\r" & "to a global handler:" & "\r" & "on resultsFromScroller resultType, aString" & "\r" & "\r" & "resultType = #ChoseLine (aString = chosen string)" & "\r" & "resultType = #NewLine (aString = new string)" & "\r" & "resultType = #DeletedLine (aString = deleted string)"
  return(str)
  exit
end