on new(me)
  myMarker = "JustDoIt"
  spriteList = [#CarStart:35]
  tempCar = new(script("DrawCar"), 1)
  drawCar(tempCar, getProp(spriteList, #CarStart))
  tempCar = 0
  return(me)
  exit
end

on init(me)
  testing = 0
  if objectp(gMulleGlobals.world) then
    objId = getEnteredObject(gMulleGlobals.world)
  else
    objId = 0
  end if
  if objId then
    tempObj = new(script("Object"))
    fromList(tempObj, objId)
    stuffToSet = getAt(getSetWhenDone(tempObj, #Cache), 1)
    partNeeded = getAt(getCheckFor(tempObj, #parts), 1)
    mission = getAt(getCheckFor(tempObj, #missions), 1)
    tempObj = 0
  else
    testing = 1
    partNeeded = 172
    stuffToSet = #Lemonade
    mission = 1
  end if
  myMarker = the frame
  if not testing then
    if not getCacheProp(gMulleGlobals.user.car, stuffToSet) = #NoProp or isMissionCompleted(gMulleGlobals.user, mission) then
      myMarker = "Done"
    else
      if findPart(gMulleGlobals.user.car, partNeeded) then
        setCacheProp(gMulleGlobals.user.car, stuffToSet)
        myMarker = "JustDoIt"
      else
        myMarker = "CantDoIt"
      end if
    end if
  end if
  exit
end

on startMovie(me)
  sendSprite(115, #C_Standard)
  go(myMarker)
  exit
end

on kill(me)
  return(0)
  exit
end