on new(me)
  myMarker = "JustDoIt"
  spriteList = [#CarStart:35]
  tempCar = new(script("DrawCar"), 1)
  drawCar(tempCar, getProp(spriteList, #CarStart))
  tempCar = 0
  return(me)
  exit
end

on init(me)
  testing = 0
  if objectp(gMulleGlobals.world) then
    objId = getEnteredObject(gMulleGlobals.world)
  else
    objId = 0
  end if
  if objId then
    tempObj = new(script("Object"))
    fromList(tempObj, objId)
    cacheToSet = getAt(getSetWhenDone(tempObj, #Cache), 1)
    stuffNeeded = getAt(getCheckFor(tempObj, #Cache), 1)
    mission = getAt(getSetWhenDone(tempObj, #missions), 1)
    tempObj = 0
  else
    testing = 1
    cacheToSet = #ExtraTank
    stuffNeeded = #Dog
    mission = 1
  end if
  myMarker = the frame
  if not testing then
    if not getCacheProp(gMulleGlobals.user.car, stuffNeeded) = #NoProp then
      myMarker = "JustDoIt"
      addCompletedMission(gMulleGlobals.user, mission)
      deleteCacheProp(gMulleGlobals.user.car, stuffNeeded)
      setCacheProp(gMulleGlobals.user.car, cacheToSet, 20)
      maxFuel = 120 * getProperty(gMulleGlobals.user.car, #FuelVolume) / 100
      setProp(gMulleGlobals.user.drivingInfo, #fuel, #Full)
    else
      if isMissionCompleted(gMulleGlobals.user, mission) then
        myMarker = "Done"
      else
        myMarker = "CantDoIt"
      end if
    end if
  end if
  exit
end

on startMovie(me)
  sendSprite(115, #C_Standard)
  go(myMarker)
  exit
end

on kill(me)
  return(0)
  exit
end