on new(me, theChild)
  child = theChild
  insideInner = 0
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  sndId = 0
  if getProp(gDir.carDriving.quickCarProps, #FuelConsumption) > 0 or gDir.carDriving.gotElectricEngine then
    OKToEnter = 1
  else
    OKToEnter = 0
  end if
  tempShow = getaProp(child.optionalData, #show)
  if not voidp(tempShow) then
  end if
  exit
end

on step(me, carLoc)
  if sndId then
    if finished(gSound, sndId) then
      sndId = 0
      programControl(gDir.carDriving, 0)
    end if
  else
    tempDiff = carLoc - child.myLoc
    tempH = getAt(tempDiff, 1)
    tempV = getAt(tempDiff, 2)
    hypo = sqrt(tempH * tempH + tempV * tempV)
    if hypo < child.InnerRadius then
      if not insideInner then
        EnterInnerRadius(me)
      end if
    else
      if insideInner then
        ExitInnerRadius(me)
      end if
    end if
  end if
  exit
end

on enterOuterRadius(me)
  exit
end

on ExitOuterRadius(me)
  exit
end

on EnterInnerRadius(me)
  if OKToEnter then
    sndId = play(gSound, getAt(child.sounds, 1), #OPEFFECT)
    setSpeed(gDir.carDriving, 0)
    steer(gDir.carDriving, 0)
    programControl(gDir.carDriving, 1)
    fillErUp(gDir.carDriving)
  end if
  insideInner = 1
  exit
end

on ExitInnerRadius(me)
  insideInner = 0
  exit
end