on new(me, theChild)
  child = theChild
  insideInner = 0
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  exists = 1
  if getProperty(gMulleGlobals.user.car, #Weight) < 20 then
    canDoIt = 1
  else
    canDoIt = 0
  end if
  FrameList = getProp(getFrameList(child), #normal)
  listLen = count(FrameList)
  counter = 0
  sprite(child.SPUnder).name = member(getAt(FrameList, 1))
  sprite(child.SPUnder).position = child.myLoc
  exit
end

on step(me, carLoc)
  counter = counter + 1
  if insideInner and not canDoIt then
    if counter = 9 then
      show(gDir.carDriving, 0)
    else
      if counter > listLen then
        play(gSound, getAt(child.sounds, 2), #EFFECT)
        restoreData(gDir.carDriving)
        carLoc = getShowCoordinate(gDir.carDriving)
        FrameList = getProp(getFrameList(child), #Gone)
        listLen = count(FrameList)
        counter = 1
        if wasCarSoundOn then
          changecarSound(gDir.carDriving.displayObject, 1)
        end if
      end if
    end if
  else
    if counter > listLen then
      counter = 1
    end if
  end if
  sprite(child.SPUnder).name = member(getAt(FrameList, counter))
  temp = checkRadius(gDir.drivingHandlers, me, carLoc, child.myLoc, #both)
  -- UNK_64 0
  if ERROR = #enterOuterRadius then
    enterOuterRadius(me)
  else
    -- UNK_64 0
    if ERROR = #ExitOuterRadius then
      ExitOuterRadius(me)
    else
      -- UNK_64 0
      if ERROR = #EnterInnerRadius then
        EnterInnerRadius(me)
      else
        -- UNK_64 0
        if ERROR = #ExitInnerRadius then
          ExitInnerRadius(me)
        else
          -- UNK_64 0
          if ERROR = #EnterBoth then
            enterOuterRadius(me)
            EnterInnerRadius(me)
          else
            -- UNK_64 0
            if ERROR = #ExitBoth then
              ExitInnerRadius(me)
              ExitOuterRadius(me)
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  exit
end

on enterOuterRadius(me)
  saveData(gDir.carDriving, 1)
  if not exists then
    setSpeed(gDir.carDriving, 0)
    restoreData(gDir.carDriving)
  end if
  exit
end

on ExitOuterRadius(me)
  saveData(gDir.carDriving, #none)
  exit
end

on EnterInnerRadius(me)
  if not canDoIt then
    exists = 0
    programControl(gDir.carDriving, 1)
    sndId = play(gSound, getAt(child.sounds, 1), #EFFECT)
    setSpeed(gDir.carDriving, 0)
    FrameList = getProp(getFrameList(child), #Splash)
    doubleFrames(me)
    listLen = count(FrameList)
    counter = 1
    wasCarSoundOn = gDir.carDriving.displayObject.soundOn
    changecarSound(gDir.carDriving.displayObject, 0)
  else
    medalId = 6
    if not getMedal(gMulleGlobals.user.car, medalId) then
      addMedal(gMulleGlobals.user.car, medalId)
      sendSprite(getProp(gDir.spriteList, #medal), #Blink, medalId)
    end if
  end if
  exit
end

on ExitInnerRadius(me)
  programControl(gDir.carDriving, 0)
  show(gDir.carDriving, 1)
  exit
end

on doubleFrames(me)
  nr = 6
  n = 1
  repeat while 1
    x = 1
    repeat while x <= nr
      addAt(FrameList, n, getAt(FrameList, n))
      x = 1 + x
    end repeat
    n = n + nr + 2
    if n > count(FrameList) then
    else
    end if
  end repeat
  exit
end